﻿Imports System.Math
Imports System.Drawing
Imports System.Windows.Forms
Imports System.Threading


Public Class frmDock

    Private Sub subDockLoad(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        On Error Resume Next
        UpDnLocX.Value = tmcDock.X
        UpDnLocY.Value = tmcDock.Y
        updnOrientation.Value = intDockOrientation
        UpDownPCTrigger.Value = intDockTriggerPC
        txtBotBatteryTrigger.Text = sngDockTriggerBot.ToString
        chkBackIn.Checked = boolDockBackIn
    End Sub



    Private Sub UpDnLocX_ValueChanged(sender As System.Object, e As System.EventArgs) Handles UpDnLocX.ValueChanged
        On Error Resume Next
        boolSettingsChanged = True
        tmcDock.X = UpDnLocX.Value
        tmcDock = ftnCheckMapArrayLimits(tmcDock)
        UpDnLocX.Value = tmcDock.X
    End Sub


    Private Sub UpDnLocY_ValueChanged(sender As System.Object, e As System.EventArgs) Handles UpDnLocY.ValueChanged
        On Error Resume Next
        tmcDock.Y = UpDnLocY.Value
        tmcDock = ftnCheckMapArrayLimits(tmcDock)
        UpDnLocY.Value = tmcDock.Y
        boolSettingsChanged = True
    End Sub


    Private Sub updnOrientation_ValueChanged(sender As System.Object, e As System.EventArgs) Handles updnOrientation.ValueChanged
        On Error Resume Next
        intDockOrientation = updnOrientation.Value
        boolSettingsChanged = True
    End Sub


    Private Sub ChkBackIn_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles chkBackIn.CheckedChanged
        On Error Resume Next
        boolDockBackIn = chkBackIn.Checked()
        boolSettingsChanged = True
    End Sub

    Private Sub UpDownPCTrigger_ValueChanged(sender As System.Object, e As System.EventArgs) Handles UpDownPCTrigger.ValueChanged
        On Error Resume Next
        intDockTriggerPC = UpDownPCTrigger.Value
        boolSettingsChanged = True
    End Sub

    Private Sub txtBotBatteryTrigger_TextChanged(sender As System.Object, e As System.EventArgs) Handles txtBotBatteryTrigger.TextChanged
        On Error Resume Next
        If (txtBotBatteryTrigger.Text <> "") Then sngDockTriggerBot = Val(txtBotBatteryTrigger.Text)
1:      boolSettingsChanged = True
    End Sub


    Private Sub OK_Button_Click(sender As System.Object, e As System.EventArgs) Handles OK_Button.Click
        Me.DialogResult = System.Windows.Forms.DialogResult.OK
        Me.Visible = False
        Me.Close()
    End Sub

    Private Sub Cancel_Button_Click(sender As System.Object, e As System.EventArgs) Handles Cancel_Button.Click
        Me.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.Close()
        frmGotABotTop.mnuLoadSettings_Click(sender, e)
    End Sub


    Private Sub Exit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Me.FormClosing
        Me.Visible = False
    End Sub


    '*****************************************************************************************************************************


    Public Sub subDock()
        Try
            Thread.CurrentThread.Name = "threadDock"
            If Not ftnCheckForStopMode() Then
                boolDock = True
                ftnSendCommand("play phraseA 'Docking.'")
                Dim boolGoodLocalization As Boolean = False
                tbpBotPose = ftnLocalize_Top(tbpBotPose, boolGoodLocalization)
                subDriveToPreDock()
                tbpBotPose = ftnLocalize_Top(tbpBotPose, boolGoodLocalization)
                Do
                    subPreDockAdjust()  ' Want accurate positioning before attempting Dock contact
                    subCheckForPause()
                    boolDocked = ftnDockMakeContact()
                    If Not boolDocked Then
                        subUnDock(tbpBotPose)
                        tbpBotPose = ftnLocalize_Top(tbpBotPose, boolGoodLocalization)
                        If ftnIAmLost(tbpBotPose) Then tbpBotPose = ftnLostRecoveryTop(tbpBotPose)
                    End If
                Loop Until boolDocked Or boolStop Or ftnIAmLost(tbpBotPose) Or boolShutDown Or Not boolDock
                If boolDocked And Not boolStop And Not boolShutDown Then
                    frmDebug.subWriteFinishedMessage()
                    strStatusDriving = "DOCKED"
                    ftnSendCommand("play phrase 'Docking Completed.'")
                    boolDock = False
                    intMovementsSinceLocalization = 0
                    subInitParticles(tbpBotPose, intNumberOfParticles)
                    boolDocked = True
                    Dim tbpDockedPose As typeBotPose = tbpBotPose
                    tbpDockedPose.Location = tmcDock
                    ftnSetMoveInfo(TypeOfMove.HALT, tbpDockedPose, tbpDockedPose, False)
                    tbpBotPose = tbpDockedPose
                    tbpTargetPosePlanned = tbpDockedPose
                ElseIf ftnIAmLost(tbpBotPose) Then
                    tbpBotPose = ftnLocalize_Top(tbpBotPose, boolGoodLocalization)
                ElseIf boolStop Then
                    boolDocked = False
                    boolDock = False
                Else
                    boolDocked = False
                    strStatusDriving = "DOCKING FAILED"
                    tbpBotPose = ftnLocalize_Top(tbpBotPose, boolGoodLocalization)
                    ftnSendCommand("play phraseA 'Docking Failed.'")
                    boolDock = False
                End If
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in subDock " & ex.ToString)
        End Try
    End Sub

    Public Sub subUnDock(ByRef tbpEstimatedPose As typeBotPose)
        Try
            If Not boolStop And Not boolPause And (ftnLocationsEqual(tbpBotPose.Location, tmcDock) Or boolDocked) And Not boolShutDown Then
                frmDebug.subWriteLogs("    ")
                frmDebug.subWriteLogs("    ")
                frmDebug.subWriteLogs("    ")
                frmDebug.subWriteLogs(Now() & "    --------------------------  UnDocking.  ----------------------- ")
                strStatusDriving = "UnDocking"
                boolPoseConfirmedAfterCollision = True
                Dim tbpTargetPose As typeBotPose = tbpEstimatedPose
                If boolDockBackIn Then
                    tbpTargetPose.Location = ftnLocationFromEstimatedPose(tbpBotPose, 0, 6)
                Else
                    tbpTargetPose.Location = ftnLocationFromEstimatedPose(tbpBotPose, 180, 4 + sngBotRadius)
                End If
                For I As Integer = 1 To 4
                    ftnSendCommand("play phrase prompt")
                    subWait(200)
                Next I
                tbpEstimatedPose = ftnBotFwd(tbpEstimatedPose, tbpTargetPose)  '  
                intMovementsSinceLocalization = 99  'Force Localization
                tbpBotPose = ftnPostMoveLocalizeAndPath(tbpTargetPose, TypeOfMove.FWD, tbpTargetPose)
                boolDocked = False
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in subUnDock " & ex.ToString)
        End Try
    End Sub

    Function ftnGetBatteryPreDock() As Single
        On Error Resume Next
        strStatusDriving = "Wait For Battery Stabilzation"
        If Not boolSimulatedMovement Then subWait(10000)
        ftnSendCommand("battery")
        ftnSendCommand("battery")
        ftnGetBatteryPreDock = sngBotBatteryVoltage
        If boolDebugDock Then _
            frmDebug.subWriteLogs(Now() & " >DOCKING CHECK: ftnGetBatteryPreDock: " & ftnGetBatteryPreDock)
    End Function

    Sub subDriveToPreDock()
        On Error Resume Next
        tmcDestination = ftnPreDockLocation()
        ftnDriveToDestination_Top(tbpBotPose, tmcDestination)
        Dim boolGoodLocalization As Boolean = False
        tbpBotPose = ftnLocalize_Top(tbpBotPose, boolGoodLocalization)
    End Sub

    Sub subPreDockAdjust()
        ' Goto preDock Location
        ' Turn towards Dock 
        Try  ' Fine positioning before final docking maneuvers. Called when Bot has arrived near its pre docking position (approx 8-10" in front of dock)
            Dim intPreDockedOientation As Short = intDockOrientation
            If boolDockBackIn Then intPreDockedOientation = ftnConvertTo360(intPreDockedOientation + 180)
            frmDebug.subWriteLogs("    ")
            frmDebug.subWriteLogs(Now() & "    --------------------------  PreDocking Fine Adjustments  ----------------------- ")
            strStatusDriving = "PreDock Adjustment "
            Dim tbpTargetPose As typeBotPose = tbpBotPose
            Dim intTries As Short = 0
            While (ftnDistanceToPreDock() > 2) And (intTries < 3) And Not boolStop And Not boolShutDown ' GOTO preDock Location and turn towards dock
                subGoToPreDock()
                tbpTargetPose.Location = tmcDock
                If (Abs(ftnAngleDifference(intPreDockedOientation, tbpBotPose.Orientation)) > 2) Then tbpBotPose = ftnBotTurn(tbpBotPose, False, tbpTargetPose) ' turn towards Dock 
                tbpBotPose = ftnLocalize_Top(tbpBotPose, False)
                intDrivingSequenceNumber += 1
                subCheckForPause()
                intTries += 1
            End While
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in subPreDockAdjust " & ex.ToString)
        End Try
    End Sub

    Function ftnDistanceToPreDock() As Integer
        Try
            Dim tmcPreDock As typeMapCoordinate = ftnPreDockLocation()
            ftnDistanceToPreDock = Max(Abs(tbpBotPose.Location.X - tmcPreDock.X), Abs(tbpBotPose.Location.Y - tmcPreDock.Y))
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in ftnDistanceToPreDock " & ex.ToString)
        End Try
    End Function

    Sub subGoToPreDock()
        Try
            Dim intTries As Short = 0
            Dim tbpTargetPose As typeBotPose = tbpBotPose
            tbpTargetPose.Location = ftnPreDockLocation()
            While (ftnDistanceToPreDock() > 2) And (intTries < 3) And Not boolStop And Not boolShutDown ' GOTO preDock Location
                ftnTurnTowardsPreDock()
                tbpBotPose = ftnBotFwd(tbpBotPose, tbpTargetPose)  ' Goto preDock Location
                tbpBotPose = ftnLocalize_Top(tbpBotPose, False)
            End While
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in subGoToPreDock " & ex.ToString)
        End Try
    End Sub

    Function ftnTurnTowardsPreDock() As Boolean
        Try
            ftnTurnTowardsPreDock = False
            If Not boolStop And Not boolPause And Not boolShutDown Then
                Dim tbpTargetPose As typeBotPose
                tbpTargetPose.Location = ftnPreDockLocation()
                tbpTargetPose.Orientation = ftnP1ToP2Angle(tbpBotPose.Location, ftnPreDockLocation())
                Dim intTries As Short = 0
                While (Abs(ftnAngleDifference(tbpTargetPose.Orientation, tbpBotPose.Orientation)) > 3) And (intTries < 2) And Not boolStop And Not boolShutDown
                    tbpBotPose = ftnBotTurn(tbpBotPose, False, tbpTargetPose)
                    tbpBotPose = ftnLocalize_Top(tbpBotPose, True)
                    tbpTargetPose.Orientation = ftnP1ToP2Angle(tbpBotPose.Location, ftnPreDockLocation())
                    subCheckForPause()
                    intTries += 1
                End While
                ftnTurnTowardsPreDock = (Abs(ftnAngleDifference(intDockOrientation, tbpBotPose.Orientation)) <= 3)
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in ftnTurnTowardsPreDock " & ex.ToString)
        End Try
    End Function

    Function ftnDockMakeContact() As Boolean  ' returns true if docking successful
        ftnDockMakeContact = False
        Try ' Final docking maneuvers - Line up charging contacts with Dock and then drive to Dock
            If Not boolStop And Not boolShutDown And Not boolPause Then
                frmDebug.subWriteLogs("    ")
                frmDebug.subWriteLogs("    ")
                frmDebug.subWriteLogs("    ")
                frmDebug.subWriteLogs(Now() & "    --------  Final Docking Sequence  --------- ")
                Dim intTries As Short = 0
                While Not ftnDockMakeContact And (intTries < 2) And Not boolStop And Not boolShutDown
                    ftnDockMakeContact = ftnTurnToDockingOrientation()
                    subCheckForPause()
                    intTries += 1
                End While
                If ftnDockMakeContact Then ftnDockMakeContact = ftnDockMakeContactFinalMovement(tbpBotPose)
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in ftnDockMakeContact " & ex.ToString)
        End Try
    End Function

    Function ftnTurnToDockingOrientation() As Boolean
        Try
            ftnTurnToDockingOrientation = False
            If Not boolStop And Not boolPause And Not boolShutDown Then
                Dim tbpTargetPose As typeBotPose
                Dim intTries As Short = 0
                While (Abs(ftnAngleDifference(intDockOrientation, tbpBotPose.Orientation)) > 3) And (intTries < 2) And Not boolStop And Not boolShutDown
                    intDrivingSequenceNumber += 1
                    tbpTargetPose = tbpBotPose
                    tbpTargetPose.Orientation = intDockOrientation
                    strStatusDriving = "Turn Towards Dock"
                    frmDebug.subWriteLogs(Now() & "    --------  Turn Charging Contacts Towards Dock  --------- ")
                    tbpBotPose = ftnBotTurn(tbpBotPose, False, tbpTargetPose)
                    If ftnScannerEnabled() Or Not boolDockBackIn Then tbpBotPose = ftnLocalize_Top(tbpBotPose, True)
                    subCheckForPause()
                    intTries += 1
                End While
                ftnTurnToDockingOrientation = (Abs(ftnAngleDifference(intDockOrientation, tbpBotPose.Orientation)) <= 3)
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in ftnTurnToDockingOrientation " & ex.ToString)
        End Try
    End Function

    Function ftnDockMakeContactFinalMovement(ByRef tbpEstimatedPose As typeBotPose) As Boolean
        ' Make contact with Dock and determine success by measuring battery voltage
        Try
            ftnDockMakeContactFinalMovement = False
            If Not boolStop And Not boolPause And Not boolShutDown Then
                Dim sngBotLinearVelocityTemp As Single = sngBotLinearVelocity
                Dim sngBotLinearAccelerationTemp As Single = sngBotLinearAcceleration
                Dim intPowerMovingTemp As Integer = intPowerMoving
                Dim intPowerStoppedTemp As Integer = intPowerStopped
                Dim boolEnableCourseCorrectionTemp As Boolean = boolEnableCourseCorrection
                Dim tbpTargetPose As typeBotPose = tbpEstimatedPose
                sngBotLinearVelocity = Min(sngBotLinearVelocity, 10) ' slower speed so we dont ram the dock
                intPowerMoving = intPowerMoving * 0.6  ' lower power so we dont ram the dock
                intPowerStopped = Max(intPowerStopped, intPowerStopped) ' 
                sngBotLinearAcceleration = Max(sngBotLinearAcceleration, 25)
                boolEnableCourseCorrection = False
                intDrivingSequenceNumber += 1
                If boolDockBackIn Then  ' Dock contacts are accessed via the rear of the robot
                    If boolURGConnected Then
                        tbpTargetPose.Location = ftnLocationFromEstimatedPose(tbpBotPose, 180, ftnDistanceBetweenLocations(tbpBotPose.Location, tmcDock) + 3)
                    Else
                        tbpTargetPose.Location = ftnLocationFromEstimatedPose(tbpBotPose, 180, ftnDistanceBetweenLocations(tbpBotPose.Location, tmcDock) + 5)
                    End If
                Else
                    If boolURGConnected Then
                        tbpTargetPose.Location = ftnLocationFromEstimatedPose(tbpBotPose, 0, ftnDistanceBetweenLocations(tbpBotPose.Location, tmcDock) + 3)
                    Else
                        tbpTargetPose.Location = ftnLocationFromEstimatedPose(tbpBotPose, 0, ftnDistanceBetweenLocations(tbpBotPose.Location, tmcDock) + 5)
                    End If
                End If
                Dim boolCheckLaptopCharge As Boolean = Not (SystemInformation.PowerStatus.BatteryChargeStatus = BatteryChargeStatus.Charging)
                Dim sngBotBatteryPreDock As Single = ftnGetBatteryPreDock()  '  Bot's Battery voltage used to determine docking success
                frmDebug.subWriteLogs(Now() & "    --------  Make Contact With Dock  --------- ")
                tbpBotPose = ftnBotFwd(tbpEstimatedPose, tbpTargetPose)  ' Make contact
                If boolSimulatedMovement Then
                    ftnDockMakeContactFinalMovement = True
                    tbpBotPose.Location = tbpTargetPose.Location
                ElseIf Not boolStop And Not boolShutDown And Not boolPause Then
                    strStatusDriving = "Wait For Battery To Charge"
                    If Not boolSimulatedMovement Then subWait(4000) ' wait for battery to charge a bit
                    Dim i As Integer = 0
                    While (i < 12) And Not ftnDockMakeContactFinalMovement And Not boolShutDown And Not boolStop And Not boolPause
                        i += 1
                        subWait(1000)
                        ftnDockMakeContactFinalMovement = ftnDocked(sngBotBatteryPreDock, boolCheckLaptopCharge)
                        If boolDebugDock Then
                            frmDebug.subWriteLogs(Now() & " >DOCKING CHECK: sngBotBatteryPreDock: " & sngBotBatteryPreDock & "    sngBotBatteryVoltage: " & sngBotBatteryVoltage)
                            frmDebug.subWriteLogs(Now() & " >            boolCheckLaptopCharge : " & boolCheckLaptopCharge & ";   Status: " & SystemInformation.PowerStatus.BatteryChargeStatus.ToString)
                        End If
                    End While
                    tbpBotPose.Location = tbpTargetPose.Location
                    If ftnDockMakeContactFinalMovement Then
                        frmDebug.subWriteLogs(Now() & " >DOCKED:  sngBotBatteryPreDock: " & sngBotBatteryPreDock & "    sngBotBatteryVoltage: " & sngBotBatteryVoltage)
                        frmDebug.subWriteLogs(Now() & " >            boolCheckLaptopCharge : " & boolCheckLaptopCharge & ";   Status: " & SystemInformation.PowerStatus.BatteryChargeStatus.ToString)
                    Else
                        frmDebug.subWriteLogs(Now() & " >DOCKING FAILED: sngBotBatteryPreDock: " & sngBotBatteryPreDock & "    sngBotBatteryVoltage: " & sngBotBatteryVoltage)
                        frmDebug.subWriteLogs(Now() & " >            boolCheckLaptopCharge : " & boolCheckLaptopCharge & ";   Status: " & SystemInformation.PowerStatus.BatteryChargeStatus.ToString)
                        tbpBotPose.Location = tmcDock
                        tbpBotPose.LocationUncertainty.X += 3
                        tbpBotPose.LocationUncertainty.Y += 3
                        tbpBotPose.OrientationUncertainty += 8
                        subUnDock(tbpBotPose)
                    End If
                End If
                sngBotLinearAcceleration = sngBotLinearAccelerationTemp
                sngBotLinearVelocity = sngBotLinearVelocityTemp
                intPowerMoving = intPowerMovingTemp
                intPowerStopped = intPowerStoppedTemp
                boolEnableCourseCorrection = boolEnableCourseCorrectionTemp
                If ftnDockMakeContactFinalMovement Then
                    ftnSetMoveInfo(TypeOfMove.HALT, tbpBotPose, tbpBotPose, True)
                    ftnBotStop(tbpBotPose, tbpBotPose)
                End If
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in ftnDockMakeContactFinalMovement " & ex.ToString)
        End Try
    End Function

    Public Function ftnPreDockLocation() As typeMapCoordinate
        Try
            Dim sngDistanceFromDock As Single
            If boolURGConnected Then
                sngDistanceFromDock = 5  ' A URG has a short minimum distance for measurement and excellent localizing abilities
            ElseIf boolKinectConnected Then
                sngDistanceFromDock = 10 ' Kinect requires a long minimum distance for measurement
            Else
                sngDistanceFromDock = 8
            End If
            If Not boolDockBackIn Then sngDistanceFromDock = -sngDistanceFromDock
            ftnPreDockLocation = ftnLocationFromLocation(tmcDock, intDockOrientation, sngDistanceFromDock)
            If ftnInWall(ftnPreDockLocation) Then ftnPreDockLocation = ftnLocationFromLocation(tmcDock, intDockOrientation, sngDistanceFromDock / 2)
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in ftnPreDockLocation")
        End Try
    End Function

    Function ftnDockContactLocation() As typeMapCoordinate
        If boolDockBackIn Then
            ftnDockContactLocation = ftnLocationFromLocation(tmcDock, intDockOrientation, -sngBotRadius)
        Else
            ftnDockContactLocation = ftnLocationFromLocation(tmcDock, intDockOrientation, +sngBotRadius)
        End If
    End Function


    Function ftnDocked(ByVal sngBotBatteryPreDock As Single, ByRef boolCheckLaptopCharge As Boolean) As Boolean  ' True if charging
        Try
            ftnDocked = False
            If boolSimulatedMovement Then
                ftnDocked = True
            ElseIf boolCheckLaptopCharge And (SystemInformation.PowerStatus.BatteryChargeStatus = BatteryChargeStatus.Charging) Or CBool(InStr(SystemInformation.PowerStatus.BatteryChargeStatus.ToString, "Charging")) Then  ' 
                ftnDocked = True
            ElseIf Not boolStop And Not boolShutDown Then
                ftnSendCommand("battery")
                ftnDocked = (sngBotBatteryVoltage > (sngBotBatteryPreDock * 1.015)) ' Bot battery charging
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in ftnDocked " & ex.ToString)
        End Try
    End Function


End Class