﻿Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Drawing
Imports System.Linq
Imports System.Text
Imports System.Windows.Forms

Imports Emgu.CV.UI
Imports Emgu.CV
Imports Emgu.CV.Structure
Imports Emgu.CV.CvEnum

Imports System.IO
Imports System.Drawing.Imaging
Imports System.Xml
Imports System.Threading


Public Class frmFaceTraining


    ''For aquiring 10 images in a row
    Public resultImages As New List(Of Image(Of Gray, Byte))()
    Private intResultsListPos As Integer = 0
    Public intNumFacesToAquire As Integer = 10
    Public boolRECORD As Boolean = False

    'Saving Jpg
    Private ImagestoWrite As New List(Of Image(Of Gray, Byte))()
    Private ENC_Parameters As New EncoderParameters(1)
    Private ENC As New EncoderParameter(System.Drawing.Imaging.Encoder.Quality, 100)
    Private Image_Encoder_JPG As ImageCodecInfo

    'Saving XAML Data file
    Private xmlDocumnt As New XmlDocument()

    Public Sub subFacetrainLoad(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Try
            Me.Visible = boolEnableFaceRecognition Or boolEnableVideo
            subInitializeComponent()
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in subFacetrainLoad " & ex.ToString)
        End Try
    End Sub


    Private Sub subInitializeComponent()

    End Sub

    Public Sub subStartTraining_Form()
        'ENC_Parameters.Param(0) = ENC
        'Image_Encoder_JPG = GetEncoder(ImageFormat.Jpeg)
        Me.Show()
    End Sub


    Private Sub Training_Form_FormClosing(sender As Object, e As FormClosingEventArgs) Handles Me.FormClosing
        frmVideo.retrain()
    End Sub





    Public Function ftnSaveTrainingData(face_data As Image) As Boolean    'Saving The Data
        Try
            Dim randFileNumber As New Random()
            Dim boolFileCreate As Boolean = True
            Dim facename As String = "face_" + NAME_PERSON.Text + "_" + randFileNumber.[Next]().ToString() + ".jpg"
            If Not Directory.Exists(Application.StartupPath + "/TrainedFaces/") Then _
                Directory.CreateDirectory(Application.StartupPath + "/TrainedFaces/")
            While boolFileCreate
                If Not File.Exists(Application.StartupPath + "/TrainedFaces/facename") Then
                    boolFileCreate = False
                Else
                    facename = "face_" + NAME_PERSON.Text + "_" + randFileNumber.[Next]().ToString() + ".jpg"
                End If
            End While


            If Directory.Exists(Application.StartupPath + "/TrainedFaces/") Then
                face_data.Save(Convert.ToString(Application.StartupPath + "/TrainedFaces/") & facename, ImageFormat.Jpeg)
            Else
                Directory.CreateDirectory(Application.StartupPath + "/TrainedFaces/")
                face_data.Save(Convert.ToString(Application.StartupPath + "/TrainedFaces/") & facename, ImageFormat.Jpeg)
            End If
            If File.Exists(Application.StartupPath + "/TrainedFaces/TrainedLabels.xml") Then
                Dim loading As Boolean = True
                While loading
                    Try
                        xmlDocumnt.Load(Application.StartupPath + "/TrainedFaces/TrainedLabels.xml")
                        loading = False
                    Catch
                        xmlDocumnt = Nothing
                        xmlDocumnt = New XmlDocument()
                        Thread.Sleep(10)
                    End Try
                End While

                'Get the root element
                Dim root As XmlElement = xmlDocumnt.DocumentElement

                Dim face_D As XmlElement = xmlDocumnt.CreateElement("FACE")
                Dim name_D As XmlElement = xmlDocumnt.CreateElement("NAME")
                Dim file_D As XmlElement = xmlDocumnt.CreateElement("FILE")

                name_D.InnerText = NAME_PERSON.Text
                file_D.InnerText = facename

                face_D.AppendChild(name_D)
                face_D.AppendChild(file_D)
                root.AppendChild(face_D)

                xmlDocumnt.Save(Application.StartupPath + "/TrainedFaces/TrainedLabels.xml")
            Else
                Dim FS_Face As FileStream = File.OpenWrite(Application.StartupPath + "/TrainedFaces/TrainedLabels.xml")
                Using writer As XmlWriter = XmlWriter.Create(FS_Face)
                    writer.WriteStartDocument()
                    writer.WriteStartElement("Faces_For_Training")

                    writer.WriteStartElement("FACE")
                    writer.WriteElementString("NAME", NAME_PERSON.Text)
                    writer.WriteElementString("FILE", facename)
                    writer.WriteEndElement()

                    writer.WriteEndElement()
                    writer.WriteEndDocument()
                End Using
                FS_Face.Close()
            End If

            Return True
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in ftnSaveTrainingData " & ex.ToString)
            Return False
        End Try

    End Function

    Private Function GetEncoder(format As ImageFormat) As ImageCodecInfo
        Dim codecs As ImageCodecInfo() = ImageCodecInfo.GetImageDecoders()
        For Each codec As ImageCodecInfo In codecs
            If codec.FormatID = format.Guid Then
                Return codec
            End If
        Next
        Return Nothing
    End Function

    'Delete all the old training data by simply deleting the folder
    Private Sub Delete_Data_BTN_Click_1(sender As Object, e As EventArgs) Handles btnDeleteData.Click
        If Directory.Exists(Application.StartupPath + "/TrainedFaces/") Then
            Directory.Delete(Application.StartupPath + "/TrainedFaces/", True)
            Directory.CreateDirectory(Application.StartupPath + "/TrainedFaces/")
        End If
    End Sub


    Private Sub ADD_BTN_Click(sender As Object, e As EventArgs) Handles btnAddImage.Click
        Try
            If resultImages.Count = intNumFacesToAquire Then
                If Not ftnSaveTrainingData(picbxFaceTraining.Image) Then
                    MessageBox.Show("Error", "Error in saving file info. Training data not saved", MessageBoxButtons.OK, MessageBoxIcon.[Error])
                End If
            Else
                If Not ftnSaveTrainingData(picbxFaceTraining.Image) Then
                    MessageBox.Show("Error", "Error in saving file info. Training data not saved", MessageBoxButtons.OK, MessageBoxIcon.[Error])
                End If
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in ADD_BTN_Click " & ex.ToString)
        End Try
    End Sub

    Private Sub Single_btn_Click(sender As Object, e As EventArgs) Handles btnSingle.Click
        boolRECORD = False
        resultImages.Clear()
        btnNextImage.Visible = False
        btnPrevImage.Visible = False
        btnSingle.Visible = False
        lblCount.Text = "Count: 0"
        lblCount.Visible = True
    End Sub

    Public Sub boolRECORD_BTN_Click(sender As Object, e As EventArgs) Handles btnRecord10Faces.Click
        If boolRECORD Then
            boolRECORD = False
        Else
            If resultImages.Count = 10 Then resultImages.Clear()
            boolRECORD = True
            'btnAddImage.Enabled = False
        End If

    End Sub
    Private Sub NEXT_BTN_Click(sender As Object, e As EventArgs) Handles btnNextImage.Click

        If intResultsListPos < resultImages.Count - 1 Then
            picbxFaceTraining.Image = resultImages(intResultsListPos).ToBitmap()
            intResultsListPos += 1
            btnPrevImage.Enabled = True
        Else
            btnNextImage.Enabled = False
        End If
    End Sub

    Private Sub PREV_btn_Click(sender As Object, e As EventArgs) Handles btnPrevImage.Click
        If intResultsListPos > 0 Then
            intResultsListPos -= 1
            picbxFaceTraining.Image = resultImages(intResultsListPos).ToBitmap()
            btnNextImage.Enabled = True
        Else
            btnPrevImage.Enabled = False
        End If
    End Sub

    Public Sub ADD_ALL_Click(sender As Object, e As EventArgs) Handles btnAddAll.Click
        For i As Integer = 0 To resultImages.Count - 1
            picbxFaceTraining.Image = resultImages(i).ToBitmap()
            If Not ftnSaveTrainingData(picbxFaceTraining.Image) Then
                MessageBox.Show("Error", "Error in saving file info. Training data not saved", MessageBoxButtons.OK, MessageBoxIcon.[Error])
            End If
            Thread.Sleep(100)
        Next
        btnAddAll.Visible = False
    End Sub

End Class