﻿

'=============================================================================================================================================================

' NOTE:  This project requires that drivers for Phidgets (http://www.phidgets.com/docs/OS_-_Windows#Quick_Downloads) 
' and Kinect (http://www.microsoft.com/en-us/kinectforwindows/develop/) be installed on the PC

' Rcc Port  = 9000
' API_Port = 9100
' 2nd API_Port = 9400
' GotAGlyph Port = 9050
' RoboRealm_Port = 6060

'=============================================================================================================================================================


Imports System.Net
Imports System.Drawing
Imports System.Threading
Imports System.Text
Imports System.Math
Imports System.Windows.Forms

Public Class frmGotABotTop

    Dim boolMouseDown As Boolean = False
    Dim boolSettingsChangedTemp As Boolean = False
    Dim boolPlaceBot As Boolean = False
    Dim boolPlaceDestination As Boolean = False

  

    Private Sub subGotABotLoad(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Try
            Thread.CurrentThread.Name = "threadGotABotTop"
            Dim infoReader As System.IO.FileInfo = My.Computer.FileSystem.GetFileInfo("GotABot_Log.txt")
            If (Dir("GotABot_Log.txt") <> "") Then
                If infoReader.Length > 10000000 Then frmDebug.subWriteLogs(" GotABot_Log.txt is growing excessively large.  Please start a new log file")
            End If

            LoadSettings("GotABot_Settings.xml") ' load settings
            boolEnableFaceRecognition = False
            subOpenMap("GotABot_Map.bmp")
            Me.Text = "GOTABOT       (Version " & My.Application.Info.Version.ToString(3) & ")"
            Me.StatusDriving.ForeColor = Color.Black
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in subGotABotLoad " & ex.ToString)
        End Try
    End Sub


    Sub subInitialize(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Me.Shown
        Try
            boolStop = True
            'CheckForIllegalCrossThreadCalls = True
            subLoadMap()
            ftnSetMoveInfo(TypeOfMove.HALT, tbpBotPose, tbpBotPose, False)
            frmDebug.subWriteLogs("")
            frmDebug.subWriteLogs(Now() & " ************************ GOTABOT       (Version " & My.Application.Info.Version.ToString(3) & ")  ********************************")
            frmDebug.subWriteLogs("")
            For intRangerNumber As Short = 0 To UBound(trfRangeFinders)
                trfRangeFinders(intRangerNumber).sngMaxRange = constIR_MaxRange
            Next
            If (ticCameraResolution.X = 0) Then
                ticCameraResolution.X = 640
                ticCameraResolution.Y = 480
            End If
            boolRangersAreEnabled = frmRangeFinder.ftnRangersAreEnabled()
            AboutBox1.LabelVer.Text = "Version " & My.Application.Info.Version.ToString
            subConfigureMenu(sender, e)
            tmiMoveInfo.timeMoveCommandSent = Now()
            frmCompass.subCompassLoad(sender, e)
            If boolEnableGotAGlyph And (ProcessesRunning("GotAGlyph") = 0) Then Process.Start(Environment.CurrentDirectory & "\GotAGlyph\GotAGlyph.exe", "")
            subStartThreads()
            ftnURGInitializeTop()
            If Not boolURGConnected Then ftnKinectInitializeTop()
            subRecalculateVariables()
            subConvertMapToArray()
            subInitParticles(tbpBotPose, intNumberOfParticles)
            boolSettingsChanged = False
            subEndImageRecognition()
            timerWatchDog.Interval = 60000
            If boolHeroSelected Then
                subHeroConfigure()
            ElseIf mnuER1Direct.Checked Then
                ftnER1_SerialConfig()
            End If
            If boolEnableGotAGlyph And (ProcessesRunning("GotAGlyph") = 0) Then _
                Process.Start(Environment.CurrentDirectory & "\GotAGlyph\GotAGlyph.exe", "")
            subInitializeDrivingControl(tbpBotPose)
            ftnGotAGlyph_Communicate("glyph", ">", 500)
            ftnLRCC_Communicate("events" & vbCrLf, "OK", 1000)
            subStartSpeechRecognition()
            strStatusDriving = "Checking Bot Coms "
            ftnSendCommand("stop")
            ftnSendCommand("stop")
            ftnSendCommand("stop")
            tmiMoveInfo.boolMoveCommandInProgress = False
            ftnSendCommand("battery")
            strStatusDriving = "Starting Video & Arm "
            If boolEnableVideo Then frmVideo.subVideoStart()
            If boolEnableArm Then classArm.frmGotAnArm_Load(sender, e)
            subGuiUpdate(sender, e)
            boolStop = True
            boolEnableCurveMotion = boolER1Selected
            boolEnableCourseCorrection = boolER1Selected And (boolKinectConnected Or boolURGConnected)
            boolEnableLocalizationWhileMoving = (boolKinectConnected Or boolURGConnected)
            timerWatchDog.Enabled = True
            strStatusDriving = "Waiting for command "
            ftnSendCommand("play phraseA 'Ready'")
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in subInitialize " & ex.ToString)
        End Try
    End Sub


    Dim boolDebugGuiUpdated As Boolean = False
    Dim tbpPreviousPose As typeBotPose
    Sub subGuiUpdate(sender As Object, e As EventArgs) Handles timerGUI.Tick
        Try
            If timerGUI.Enabled Then
                timerGUI.Enabled = False
                boolDebugGuiUpdated = True
                subButtonGui()
                If Not ftnPosesEqual(tbpBotPose, tbpPreviousPose) Then _
                        subEraseOldBotLocation(tbpPreviousPose.Location)
                tbpPreviousPose = tbpBotPose
                subPathGUI()
                subVectorGUI()
                subLmGUI()
                If boolDock Then subDrawSmallCircle(tmcDock, Color.Purple)
                subDrawBot(tbpBotPose)
                subRBPFGUI()
                If (boolPlaceDestination And boolMouseDown) Then subDrawDestination(tmcDestination)
                subCollisionGUI()
                subUpdateAllText(tbpBotPose)
                timerGUI.Enabled = True
            End If
        Catch ex As Exception
            timerGUI.Enabled = True
            frmDebug.subWriteLogs(" EXCEPTION in subGuiUpdate " & ex.ToString)
        End Try
    End Sub

    Sub subButtonGui()
        Try
            If boolPlaceBot Then
                Me.picBot.BorderStyle = FormBorderStyle.Fixed3D
            Else
                Me.picBot.BorderStyle = FormBorderStyle.None
            End If
            If boolPlaceDestination Then
                Me.picDestination.BorderStyle = FormBorderStyle.Fixed3D
            Else
                Me.picDestination.BorderStyle = FormBorderStyle.None
            End If
            If boolPause Then
                Me.picPause.BorderStyle = FormBorderStyle.Fixed3D
            Else
                Me.picPause.BorderStyle = FormBorderStyle.None
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in subButtonGui " & ex.ToString)
        End Try
    End Sub

    Dim boolPathDisplayed As Boolean = False
    Sub subPathGUI()
        Try
            If boolDrivingToDestination And Not boolPathDisplayed Then
                subDrawPath(tmcDestination)
                boolPlaceDestination = False
                boolPathDisplayed = True
            ElseIf Not boolDrivingToDestination Then
                boolPathDisplayed = False
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in subPathGUI " & ex.ToString)
        End Try
    End Sub

    ' Dim intPreviousSelectMap As Boolean = 0
    Sub subRBPFGUI()
        Try
            If boolEnableRBPF And Not tmiMoveInfo.boolBotIsMoving And Not boolSimulatedMovement Then
                For intParticleNumber As Short = 0 To intNumberOfParticles - 1 Step Max(intNumberOfParticles / 128, 1)
                    subDrawMapPixel(tbpParticlePose(intParticleNumber).Location.X, tbpParticlePose(intParticleNumber).Location.Y, Color.CornflowerBlue)
                Next
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in subRBPFGUI " & ex.ToString)
        End Try
    End Sub

    'Dim tlmLandMarkArrayCopy(128) As typeLandMark
    Sub subLmGUI()
        Try
            If frmLandMarkEdit.Visible Then
                If Not boolLocalizationInProgress Then  '  
                    'If Not boolDrivingToDestination Then Me.Refresh()

                    'If ftnVisualRecognizerEnabled() Then
                    '    If boolLocalizationInProgress And Not boolMouseDown Then
                    '        For i = 0 To UBound(tlmLandMarkArray)
                    '            If (tlmLandMarkArray(i).LandMarkRecognized <> tlmLandMarkArrayCopy(i).LandMarkRecognized) Then
                    '                If (tlmLandMarkArray(i).LandMarkValid <> tlmLandMarkArrayCopy(i).LandMarkValid) Then
                    '                    subDrawSmallCircle(tlmLandMarkArray(i).LandMarkLocation, Color.Green)
                    '                Else
                    '                    subDrawSmallCircle(tlmLandMarkArray(i).LandMarkLocation, Color.Red)
                    '                End If
                    '            End If
                    '        Next
                    '    Else
                    '        tlmLandMarkArrayCopy = tlmLandMarkArray
                    '    End If
                    'End If
                    'If boolMouseDown Then Me.Refresh()
                    subDrawLandMark()
                    myMap.CreateGraphics.DrawRectangle(Pens.CornflowerBlue, tlmLandMarkArray(frmLandMarkEdit.UpDnLM.Value).LandMarkValidRegion.X * sngZoom, tlmLandMarkArray(frmLandMarkEdit.UpDnLM.Value).LandMarkValidRegion.Y * sngZoom,
                                                                           tlmLandMarkArray(frmLandMarkEdit.UpDnLM.Value).LandMarkValidRegion.Width * sngZoom, tlmLandMarkArray(frmLandMarkEdit.UpDnLM.Value).LandMarkValidRegion.Height * sngZoom)
                End If
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in subLmGUI " & ex.ToString)
        End Try
    End Sub

    Sub subVectorGUI()
        Try
            If classScanner.chkContinuous.Checked Then
                frmRangeFinder.subGetRangerReadings()
                Refresh()
                ftnGetScanVectors()
            End If
            If boolLocalizationInProgress Then subLmGUI()
            If boolShowVectors Or classScanner.chkContinuous.Checked Then _
                subDrawScanVectors(tbpBotPose, boolShowGreenVectors)
            If boolShowVectors And Not boolLocalizationInProgress Then
                If boolShowGreenVectors Then
                    subDrawScanVectors(tbpBotPose, True)
                    boolShowGreenVectors = False
                    subWait(150)
                End If
                boolShowVectors = False
                myMap.Image = imgMap
                Refresh()
                boolPathDisplayed = False
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in subVectorGUI " & ex.ToString)
        End Try
    End Sub

    Sub subCollisionGUI()
        Try
            If (byteCollisionCode <> 7) Then
                subDrawScanVectors(tbpBotPose, False)
                Select Case byteCollisionCode
                    Case 4
                        StatusDriving.ForeColor = Color.Red
                        subDrawBumperSwitch(tbpBotPose, 0)
                        strStatusDriving = intDrivingSequenceNumber & ": COLLISION DETECTED -  Front"
                    Case 6
                        StatusDriving.ForeColor = Color.Red
                        subDrawBumperSwitch(tbpBotPose, -45)
                        strStatusDriving = intDrivingSequenceNumber & ": COLLISION DETECTED - Right Front"
                    Case 5
                        StatusDriving.ForeColor = Color.Red
                        subDrawBumperSwitch(tbpBotPose, 45)
                        strStatusDriving = intDrivingSequenceNumber & ": COLLISION DETECTED - Left Front"
                    Case 3
                        StatusDriving.ForeColor = Color.Red
                        subDrawBumperSwitch(tbpBotPose, 180)
                        strStatusDriving = intDrivingSequenceNumber & ": COLLISION DETECTED - Rear"
                    Case Else
                        StatusDriving.ForeColor = Color.Red
                        subDrawBumperSwitch(tbpBotPose, 180)
                        subDrawBumperSwitch(tbpBotPose, 45)
                        subDrawBumperSwitch(tbpBotPose, -45)
                        subDrawBumperSwitch(tbpBotPose, 0)
                        strStatusDriving = intDrivingSequenceNumber & ": COLLISION DETECTED "
                End Select
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in subCollisionGUI " & ex.ToString)
        End Try
    End Sub

    Sub subUpdateAllText(ByRef tbpBotPose As typeBotPose)
        Try
            If Not Me.InvokeRequired Then
                If Not updnOrientation.Focused Then updnOrientation.Value = tbpBotPose.Orientation
                subUpdateStatusLine()
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in subUpdateAllText " & ex.ToString)
        End Try
    End Sub

    Sub subUpdateStatusLine()
        Try
            If Not Me.InvokeRequired Then
                If (sngLaptopBatteryPercent <> 999) Then _
                        strStatusLaptopVoltage = "Laptop: " & sngLaptopBatteryPercent.ToString & "%"
                boolLocalRCCConnected = (boolEnableLocalRCC And classLRCCClient.Connected)
                boolRRConnected = ((boolRoboRealmBotSelected Or boolEnableLocalRR) And classRoboRealmClient.Connected)
                strStatusCommunications = "Comms: "
                If boolBotConnected Then strStatusCommunications += "Bot "
                If boolCompassAttached Then strStatusCommunications += "Compass "
                If boolRRConnected Then strStatusCommunications += "RR "
                If boolLocalRCCConnected Then strStatusCommunications += "LRCC "
                If classAPI1Server.Connected Then strStatusCommunications += "API "
                If classAPI2Server.Connected Then strStatusCommunications += "API2 "
                If boolEnableGotAGlyph And classGotAGlyphClient.Connected Then strStatusCommunications += "Glyph "
                If boolKinectConnected Then _
                        strStatusCommunications += "Kinect "
                If boolURGConnected Then _
                        strStatusCommunications += "URG04 "

                Dim stbStatus As StringBuilder = New StringBuilder(strStatusDriving)
                Dim cap As Int16 = stbStatus.EnsureCapacity(191)
                stbStatus.Append("                                             ")
                stbStatus.Remove(40, stbStatus.Length - 40)
                stbStatus.Append(strStatusCommunications)
                stbStatus.Append("                                   ")
                stbStatus.Remove(70, stbStatus.Length - 70)
                stbStatus.Append(strStatusBotVoltage)
                stbStatus.Append("                 ")
                stbStatus.Remove(85, stbStatus.Length - 85)
                stbStatus.Append(strStatusLaptopVoltage)
                stbStatus.Append("                         ")
                stbStatus.Remove(105, stbStatus.Length - 105)
                stbStatus.Append(strStatusMouseCoordinates)
                stbStatus.Append("                    ")
                stbStatus.Remove(120, stbStatus.Length - 120)
                stbStatus.Append(strStatusMapContents)

                Me.StatusDriving.Text = stbStatus.ToString
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in subUpdateStatusLine " & ex.ToString)
        End Try
    End Sub


    Private Sub subConfigureMenu(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuConfigure.Click
        Try
            If boolER1Selected Then
                mnuAngularVelocity.Visible = True
                mnuAngularAcceleration.Visible = True
                mnuVelocity.Visible = True
                mnuBotAcceleration.Visible = True
                mnuBotDiameter.Visible = True
                mnuBotSelect.Text = "Bot Select                   (ER1)"
                mnuSteeringBiasCorrection.Visible = False
                mnuDistanceCompensation.Visible = False
                mnuPowerMoving.Visible = True
                mnuPowerStopped.Visible = True
            ElseIf boolRoboRealmBotSelected Then
                mnuAngularVelocity.Visible = True
                mnuAngularAcceleration.Visible = True
                mnuVelocity.Visible = True
                mnuBotDiameter.Visible = True
                mnuBotSelect.Text = "Bot Select                   (RR Bot)"
                mnuSteeringBiasCorrection.Visible = False
                mnuDistanceCompensation.Visible = False
                mnuPowerMoving.Visible = False
                mnuPowerStopped.Visible = False
                boolEnableCurveMotion = False
            ElseIf boolHeroSelected Then
                sngMaxTurn = 90
                mnuAngularVelocity.Visible = False
                mnuAngularAcceleration.Visible = False
                mnuVelocity.Visible = False
                mnuBotAcceleration.Visible = False
                mnuBotDiameter.Visible = False
                mnuBotSelect.Text = "Bot Select                   (Hero)"
                mnuDistanceCompensation.Visible = True
                mnuSteeringBiasCorrection.Visible = True
                mnuPowerMoving.Visible = False
                mnuPowerStopped.Visible = False
                boolEnableCurveMotion = False
                boolEnableCourseCorrection = False
                boolEnableCurveMotion = False
            Else
                mnuSteeringBiasCorrection.Visible = False
                mnuPowerMoving.Visible = False
                mnuPowerStopped.Visible = False
                mnuDistanceCompensation.Visible = False
            End If
            mnuBotComPort.Visible = boolHeroSelected
            mnuBotComPort.Text = "Bot Com Port           (" & strBotComPort & ")"
            mnuHeroSelected.Checked = boolHeroSelected
            mnuER1Direct.Checked = boolER1Selected
            mnuFaceRecognition.Checked = boolEnableFaceRecognition
            mnuVideo.Checked = boolEnableVideo
            mnuArmControl.Checked = boolEnableArm
            boolEnableLocalizationWhileMoving = False
            mnuDock.Checked = boolDock
            mnuWheelSeparation.Visible = boolER1Selected
            mnuWheelSeparation.Text = "Wheel Separation           (" & sngBotWheelSeparation.ToString & ")"
            mnuEnableBumperSwitches.Visible = boolER1Selected
            mnuVoiceCommandEnable.Checked = boolVoiceCommandEnable
            mnuSimulatedMovement.Checked = boolSimulatedMovement
            mnuEnableRCC.Checked = boolEnableLocalRCC
            mnuEnableGotAGlyph.Checked = boolEnableGotAGlyph
            mnuEnableAVM.Checked = boolEnableAVM
            mnuEnableRR.Checked = boolEnableLocalRR
            mnuMute.Checked = boolMute
            mnuLogFileEnable.Checked = boolLogFileEnable
            mnuHeroSelected.Checked = boolHeroSelected
            mnuEnableBumperSwitches.Checked = boolEnableBumperSwitches_ER1
            mnuRoboRealmBotSelected.Checked = boolRoboRealmBotSelected
            mnuAllowRoboRealmToControlBot.Checked = boolAllowRoboRealmToControlBot
            mnuBotPose.Text = "Pose                      (" & tbpBotPose.Location.X & ", " & tbpBotPose.Location.Y & "    " & tbpBotPose.Orientation & ")"
            mnuBotDiameter.Text = "Bot Diameter                (" & sngBotDiameter & ")"
            mnuCameraResolution.Text = "Camera Resolution       (" & ticCameraResolution.X & ", " & ticCameraResolution.Y & ")"
            mnuCameraFOV.Text = "Camera FOV                 (" & sngCameraFOV & ")"
            mnuCameraOffset.Text = "Camera Offset              (" & sngCameraOffset & ")"
            mnuBotAcceleration.Text = "Acceleration                  (" & sngBotLinearAcceleration & ")"
            mnuVelocity.Text = "Velocity                          (" & sngBotLinearVelocity & ")"
            mnuAngularVelocity.Text = "Angular Velocity             (" & sngBotAngularVelocity & ")"
            mnuAngularAcceleration.Text = "Angular Acceleration      (" & sngBotAngularAcceleration & ")"
            mnuRecognitionTime.Text = "Visual Localization Time  (" & sngLocalizationTime & ")"
            mnuSteeringBiasCorrection.Text = "Steering Bias Correction      (" & sngSteeringBiasOffsetCorrection & ")"
            mnuPowerMoving.Text = "Power Moving            (" & intPowerMoving & ")"
            mnuPowerStopped.Text = "Power Stopped            (" & intPowerStopped & ")"
            mnuDestinationAlpha.Text = "Destination Alpha         (" & tmcDestinationAlpha.X & ", " & tmcDestinationAlpha.Y & ")"
            mnuDestinationBravo.Text = "Destination Bravo         (" & tmcDestinationBravo.X & ", " & tmcDestinationBravo.Y & ")"
            mnuDestinationCharlie.Text = "Destination Charlie       (" & tmcDestinationCharlie.X & ", " & tmcDestinationCharlie.Y & ")"
            mnuDestinationDelta.Text = "Destination Delta         (" & tmcDestinationDelta.X & ", " & tmcDestinationDelta.Y & ")"
            mnuDestinationEcho.Text = "Destination Echo          (" & tmcDestinationEcho.X & ", " & tmcDestinationEcho.Y & ")"
            mnuWeatherCity.Text = " Weather City             (" & strWeatherURL & ")"
            mnuNewsURL.Text = " News URL              (" & strNewsURL & ")"
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in subConfigure_Click " & ex.ToString)
        End Try
    End Sub


    Public Sub subLoadMap()
        Try
            myMap.Image = imgMap
            subResizeMap()
            myMap.Height = CInt(sngZoom * imgMap.Height)
            myMap.Width = CInt(sngZoom * imgMap.Width)
            Me.Refresh()
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in subLoadMap " & ex.ToString)
        End Try
    End Sub


    Sub subSizeChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Me.SizeChanged
        Try
            If (MouseButtons = MouseButtons.Left) Then subResizeMap() ' synth.SpeakAsync caused problems with me.height
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in subSizeChanged " & ex.ToString)
        End Try
    End Sub


    Private Sub subResizeMap()
        Try
            If (Me.WindowState <> FormWindowState.Minimized) Then
                If (Abs(sngZoom - (CSng(Me.Height - 150) / imgMap.Height)) > 0.01) Then
                    'myMap.Image = imgMap
                    sngZoom = (CSng(Me.Height - 150) / imgMap.Height)
                    myMap.Height = CInt(sngZoom * imgMap.Height)
                    myMap.Width = CInt(sngZoom * imgMap.Width)
                    Me.Width = myMap.Width + 80
                    If (Me.WindowState <> FormWindowState.Minimized) Then
                        If Me.Width > Screen.PrimaryScreen.Bounds.Width Then _
                                Me.Width = Screen.PrimaryScreen.Bounds.Width
                        If Me.Height > Screen.PrimaryScreen.Bounds.Height Then _
                                Me.Height = Screen.PrimaryScreen.Bounds.Height
                    End If
                    subRecalculateVariables()
                    Me.Refresh()
                    If boolDrivingToDestination Then subDrawPath(tmcDestination)
                End If
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in subResizeMap " & ex.ToString)
        End Try
    End Sub



    Dim boolPlacementActive As Boolean = False
    Dim tmcMouseDown As typeMapCoordinate
    Public Sub myMapNouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles myMap.MouseDown
        Try
            Dim tmcMapPoint As typeMapCoordinate = ftnMouseToMapPosition()
            boolMouseDown = (e.Button = MouseButtons.Left)

            If e.Button = MouseButtons.Right Then
                boolMouseDown = False
                MapContextMenu.Visible = True
                MapContextMenu.Left = MousePosition.X
                MapContextMenu.Top = MousePosition.Y
            ElseIf (boolPlaceBot And boolMouseDown) Then
                subWait(200)
                If ((Control.MouseButtons & MouseButtons.Left) <> MouseButtons.Left) And Not ftnInWall(tmcMapPoint) Then
                    If boolSlam Then
                        Dim DidWork As Integer = MsgBox("Are you sure you want to move the Bot's mapped position?", MsgBoxStyle.YesNoCancel)
                        If DidWork <> DialogResult.Yes Then Exit Sub
                        boolCollisionDetected = False
                        boolCollisionPredicted = False
                    End If
                    frmDebug.subWriteLogs(" ")
                    frmDebug.subWriteLogs(" ")
                    frmDebug.subWriteLogs(" ******************************************************************************************")
                    frmDebug.subWriteLogs(" ")
                    frmDebug.subWriteLogs(" ************  New Bot Location selected: Location = " & tmcMapPoint.X & ", " & tmcMapPoint.Y)
                    subChangeParticlePose(tmcMapPoint.X - tbpBotPose.Location.X, tmcMapPoint.Y - tbpBotPose.Location.Y, 0)
                    tbpBotPose.Location = tmcMapPoint 'Place the bot icon
                    If Not boolSlam Then subInitParticles(tbpBotPose, intNumberOfParticles)
                    boolPlacementActive = True
                End If
            ElseIf (boolPlaceDestination And boolMouseDown) Then
                tmcDestination = tmcMapPoint
            ElseIf (frmLandMarkEdit.Visible And frmLandMarkEdit.boolLocationFocused And boolMouseDown) Then ' Enter a Landmark Location
                tmcMapPoint = ftnMouseToMapPosition()
                tlmLandMarkArray(frmLandMarkEdit.UpDnLM.Value).LandMarkLocation.X = tmcMapPoint.X
                tlmLandMarkArray(frmLandMarkEdit.UpDnLM.Value).LandMarkLocation.Y = tmcMapPoint.Y
            ElseIf frmLandMarkEdit.Visible And frmLandMarkEdit.boolValidtyRegionFocused And boolMouseDown Then  ' Determine LandMark Validity area
                tmcMouseDown = ftnMouseToMapPosition()
            End If
            boolPlacementActive = ((Control.MouseButtons & MouseButtons.Left) <> MouseButtons.Left)
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in myMapNouseDown " & ex.ToString)
        End Try
    End Sub

    Public Sub myMapNouseUp(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles myMap.MouseUp
        Try
            If boolPlaceDestination Then
                tmcDestination = ftnMouseToMapPosition()
                Refresh()
                subGuiUpdate(sender, e)
                Dim threadDriveToDestination As New Thread(AddressOf subDriveToUserChosenDestination)
                threadDriveToDestination.Start()
            ElseIf boolPlaceBot Then
                tbpBotPose.Location = ftnMouseToMapPosition()
                Refresh()
                subGuiUpdate(sender, e)
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in myMapNouseUp " & ex.ToString)
        End Try
    End Sub


    Dim boolMap_MouseMoveBusy As Boolean = False
    Public Sub myMap_MouseMove(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles myMap.MouseMove
        Try
            If Not boolMap_MouseMoveBusy Then
                boolMap_MouseMoveBusy = True
                If boolLocalizationInProgress Then
                    Me.Cursor = Cursors.WaitCursor
                Else
                    Me.Cursor = Cursors.Arrow
                End If
                Dim tmcMapPoint As typeMapCoordinate = ftnMouseToMapPosition()
                myMap.Select()
                strStatusMouseCoordinates = tmcMapPoint.X.ToString("0000") & ", " & tmcMapPoint.Y.ToString("0000")
                If boolEnableRBPF Then
                    Dim intBestParticle As Short = ftnBestParticle(intNumberOfParticles)
                    strStatusMapContents = byteNavigationArray(tmcMapPoint.X, tmcMapPoint.Y).ToString & ", " & intPathArray(tmcMapPoint.X, tmcMapPoint.Y) & ", " &
                                               intDistanceFromWallSquaredArray(tmcMapPoint.X, tmcMapPoint.Y).ToString & ", " & byteParticleMapOdds(intBestParticle, tmcMapPoint.X, tmcMapPoint.Y).ToString()
                Else
                    strStatusMapContents = byteNavigationArray(tmcMapPoint.X, tmcMapPoint.Y).ToString & ", " & intPathArray(tmcMapPoint.X, tmcMapPoint.Y) & ", " &
                                               intDistanceFromWallSquaredArray(tmcMapPoint.X, tmcMapPoint.Y).ToString
                End If
                If e.Button <> MouseButtons.Left Then boolMouseDown = False
                If (boolPlaceBot And boolMouseDown And boolPlacementActive) Then    'Drag the bot icon
                    subChangeParticlePose(tmcMapPoint.X - tbpBotPose.Location.X, tmcMapPoint.Y - tbpBotPose.Location.Y, 0)
                    If Not ftnInWall(tmcMapPoint) Then
                        tbpBotPose.Location = tmcMapPoint
                        If Not boolSlam Then subInitParticles(tbpBotPose, intNumberOfParticles)
                        boolSettingsChanged = True
                    End If
                ElseIf (boolPlaceDestination And boolMouseDown And boolPlacementActive) Then
                    tmcDestination = tmcMapPoint  'Place the Destination icon
                ElseIf frmLandMarkEdit.Visible And boolMouseDown And frmLandMarkEdit.boolValidtyRegionFocused Then
                    subLMValidityRegion(tmcMouseDown)
                ElseIf frmLandMarkEdit.Visible And boolMouseDown And frmLandMarkEdit.boolLocationFocused Then
                    tlmLandMarkArray(frmLandMarkEdit.UpDnLM.Value).LandMarkLocation.X = tmcMapPoint.X
                    tlmLandMarkArray(frmLandMarkEdit.UpDnLM.Value).LandMarkLocation.Y = tmcMapPoint.Y
                End If
                boolMap_MouseMoveBusy = False
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in myMap_MouseMove " & ex.ToString)
        End Try
    End Sub


    Sub subLMValidityRegion(ByVal tmcMouseDown As typeMapCoordinate)
        Try
            If boolPlaceDestination = False And boolPlaceBot = False And boolMouseDown _
                    And frmLandMarkEdit.Visible And frmLandMarkEdit.boolValidtyRegionFocused Then  ' Determine LandMark Validity area
                Dim intWidth, intHeight, intX, intY As Short
                If (ftnMouseToMapPosition().Y >= tmcMouseDown.Y) Then
                    intHeight = ftnMouseToMapPosition().Y - tmcMouseDown.Y
                    intY = tmcMouseDown.Y
                Else
                    intHeight = (tmcMouseDown.Y - ftnMouseToMapPosition().Y)
                    intY = ftnMouseToMapPosition().Y
                End If
                If (ftnMouseToMapPosition().X >= tmcMouseDown.X) Then
                    intWidth = ftnMouseToMapPosition().X - tmcMouseDown.X
                    intX = tmcMouseDown.X
                Else
                    intWidth = (tmcMouseDown.X - ftnMouseToMapPosition().X)
                    intX = ftnMouseToMapPosition().X
                End If
                tlmLandMarkArray(frmLandMarkEdit.UpDnLM.Value).LandMarkValidRegion.X = intX
                tlmLandMarkArray(frmLandMarkEdit.UpDnLM.Value).LandMarkValidRegion.Y = intY
                tlmLandMarkArray(frmLandMarkEdit.UpDnLM.Value).LandMarkValidRegion.Width = intWidth
                tlmLandMarkArray(frmLandMarkEdit.UpDnLM.Value).LandMarkValidRegion.Height = intHeight
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in subLMValidityRegion " & ex.ToString)
        End Try
    End Sub



    Private Sub updnOrientation_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles updnOrientation.ValueChanged
        Try
            If Not Me.InvokeRequired And updnOrientation.Focused And updnOrientation.Enabled Then
                updnOrientation.Enabled = False
                updnOrientation.Value = ftnConvertTo360(Convert.ToInt16(updnOrientation.Value))
                If (tbpBotPose.Orientation <> updnOrientation.Value) Then
                    tbpBotPose.Orientation = updnOrientation.Value
                    tmiMoveInfo.tbpStartingPose.Orientation = updnOrientation.Value
                    frmDebug.subWriteLogs(" ************  New Bot Orientation selected:  = " & tbpBotPose.Orientation & " Degrees")
                    subChangeParticlePose(0, 0, ftnAngleDifference(Convert.ToInt16(updnOrientation.Value), tbpBotPose.Orientation))
                    updnOrientation.Enabled = True
                End If
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in updnOrientation_ValueChanged " & ex.ToString)
            updnOrientation.Enabled = True
            updnOrientation.Value = ftnConvertTo360(tbpBotPose.Orientation)
        End Try
    End Sub



    Private Sub picPause_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles picPause.DoubleClick
        On Error Resume Next
        boolPause = Not boolPause
        If boolPause Then frmDebug.subWriteLogs(Now() & "    >>>>  PAUSE button was pushed  >>> ")
    End Sub

    Private Function ftnMouseToMapPosition() As typeMapCoordinate
        Try
            ftnMouseToMapPosition.X = CShort((MousePosition.X - Me.Location.X - myMap.Location.X - myMap.Padding.Left - myMap.Margin.Left - 5) / sngZoom)
            ftnMouseToMapPosition.Y = (MousePosition.Y - Me.Location.Y - myMap.Location.Y - myMap.Padding.Top - myMap.Margin.Top - 27) / sngZoom
            ftnMouseToMapPosition = ftnCheckMapArrayLimits(ftnMouseToMapPosition)
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in ftnMouseToMapPosition " & ex.ToString)
        End Try
    End Function









    '==========================  MENUS  ==================================================



    '==========================  File Menu  ==================================================

    Delegate Sub DelegateLoadSettings(ByVal sender As System.Object, ByVal e As System.EventArgs)
    Public Sub mnuLoadSettings_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuLoadSettings.Click
        Try
            If InvokeRequired Then
                Dim newDelegate As New DelegateLoadSettings(AddressOf mnuLoadSettings_Click)
                Invoke(newDelegate, New Object() {sender, e})
            Else
                Me.StatusDriving.ForeColor = Color.Black
                LoadSettings("GotABot_Settings.xml")
                boolSettingsChanged = False
                subResizeMap()
                subConvertMapToArray()
                strStatusDriving = "Waiting for command "
                subInitParticles(tbpBotPose, intNumberOfParticles)
                ftnSendCommand("play phraseA 'Ready'")
                Me.Refresh()
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in mnuLoadSettings_Click " & ex.ToString)
        End Try
    End Sub

    Private Sub mnuLoadSettingsFileSelect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuLoadSettingsFileSelect.Click
        On Error Resume Next
        Me.StatusDriving.ForeColor = Color.Black
        OpenFD.Title = "Load GotABot Settings"
        OpenFD.Filter = "xml Files(*.xml)|*.xml"
        Dim DidWork As Integer = OpenFD.ShowDialog()
        If DidWork <> DialogResult.Cancel Then _
            LoadSettings(OpenFD.FileName)
        boolSettingsChanged = False
        subResizeMap()
        subConvertMapToArray()
        subInitParticles(tbpBotPose, intNumberOfParticles)
        If boolHeroSelected Then
            ftnHeroConfig()
            sngMaxTurn = 90
        ElseIf mnuER1Direct.Checked Then
            ftnER1_SerialConfig()
        ElseIf boolER1Selected Then
            ftnSendCommand("stop") ' force login for the ER1 I/F 
        End If
        Me.Refresh()
        strStatusDriving = "Waiting for command "
        ftnSendCommand("play phraseA 'Ready'")
    End Sub


    Public Sub mnuSaveSettings_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuSaveSettings.Click
        On Error Resume Next
        SaveSettings("GotABot_Settings.xml")
        boolSettingsChanged = False
    End Sub

    Private Sub mnuSaveSettingsFileSelect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuSaveSettingsFileSelect.Click
        On Error Resume Next
        Dim saveFD As New SaveFileDialog()
        saveFD.Title = "GotABot Settings Changed - Save?"
        saveFD.Filter = "xml Files(*.xml)|*.xml"
        Dim DidWork As Integer = saveFD.ShowDialog()
        If DidWork <> DialogResult.Cancel Then _
            SaveSettings(saveFD.FileName)
        boolSettingsChanged = False
    End Sub


    Private Sub mnuNewLog_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuNewLog.Click
        On Error Resume Next
        If (Dir("GotABot_Log.txt") <> "") Then My.Computer.FileSystem.DeleteFile("GotABot_Log.txt",
                    FileIO.UIOption.AllDialogs, FileIO.RecycleOption.DeletePermanently, FileIO.UICancelOption.DoNothing)
    End Sub

    Private Sub mnuOpenMapLog_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuOpenMapLog.Click
        On Error Resume Next
        Process.Start("notepad", "GotABot_Log.txt")
    End Sub





    Private Sub mnuExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuExit.Click
        Me.Close()
    End Sub

    Private Sub me_exit(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Me.FormClosed
        On Error Resume Next
        boolShutDown = True
        If boolBotConnected Then tbpBotPose = modBotMovementControl.ftnBotStop(tbpBotPose, tmiMoveInfo.tbpTargetPose)
        timerWatchDog.Enabled = False
        timerGUI.Enabled = False
        If boolSettingsChanged Then _
                 mnuSaveSettingsFileSelect_Click(sender, e)
        ftnSendCommand("play phrase 'Goodby'")
        boolKinectConnected = False
        boolURGConnected = False
        comURG.Close()
        boolStop = True
        modKinect.ftnKinectStop()
        classArm.subArmExit()
        ftnER1_SerialClose()
        reco.UnloadAllGrammars()
        reco.Dispose()
        Dim speech = Process.GetProcessesByName("Speech Recognition")
        For i As Integer = 0 To speech.Count - 1
            speech(i).CloseMainWindow()
            speech(i).Kill()
        Next i
        Dim proc = Process.GetProcessesByName("GotAGlyph")
        For i As Integer = 0 To proc.Count - 1
            proc(i).CloseMainWindow()
            proc(i).Kill()
        Next i
        subWait(1000)
    End Sub









    '==========================  Configure Menu  ==================================================



    Private Sub mnuEditMap_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuEditMap.Click
        Try
            OpenFD.Title = "Edit a Map"
            OpenFD.Filter = "BitMap Files(*.bmp)|*.bmp"
            Dim DidWork As Integer = OpenFD.ShowDialog()
            If DidWork <> DialogResult.Cancel Then
                imgMap.Dispose()
                bmpMap.Dispose()

                Dim editMap As Process = Process.Start("mspaint", OpenFD.SafeFileName)
                editMap.WaitForExit()
                subWait(500)
                imgMap = System.Drawing.Image.FromFile(OpenFD.FileName)
                Me.myMap.Image = imgMap
                subResizeMap()
                bmpMap = CType(System.Drawing.Image.FromFile(OpenFD.FileName), Bitmap)
                myMap.Height = CInt(sngZoom * imgMap.Height)
                myMap.Width = CInt(sngZoom * imgMap.Width)
                ReDim byteNavigationArray(imgMap.Width, imgMap.Height)
                ReDim intPathArray(CInt(imgMap.Width), CInt(imgMap.Height))
                ReDim intDistanceFromWallSquaredArray(imgMap.Width, imgMap.Height)
                subRecalculateVariables()
                subConvertMapToArray()
            End If
            subResizeMap()
            Me.Refresh()
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in mnuEditMap_Click " & ex.ToString)
        End Try
    End Sub

    Public Sub mnuOpenMap_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuOpenMap.Click
        Try
            OpenFD.Title = "Open a New Map"
            OpenFD.Filter = "BitMap Files(*.bmp)|*.bmp"
            Dim DidWork As Integer = OpenFD.ShowDialog()
            If DidWork <> DialogResult.Cancel Then subOpenMap(OpenFD.FileName)
            subConvertMapToArray()
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in mnuOpenMap_Click " & ex.ToString)
        End Try
    End Sub

    Private Sub mnuSaveMap_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuSaveMap.Click
        Try
            Dim saveFD As New SaveFileDialog()
            saveFD.Title = "Save a copy of the map"
            saveFD.Filter = "BitMap Files(*.bmp)|*.bmp"
            Dim DidWork As Integer = saveFD.ShowDialog()
            If DidWork <> DialogResult.Cancel Then _
                  bmpMap.Save(saveFD.FileName)
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in mnuSaveMap_Click " & ex.ToString)
        End Try
    End Sub


    Delegate Sub DelegateOpenMap(ByVal strFileName As String)
    Public Sub subOpenMap(ByVal strFileName As String)
        Try
            If InvokeRequired Then
                Dim newDelegate As New DelegateOpenMap(AddressOf subOpenMap)
                BeginInvoke(newDelegate, New Object() {strFileName})
            Else
                imgMap.Dispose()
                bmpMap.Dispose()
                imgMap = System.Drawing.Image.FromFile(strFileName)
                subResizeMap()
                ReDim byteNavigationArray(imgMap.Width, imgMap.Height)
                ReDim intPathArray(CInt(imgMap.Width), CInt(imgMap.Height))
                ReDim intDistanceFromWallSquaredArray(imgMap.Width, imgMap.Height)
                ReDim boolGreySpace(imgMap.Width, imgMap.Height)
                ReDim boolNoGo(imgMap.Width, imgMap.Height)
                ReDim boolCompassIsSuspect(imgMap.Width, imgMap.Height)
                Me.myMap.Image = imgMap
                bmpMap = New Bitmap(System.Drawing.Image.FromFile(strFileName), imgMap.Width, imgMap.Height)
                subRecalculateVariables()
                subConvertMapToArray() ' Convert the Map from .bmp format to a byte array
                subInitParticles(tbpBotPose, intNumberOfParticles)
                Me.Refresh()
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in subOpenMap " & ex.ToString)
        End Try
    End Sub


    Private Sub mnuViewLM_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuViewLM.Click
        On Error Resume Next
        boolViewLM = Not boolViewLM
        frmLandMarkEdit.Visible = boolViewLM
        frmLandMarkEdit.Focus()
    End Sub



    Private Sub subScannerConfigure(sender As Object, e As EventArgs) Handles mnuScannerConfigure.Click
        On Error Resume Next
        classScanner.Visible = True
        classScanner.Focus()
    End Sub


    Private Sub mnuDistanceCompensation_Click(sender As Object, e As EventArgs) Handles mnuDistanceCompensation.Click
        On Error Resume Next
        frmDistanceComp.Visible = True
        frmDistanceComp.Focus()
    End Sub




    Private Sub mnuER1Direct_Click(sender As Object, e As EventArgs) Handles mnuER1Direct.Click
        Try
            mnuER1Direct.Checked = Not mnuER1Direct.Checked
            boolER1Selected = mnuER1Direct.Checked
            If boolER1Selected Then
                mnuRoboRealmBotSelected.Checked = False
                boolRoboRealmBotSelected = False
                mnuHeroSelected.Checked = False
                boolHeroSelected = False
                sngBotMovementAccuracy = 0.7
                sngMaxTravel = 111
                ftnER1_SerialConfig()
            End If
            boolSettingsChanged = True
            subConfigureMenu(sender, e)
            mnuConfigure.ShowDropDown()
            mnuBotConfigure.ShowDropDown()
            mnuBotSelect.ShowDropDown()
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in mnuER1Direct_Click " & ex.ToString)
        End Try
    End Sub

    Private Sub mnuHeroSelected_Click(sender As Object, e As EventArgs) Handles mnuHeroSelected.Click
        On Error Resume Next
        mnuHeroSelected.Checked = Not mnuHeroSelected.Checked
        boolHeroSelected = mnuHeroSelected.Checked
        If boolHeroSelected Then subHeroConfigure()
        boolSettingsChanged = True
        subConfigureMenu(sender, e)
        mnuConfigure.ShowDropDown()
        mnuBotConfigure.ShowDropDown()
        mnuBotSelect.ShowDropDown()
    End Sub

    Sub subHeroConfigure()
        Try
            boolER1Selected = False
            mnuER1Direct.Checked = False
            mnuRoboRealmBotSelected.Checked = False
            boolRoboRealmBotSelected = False
            boolEnableCurveMotion = False
            boolEnableCourseCorrection = False
            boolEnableLocalizationWhileMoving = False
            sngBotAngularAcceleration = 999
            sngBotAngularVelocity = 999
            sngBotLinearVelocity = 40
            sngBotLinearAcceleration = 40
            sngBotDiameter = 14.5
            sngBotMovementAccuracy = 0.4
            sngMaxTravel = 48
            sngMaxTurn = 90
            If Not boolURGConnected And Not boolKinectConnected Then
                sngScanFOV = 350
                tmcScanVectorOffset.X = 0
                tmcScanVectorOffset.Y = 0
                intScanOffsetDegrees = 0
                intScanVectorsMaxRangeInches = 100
                intScanVectorsMinRangeInches = 0
                intNumberOfBeamsDefault = 40
                intNumberOfBeams = 40
                subCalculateScanBeamAngles()
                subCalculateScanCalCoefficients()
            End If
            subRecalculateVariables()
            boolStop = True
            Me.picStop.BorderStyle = FormBorderStyle.Fixed3D
            strStatusDriving = "Hero Configured "
            ftnHeroConfig()
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in subHeroConfigure " & ex.ToString)
        End Try
    End Sub

    Private Sub mnuRoboRealmBotSelected_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuRoboRealmBotSelected.Click
        On Error Resume Next
        mnuRoboRealmBotSelected.Checked = Not mnuRoboRealmBotSelected.Checked
        boolRoboRealmBotSelected = mnuRoboRealmBotSelected.Checked
        If boolRoboRealmBotSelected Then
            boolER1Selected = False
            mnuHeroSelected.Checked = False
            boolHeroSelected = False
            sngBotMovementAccuracy = 0.7
        End If
        boolSettingsChanged = True
        subConfigureMenu(sender, e)
        mnuConfigure.ShowDropDown()
        mnuBotConfigure.ShowDropDown()
        mnuBotSelect.ShowDropDown()
    End Sub



    Private Sub mnuDownloadHeroS19_Click(sender As Object, e As EventArgs)
        subHeroS19Download()
        Me.Refresh()
    End Sub


    Private Sub mnuEnableBumperSwitches_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuEnableBumperSwitches.Click
        On Error Resume Next
        mnuEnableBumperSwitches.Checked = Not mnuEnableBumperSwitches.Checked
        boolEnableBumperSwitches_ER1 = mnuEnableBumperSwitches.Checked
        boolSettingsChanged = True
        subConfigureMenu(sender, e)
        mnuConfigure.ShowDropDown()
        mnuOptions.ShowDropDown()
    End Sub



    Private Sub mnuBotComPort_Click(sender As Object, e As EventArgs) Handles mnuBotComPort.Click
        Try
            strBotComPort = InputBox("Enter Bot Com Port (ie COM1 or COM2 or ... )", "Bot Com Port Name", strBotComPort)
            boolSettingsChanged = True
            subConfigureMenu(sender, e)
            mnuConfigure.ShowDropDown()
            mnuBotConfigure.ShowDropDown()
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in mnuBotComPort_Click " & ex.ToString)
        End Try
    End Sub





    Private Sub mnuBotDiameter_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuBotDiameter.Click
        On Error Resume Next
        Dim strBotDiameter As String
        strBotDiameter = InputBox("Enter Bot Diameter ", "Bot Diameter", Str(sngBotDiameter))
        If strBotDiameter <> "" And IsNumeric(strBotDiameter) Then _
                sngBotDiameter = Convert.ToSingle(strBotDiameter)
        subRecalculateVariables()
        subConvertMapToArray()
        boolSettingsChanged = True
        subConfigureMenu(sender, e)
        mnuConfigure.ShowDropDown()
        mnuBotConfigure.ShowDropDown()
    End Sub

    Private Sub mnuRangers_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuRangers.Click
        On Error Resume Next
        frmRangeFinder.Visible = True
        frmRangeFinder.Focus()
    End Sub

    Private Sub mnuCameraResolution_Click(sender As System.Object, e As System.EventArgs) Handles mnuCameraResolution.Click
        On Error Resume Next
        Dim strCameraResolution As String
        strCameraResolution = InputBox("Enter Camera Resolution in the form 640, 480", "Camera Resolution", Str(ticCameraResolution.X) & ", " & Str(ticCameraResolution.Y))
        strCameraResolution &= " , 640, 480"
        Dim strParsedText As String() = strCameraResolution.Split(","c)
        ticCameraResolution.X = Convert.ToInt16(strParsedText(0))
        ticCameraResolution.Y = Convert.ToInt16(strParsedText(1))
        boolSettingsChanged = True
        subConfigureMenu(sender, e)
        mnuConfigure.ShowDropDown()
        mnuVisualLocalization.ShowDropDown()
        mnuCamera.ShowDropDown()
    End Sub


    Private Sub CameraFOVToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuCameraFOV.Click
        On Error Resume Next
        Dim strCameraFOV As String
        strCameraFOV = InputBox("Enter Camera Field Of View ", "Camera FOV", Str(sngCameraFOV))
        If strCameraFOV <> "" And IsNumeric(strCameraFOV) Then
            sngCameraFOV = Convert.ToSingle(strCameraFOV)
        End If
        boolSettingsChanged = True
        subConfigureMenu(sender, e)
        mnuConfigure.ShowDropDown()
        mnuVisualLocalization.ShowDropDown()
        mnuCamera.ShowDropDown()
    End Sub


    Private Sub mnuCameraOffset_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuCameraOffset.Click
        On Error Resume Next
        Dim strCameraOffset As String
        strCameraOffset = InputBox("Enter Camera Offset from center of Bot ", "Camera Offset", Str(sngCameraOffset))
        If strCameraOffset <> "" And IsNumeric(strCameraOffset) Then
            sngCameraOffset = Convert.ToSingle(strCameraOffset)
        End If
        boolSettingsChanged = True
        subConfigureMenu(sender, e)
        mnuConfigure.ShowDropDown()
        mnuVisualLocalization.ShowDropDown()
        mnuCamera.ShowDropDown()
    End Sub


    Private Sub mnuPowerMoving_Click(sender As Object, e As EventArgs) Handles mnuPowerMoving.Click
        Try
            Dim strPowerMoving As String
            strPowerMoving = InputBox("Enter Power Moving (0-100) ", "Power Moving", Str(intPowerMoving))
            If strPowerMoving <> "" And IsNumeric(strPowerMoving) Then
                intPowerMoving = Convert.ToSingle(strPowerMoving)
                If (intPowerMoving > 100) Or (intPowerMoving < 0) Then
                    intPowerMoving = 60
                    ftnSendCommand("play phrase Beep")
                End If
                ftnSendCommand("set power moving " & intPowerMoving)
            End If
            subConfigureMenu(sender, e)
            mnuConfigure.ShowDropDown()
            mnuBotConfigure.ShowDropDown()
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in mnuPowerMoving_Click " & ex.ToString)
        End Try
    End Sub

    Private Sub mnuPowerStopped_Click(sender As Object, e As EventArgs) Handles mnuPowerStopped.Click
        Try
            Dim strPowerStopped As String
            strPowerStopped = InputBox("Enter Power Stopped (0-100) ", "Power Stopped", Str(intPowerStopped))
            If strPowerStopped <> "" And IsNumeric(strPowerStopped) Then
                intPowerStopped = Convert.ToSingle(strPowerStopped)
                If (intPowerStopped > 100) Or (intPowerStopped < 0) Then
                    intPowerStopped = 60
                    ftnSendCommand("play phrase Beep")
                End If
                ftnSendCommand("set power stopped " & intPowerStopped)
            End If
            ftnSendCommand("stop")
            subConfigureMenu(sender, e)
            mnuConfigure.ShowDropDown()
            mnuBotConfigure.ShowDropDown()
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in mnuPowerStopped_Click " & ex.ToString)
        End Try
    End Sub

    Private Sub mnuWheelSeparation_Click(sender As Object, e As EventArgs) Handles mnuWheelSeparation.Click
        Try
            Dim strWheelSeparation As String
            strWheelSeparation = InputBox("Enter WheelSeparation in cm ", "Wheel Separation", Str(sngBotWheelSeparation))
            If strWheelSeparation <> "" And IsNumeric(strWheelSeparation) Then
                sngBotWheelSeparation = Convert.ToSingle(strWheelSeparation)
                ftnSendCommand("set power stopped " & intPowerStopped)
            End If
            subConfigureMenu(sender, e)
            mnuConfigure.ShowDropDown()
            mnuBotConfigure.ShowDropDown()
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in mnuWheelSeparation_Click " & ex.ToString)
        End Try
    End Sub


    Private Sub mnuAcceleration_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuBotAcceleration.Click
        On Error Resume Next
        Dim strAcceleration As String
        strAcceleration = InputBox("Enter the Bot Acceleration in centimeters per second /second ", "Acceleration", Str(sngBotLinearAcceleration))
        If strAcceleration <> "" And IsNumeric(strAcceleration) Then
            sngBotLinearAcceleration = Convert.ToSingle(strAcceleration)
            If (sngBotLinearAcceleration <= 0) Then sngBotLinearAcceleration = 1
        End If
        subRecalculateVariables()
        boolSettingsChanged = True
        subConfigureMenu(sender, e)
        mnuConfigure.ShowDropDown()
        mnuBotConfigure.ShowDropDown()
    End Sub

    Private Sub mnuVelocity_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuVelocity.Click
        On Error Resume Next
        Dim strVelocity As String
        strVelocity = InputBox("Enter the Bot Linear Velocity in centimeters per second  ", "Velocity", Str(sngBotLinearVelocity))
        If strVelocity <> "" And IsNumeric(strVelocity) Then
            sngBotLinearVelocity = Convert.ToSingle(strVelocity)
        End If
        subRecalculateVariables()
        boolSettingsChanged = True
        ftnSendCommand("set linear velocity " & Int(sngBotLinearVelocity).ToString)
        subConfigureMenu(sender, e)
        mnuConfigure.ShowDropDown()
        mnuBotConfigure.ShowDropDown()
    End Sub


    Private Sub mnuAngularVelocity_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuAngularVelocity.Click
        On Error Resume Next
        Dim strAngularVelocity As String
        strAngularVelocity = InputBox("Enter the Bot Angular Velocity in degrees per second  ", "AngularVelocity", Str(sngBotAngularVelocity))
        If strAngularVelocity <> "" And IsNumeric(strAngularVelocity) Then
            sngBotAngularVelocity = Convert.ToSingle(strAngularVelocity)
        End If
        subRecalculateVariables()
        boolSettingsChanged = True
        ftnSendCommand("set angular velocity  " & Int(sngBotAngularVelocity).ToString)
        subConfigureMenu(sender, e)
        mnuConfigure.ShowDropDown()
        mnuBotConfigure.ShowDropDown()
    End Sub

    Private Sub mnuAngularAcceleration_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuAngularAcceleration.Click
        On Error Resume Next
        Dim strAngularAcceleration As String
        strAngularAcceleration = InputBox("Enter the Bot Angular Acceleration in degrees per second per second ", "AngularAcceleration", Str(sngBotAngularAcceleration))
        If strAngularAcceleration <> "" And IsNumeric(strAngularAcceleration) Then
            sngBotAngularAcceleration = Convert.ToSingle(strAngularAcceleration)
            If (sngBotAngularAcceleration <= 0) Then sngBotAngularAcceleration = 1
        End If
        subRecalculateVariables()
        boolSettingsChanged = True
        subConfigureMenu(sender, e)
        mnuConfigure.ShowDropDown()
        mnuBotConfigure.ShowDropDown()
    End Sub


    Private Sub mnuSteeringBias_Click(sender As Object, e As EventArgs) Handles mnuSteeringBiasCorrection.Click
        Try
            Dim strSteeringBiasOffsetCorrection As String
            strSteeringBiasOffsetCorrection = InputBox("If the robot does not steer straight ahead then enter an offset correction" & vbCrLf &
                                                  " '-ve offset' = robot will steer more left" & vbCrLf &
                                                  " '+ve offset' = robot will steer more right", "SteeringBiasCorrection", Str(sngSteeringBiasOffsetCorrection))
            If strSteeringBiasOffsetCorrection <> "" And IsNumeric(strSteeringBiasOffsetCorrection) Then
                sngSteeringBiasOffsetCorrection = Convert.ToSingle(strSteeringBiasOffsetCorrection)
            End If
            boolSettingsChanged = True
            subConfigureMenu(sender, e)
            mnuConfigure.ShowDropDown()
            mnuBotConfigure.ShowDropDown()
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in mnuSteeringBias_Click " & ex.ToString)
        End Try
    End Sub


    Private Sub mnuCompass_Click(sender As Object, e As EventArgs) Handles mnuCompass.Click
        frmCompass.Visible = True
    End Sub







    Private Sub mnuViewDebug_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuViewDebug.Click
        On Error Resume Next
        boolViewDebug = True
        frmDebug.Visible = boolViewDebug
        frmDebug.Focus()
    End Sub


    Private Sub mnuToolsOptions_Click(sender As System.Object, e As System.EventArgs)
        On Error Resume Next
    End Sub



    Private Sub mnuEnableLocalRCC_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuEnableRCC.Click
        On Error Resume Next
        mnuEnableRCC.Checked = Not mnuEnableRCC.Checked
        boolEnableLocalRCC = mnuEnableRCC.Checked
        If boolEnableLocalRCC Then strPassword = InputBox("Enter password ", "Password", "XXXXXXXX")
        boolSettingsChanged = True
        subConfigureMenu(sender, e)
        mnuConfigure.ShowDropDown()
        mnuVisualLocalization.ShowDropDown()
        mnuRecognizer.ShowDropDown()
    End Sub

    Private Sub mnuEnableLocalRR_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuEnableRR.Click
        On Error Resume Next
        mnuEnableRR.Checked = Not mnuEnableRR.Checked
        boolEnableLocalRR = mnuEnableRR.Checked
        boolSettingsChanged = True
        subConfigureMenu(sender, e)
        mnuConfigure.ShowDropDown()
        mnuVisualLocalization.ShowDropDown()
        mnuRecognizer.ShowDropDown()
    End Sub




    Private Sub mnuEnableGotAGlyph_Click(sender As System.Object, e As System.EventArgs) Handles mnuEnableGotAGlyph.Click
        On Error Resume Next
        mnuEnableGotAGlyph.Checked = Not mnuEnableGotAGlyph.Checked
        boolEnableGotAGlyph = mnuEnableGotAGlyph.Checked
        boolSettingsChanged = True
        If boolEnableGotAGlyph And (ProcessesRunning("GotAGlyph") = 0) Then
            Process.Start(Environment.CurrentDirectory & "\GotAGlyph\GotAGlyph.exe", "")
        End If
        ftnGotAGlyph_Communicate("glyph", ">", 500)
    End Sub

    Private Sub mnuEnableAVM_Click(sender As System.Object, e As System.EventArgs) Handles mnuEnableAVM.Click
        On Error Resume Next
        mnuEnableAVM.Checked = Not mnuEnableAVM.Checked
        boolEnableAVM = mnuEnableAVM.Checked
        boolSettingsChanged = True
        subConfigureMenu(sender, e)
        mnuConfigure.ShowDropDown()
        mnuVisualLocalization.ShowDropDown()
        mnuRecognizer.ShowDropDown()
    End Sub


    Private Sub mnuRangeCalibration_Click(sender As System.Object, e As System.EventArgs) Handles mnuRangeCalibration.Click
        On Error Resume Next
        frmAvmRangeCorrection.Visible = True
        frmAvmRangeCorrection.Focus()
    End Sub


    Function ProcessesRunning(ByVal ProcessName As String) As Integer
        '  Generalized Function to Check if an Instance of Application is running in the machine
        Try
            Return Process.GetProcessesByName(ProcessName).GetUpperBound(0) + 1
        Catch
            Return 0
        End Try
    End Function





    Private Sub mnuSimulatedMovement_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuSimulatedMovement.Click
        On Error Resume Next
        If (boolSimulatedMovement = False) Then
            boolSimulatedMovement = True
            mnuSimulatedMovement.Checked = True
        Else
            boolSimulatedMovement = False
            mnuSimulatedMovement.Checked = False
        End If
        boolSettingsChanged = True
        subConfigureMenu(sender, e)
        mnuConfigure.ShowDropDown()
        mnuOptions.ShowDropDown()
    End Sub

    Private Sub mnuLocalize_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuLocalize.Click
        On Error Resume Next
        boolStop = False
        frmDebug.subWriteLogs(ftnElapsedTimeS() & "                  Starting Localization ")
        Dim threadLocalize As New Thread(AddressOf subLocalizeTop)
        threadLocalize.Start()
    End Sub

    Private Sub mnuSLAM_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuSLAM.Click
        Try
            boolStop = False
            mnuOpenMap_Click(sender, e)
            boolSlam = True
            frmSlam.subSlamInit()
            frmSlam.Visible = True
            subInitParticles(tbpBotPose, intNumberOfParticles)
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in mnuSLAM_Click " & ex.ToString)
        End Try
    End Sub


    Private Sub mnuDock_Click(sender As System.Object, e As System.EventArgs) Handles mnuDock.Click
        On Error Resume Next
        boolDock = Not boolDock
        If boolDock Then
            boolStop = False
            Me.picStop.BorderStyle = FormBorderStyle.None
            mnuTools.HideDropDown()
            Dim threadDock As New Thread(AddressOf frmDock.subDock)
            threadDock.Start()
        End If
    End Sub

    Private Sub mnuDockConfigure_Click(sender As System.Object, e As System.EventArgs) Handles mnuDockConfigure.Click
        On Error Resume Next
        frmDock.Visible = True
        frmDock.Focus()
    End Sub


    Private Sub mnuFaceRecognition_Click(sender As Object, e As EventArgs) Handles mnuFaceRecognition.Click
        Try
            mnuFaceRecognition.Checked = Not mnuFaceRecognition.Checked
            boolEnableFaceRecognition = mnuFaceRecognition.Checked
            frmVideo.subVideoStart()
            boolSettingsChanged = True
            subConfigureMenu(sender, e)
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in mnuFaceRecognition_Click " & ex.ToString)
        End Try
    End Sub


    Private Sub mnuArmControl_Click(sender As Object, e As EventArgs) Handles mnuArmControl.Click
        Try
            mnuArmControl.Checked = Not mnuArmControl.Checked
            boolEnableArm = mnuArmControl.Checked
            subConfigureMenu(sender, e)
            mnuTools.ShowDropDown()
            If boolEnableArm Then classArm.frmGotAnArm_Load(sender, e)
            boolSettingsChanged = True
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in mnuArmControl_Click " & ex.ToString)
        End Try
    End Sub


    Private Sub mnuVideo_Click(sender As Object, e As EventArgs) Handles mnuVideo.Click
        Try
            mnuVideo.Checked = Not mnuVideo.Checked
            boolEnableVideo = mnuVideo.Checked
            If boolEnableVideo Then frmVideo.subVideoStart()
            boolSettingsChanged = True
            subConfigureMenu(sender, e)
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in mnuVideo_Click " & ex.ToString)
        End Try
    End Sub

    Private Sub RecognitionTimeToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuRecognitionTime.Click
        On Error Resume Next
        Dim strRecognitionTime As String
        strRecognitionTime = InputBox("Enter the time (in seconds) the robot will look for Land Marks (Longer gives better accuracy) ", "Localization Time", Str(sngLocalizationTime))
        If strRecognitionTime <> "" And IsNumeric(strRecognitionTime) Then
            sngLocalizationTime = Convert.ToSingle(strRecognitionTime)
        End If
        boolSettingsChanged = True
        subConfigureMenu(sender, e)
        mnuConfigure.ShowDropDown()
        mnuVisualLocalization.ShowDropDown()
    End Sub


    Private Sub mnuAllowRoboRealmToControlBot_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuAllowRoboRealmToControlBot.Click
        On Error Resume Next
        mnuAllowRoboRealmToControlBot.Checked = Not mnuAllowRoboRealmToControlBot.Checked
        boolAllowRoboRealmToControlBot = mnuAllowRoboRealmToControlBot.Checked
        boolSettingsChanged = True
        If boolAllowRoboRealmToControlBot Then AllowRRToControlBot()
        subConfigureMenu(sender, e)
        mnuConfigure.ShowDropDown()
        mnuOptions.ShowDropDown()
    End Sub

    Private Sub mnuMute_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuMute.Click
        On Error Resume Next
        boolMute = Not boolMute
        mnuMute.Checked = boolMute
        If boolMute Then
            ftnSendCommand("clear")
            ftnSendCommand("speak off")
        Else
            ftnSendCommand("clear")
            ftnSendCommand("speak on")
        End If
        subConfigureMenu(sender, e)
        mnuConfigure.ShowDropDown()
        mnuOptions.ShowDropDown()
    End Sub

    '--------------------------------- Speech Control
    Private Sub mnuNewsURL_Click(sender As Object, e As EventArgs) Handles mnuNewsURL.Click
        On Error Resume Next
        strNewsURL = InputBox("Enter the URL of a news feed ", " News URL", strNewsURL)
        boolSettingsChanged = True
        subConfigureMenu(sender, e)
        mnuConfigure.HideDropDown()
    End Sub

    Private Sub mnuWeatherURL_Click(sender As Object, e As EventArgs) Handles mnuWeatherCity.Click
        On Error Resume Next
        'strWeatherURL = InputBox("Enter the URL of a Yahoo Weather feed.  See http://weather.yahoo.com/ for the URL of your location. ", " Yahoo Weather URL", strWeatherURL)
        strWeatherURL = InputBox("Enter the city name. ", " City", strWeatherURL)
        boolSettingsChanged = True
        subConfigureMenu(sender, e)
        mnuConfigure.HideDropDown()
        Dim strWeather As String = ftnGetWeatherRSS("https://query.yahooapis.com/v1/public/yql?q=select%20*%20from%20weather.forecast%20where%20woeid%20in%20(select%20woeid%20from%20geo.places(1)%20where%20text%3D%22" & strWeatherURL & "%2C%20ak%22)&format=xml&env=store%3A%2F%2Fdatatables.org%2Falltableswithkeys")
        ftnSendCommand("play phraseA '" & strWeather & "'")
    End Sub

    Private Sub mnuDestinationAlpha_Click(sender As Object, e As EventArgs) Handles mnuDestinationAlpha.Click
        Try
            tmcDestinationAlpha = ftnGetVoiceDestination()
            boolSettingsChanged = True
            subConfigureMenu(sender, e)
            mnuConfigure.ShowDropDown()
            mnuOptions.ShowDropDown()
            mnuVoiceCommandEnable.ShowDropDown()
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in mnuDestinationAlpha_Click " & ex.ToString)
        End Try
    End Sub

    Private Sub mnuDestinationBravo_Click(sender As Object, e As EventArgs) Handles mnuDestinationBravo.Click
        Try
            tmcDestinationBravo = ftnGetVoiceDestination()
            boolSettingsChanged = True
            subConfigureMenu(sender, e)
            mnuConfigure.ShowDropDown()
            mnuOptions.ShowDropDown()
            mnuVoiceCommandEnable.ShowDropDown()
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in mnuDestinationBravo_Click " & ex.ToString)
        End Try
    End Sub

    Private Sub mnuDestinationCharlie_Click(sender As Object, e As EventArgs) Handles mnuDestinationCharlie.Click
        Try
            tmcDestinationCharlie = ftnGetVoiceDestination()
            boolSettingsChanged = True
            subConfigureMenu(sender, e)
            mnuConfigure.ShowDropDown()
            mnuOptions.ShowDropDown()
            mnuVoiceCommandEnable.ShowDropDown()
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in mnuDestinationCharlie_Click " & ex.ToString)
        End Try
    End Sub

    Private Sub mnuDestinationDelta_Click(sender As Object, e As EventArgs) Handles mnuDestinationDelta.Click
        Try
            tmcDestinationDelta = ftnGetVoiceDestination()
            boolSettingsChanged = True
            subConfigureMenu(sender, e)
            mnuConfigure.ShowDropDown()
            mnuOptions.ShowDropDown()
            mnuVoiceCommandEnable.ShowDropDown()
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in mnuDestinationDelta_Click " & ex.ToString)
        End Try
    End Sub

    Private Sub mnuDestinationEcho_Click(sender As Object, e As EventArgs) Handles mnuDestinationEcho.Click
        Try
            tmcDestinationEcho = ftnGetVoiceDestination()
            boolSettingsChanged = True
            subConfigureMenu(sender, e)
            mnuConfigure.ShowDropDown()
            mnuOptions.ShowDropDown()
            mnuVoiceCommandEnable.ShowDropDown()
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in mnuDestinationEcho_Click " & ex.ToString)
        End Try
    End Sub

    Function ftnGetVoiceDestination() As typeMapCoordinate
        Try
            ftnGetVoiceDestination = tbpBotPose.Location
            Dim strDestination As String = ""
            strDestination = InputBox("enter a destination in the form xx yy ", "Destination", strDestination)
            Dim strParsedDestination As String() = strDestination.Split(" ")
            If (UBound(strParsedDestination) >= 1) And (Val(strParsedDestination(0) > 0)) And (Val(strParsedDestination(1) > 0)) Then
                ftnGetVoiceDestination.X = Int(Val(strParsedDestination(0)))
                ftnGetVoiceDestination.Y = Int(Val(strParsedDestination(1)))
            Else
                ftnSendCommand("play phrase Beep")
                MsgBox(" Invalid Destination.")
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in ftnGetVoiceDestination " & ex.ToString)
        End Try
    End Function



    Private Sub mnuBotPose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuBotPose.Click
        On Error Resume Next
        frmPose.Visible = True
        frmPose.Focus()
    End Sub




    Private Sub VoiceCommandEnableToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles mnuVoiceCommandEnable.Click
        On Error Resume Next
        mnuVoiceCommandEnable.Checked = Not mnuVoiceCommandEnable.Checked
        boolVoiceCommandEnable = mnuVoiceCommandEnable.Checked
        subSpeechEnableChange()
        boolSettingsChanged = True
        subConfigureMenu(sender, e)
        mnuConfigure.ShowDropDown()
        mnuOptions.ShowDropDown()
    End Sub

    Private Sub mnuLogFileEnable_Click(sender As Object, e As EventArgs) Handles mnuLogFileEnable.Click
        On Error Resume Next
        mnuLogFileEnable.Checked = Not mnuLogFileEnable.Checked
        boolLogFileEnable = mnuLogFileEnable.Checked
        boolSettingsChanged = True
        subConfigureMenu(sender, e)
        mnuConfigure.ShowDropDown()
        mnuOptions.ShowDropDown()
    End Sub


    '==========================  Tool Strip  ==================================================


    Private Sub OpenToolStripButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OpenToolStripButton.Click
        Try
            If NativeMethods.GetAsyncKeyState(Keys.LShiftKey) Then   ' Test Code
                tbpBotPose.Location = ftnConvertToTMC(117, 166)
                tbpBotPose.LocationUncertainty = ftnConvertToTMC(13, 13)
                tbpBotPose.Orientation = 183
                tbpBotPose.OrientationUncertainty = 13
                intNumberOfBeamsDefault = 32
                intNumberOfBeams = 32
                frmDebug.subWriteLogs(" intNumberOfBeams =  " & intNumberOfBeams)
                frmDebug.subWriteLogs(" intNumberOfBeamsDefault =  " & intNumberOfBeamsDefault)
                frmDebug.subWriteLogs(" intNumberOfParticles =  " & intNumberOfParticles)
                tmiMoveInfo.timeMoveCommandSent = Now()
                subConvertMapToArray()
                frmDebug.subWriteLogs(" subConvertMapToArray Time = " & ftnElapsedTimeS())
                tmiMoveInfo.timeMoveCommandSent = Now()
                subGeneratePathArray()
                frmDebug.subWriteLogs(" subGeneratePathArray Time = " & ftnElapsedTimeS())
                tmiMoveInfo.timeMoveCommandSent = Now()
                ftnFindPathToDestination(ftnConvertToTMC(150, 65), tbpBotPose.Location)
                frmDebug.subWriteLogs(" ftnFindPathToDestination Time = " & ftnElapsedTimeS())
                tmiMoveInfo.timeMoveCommandSent = Now()
                ftnFindTargetPose(tbpBotPose, ftnConvertToTMC(150, 65))
                frmDebug.subWriteLogs(" ftnFindTargetPose Time = " & ftnElapsedTimeS())
                tmiMoveInfo.timeMoveCommandSent = Now()
                ftnGetScanVectors()
                frmDebug.subWriteLogs(" ftnGetScanVectors Time = " & ftnElapsedTimeS())
                tmiMoveInfo.timeMoveCommandSent = Now()
                ftnNonFlatWall()
                frmDebug.subWriteLogs(" ftnNonFlatWall Time = " & ftnElapsedTimeS())
                tmiMoveInfo.timeMoveCommandSent = Now()
                boolEnableRBPF = True
                tmiMoveInfo.timeMoveCommandSent = Now()
                subInitParticles(tbpBotPose, 128)
                frmDebug.subWriteLogs(" subInitParticles 128 particles Time = " & ftnElapsedTimeS())
                tmiMoveInfo.timeMoveCommandSent = Now()
                ftnLocalizeRBPF_Top(tbpBotPose, False)
                frmDebug.subWriteLogs(" ftnLocalizeRBPF_Top  Time = " & ftnElapsedTimeS())
                boolLocalizationInProgress = False
                boolEnableRBPF = False
            Else
                mnuOpenMap_Click(sender, e)
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in OpenToolStripButton_Click " & ex.ToString)
        End Try
    End Sub

    Private Sub SaveToolStripButton_Click(sender As Object, e As EventArgs) Handles SaveToolStripButton.Click
        Try
            If NativeMethods.GetAsyncKeyState(Keys.LShiftKey) Then  ' Test Code
                tbpBotPose.Location = ftnConvertToTMC(114, 168)
                tbpBotPose.Orientation = 178
                Dim tbpTarget As typeBotPose = tbpBotPose
                tmcDestination = ftnConvertToTMC(128, 193)
                Dim threadDriveToDestination As New Thread(AddressOf subDriveToUserChosenDestination)
                threadDriveToDestination.Start()
            ElseIf NativeMethods.GetAsyncKeyState(Keys.ControlKey) Then  ' Test Code
                ftnSendCommand("play phrase 'How are you today?'")
                ftnSendCommand("play phrase 'How are you today.'")
            Else
                mnuSaveSettings_Click(sender, e)
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in SaveToolStripButton_Click " & ex.ToString)
        End Try
    End Sub




    '==========================  Map Context Menu  ==================================================

    Private Sub ContextMenuStrip1_Opening(ByVal sender As System.Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MapContextMenu.Opening
        MapContextMenu.Visible = True
    End Sub



    Private Sub mnuLocalizeContext_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuLocalizeContext.Click
        mnuLocalize_Click(sender, e)
    End Sub


    Private Sub mnuAbout_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuAbout.Click
        AboutBox1.Visible = True
    End Sub



    '==================================== Keyboard Manual Control  =============================================
    Dim boolManualControl As Boolean = False
    Public boolCtrlKey As Boolean = False
    Private Sub Form_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles MyBase.KeyDown
        Try
            Dim boolGoodLocalization As Boolean = False
            boolCtrlKey = (e.KeyCode = Keys.ControlKey)
            If Not boolManualControl And Not boolLocalizationInProgress And Not boolSlam Then
                boolManualControl = True
                boolDocked = False
                boolDock = False
                Dim tbpTargetPose As typeBotPose = tbpBotPose
                If e.KeyCode = Keys.Down Then
                    boolStop = False
                    frmDebug.subWriteLogs("))))))  Manual Control:  BACK")
                    If boolSlam Or boolHeroSelected Then
                        While NativeMethods.GetAsyncKeyState(Keys.Down)
                            tbpTargetPose.Location = ftnLocationFromEstimatedPose(tbpBotPose, 180, 10)
                            tbpBotPose = ftnBotFwd(tbpBotPose, tbpTargetPose)
                            subWait(1000)
                            NativeMethods.GetAsyncKeyState(Keys.Down)
                        End While
                    Else
                        tbpTargetPose.Location = ftnLocationFromEstimatedPose(tbpBotPose, 180, sngMaxTravel)
                        tbpBotPose = ftnBotFwd(tbpBotPose, tbpTargetPose)
                    End If
                    If boolSlam Then
                        Dim threadLocalize As New Thread(AddressOf subLocalizeTop)
                        threadLocalize.Start()
                    End If
                End If
                If e.KeyCode = Keys.Up Then
                    boolStop = False
                    frmDebug.subWriteLogs("))))))  Manual Control:  FWD")
                    If boolSlam Or boolHeroSelected Then
                        While NativeMethods.GetAsyncKeyState(Keys.Up)
                            tbpTargetPose.Location = ftnLocationFromEstimatedPose(tbpBotPose, 0, 10)
                            tbpBotPose = ftnBotFwd(tbpBotPose, tbpTargetPose)
                            subWait(1000)
                            NativeMethods.GetAsyncKeyState(Keys.Up)
                        End While
                    Else
                        tbpTargetPose.Location = ftnLocationFromEstimatedPose(tbpBotPose, 0, sngMaxTravel)
                        tbpBotPose = ftnBotFwd(tbpBotPose, tbpTargetPose)
                    End If
                    If boolSlam Then
                        Dim threadLocalize As New Thread(AddressOf subLocalizeTop)
                        threadLocalize.Start()
                    End If
                End If
                If e.KeyCode = Keys.Right Then
                    boolStop = False
                    frmDebug.subWriteLogs("))))))  Manual Control:  TURN RIGHT")
                    If boolSlam Or boolHeroSelected Then
                        While NativeMethods.GetAsyncKeyState(Keys.Right)
                            tbpTargetPose.Orientation = ftnConvertTo360(tbpTargetPose.Orientation - 15)
                            tbpBotPose = ftnBotTurn(tbpBotPose, False, tbpTargetPose)
                            subWait(1000)
                            NativeMethods.GetAsyncKeyState(Keys.Right)
                        End While
                    Else
                        tbpTargetPose.Orientation = ftnConvertTo360(tbpTargetPose.Orientation - 135)
                        tbpBotPose = ftnBotTurn(tbpBotPose, False, tbpTargetPose)
                    End If
                    If boolSlam Then
                        Dim threadLocalize As New Thread(AddressOf subLocalizeTop)
                        threadLocalize.Start()
                    End If
                End If
                If e.KeyCode = Keys.Left Then
                    boolStop = False
                    frmDebug.subWriteLogs("))))))  Manual Control:  TURN LEFT")
                    If boolSlam Or boolHeroSelected Then
                        While NativeMethods.GetAsyncKeyState(Keys.Left)
                            tbpTargetPose.Orientation = ftnConvertTo360(tbpTargetPose.Orientation + 10)
                            tbpBotPose = ftnBotTurn(tbpBotPose, False, tbpTargetPose)
                            subWait(1000)
                            NativeMethods.GetAsyncKeyState(Keys.Left)
                        End While
                    Else
                        tbpTargetPose.Orientation = ftnConvertTo360(tbpTargetPose.Orientation + 135)
                        tbpBotPose = ftnBotTurn(tbpBotPose, False, tbpTargetPose)
                    End If
                    If boolSlam Or boolHeroSelected Then
                        While boolManualControl
                            subWait(100)
                        End While
                        If boolSlam Then
                            Dim threadLocalize As New Thread(AddressOf subLocalizeTop)
                            threadLocalize.Start()
                        End If
                    End If
                End If
                If boolHeroSelected And boolManualControl Then
                    subWait(500)
                    boolCollisionDetected = False
                    boolManualControl = False
                    boolCtrlKey = False
                End If
            ElseIf boolManualControl And boolLocalizationInProgress Then
                MsgBox(" Wait for Localization to complete")
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in Form_KeyDown " & ex.ToString)
        End Try
    End Sub

    Private Sub Form_KeyUp(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles MyBase.KeyUp
        Try
            If boolManualControl And Not boolHeroSelected Then
                If (boolManualControl And (boolBotConnected Or (tmiMoveInfo.tomTypeOfMove = TypeOfMove.TURN) Or (tmiMoveInfo.tomTypeOfMove = TypeOfMove.FWD))) Then
                    If Not boolEnableRBPF Then
                        tbpBotPose = ftnBotStop(tbpBotPose, tmiMoveInfo.tbpTargetPose)
                        tmiMoveInfo.tomTypeOfMove = TypeOfMove.NONE
                    End If
                End If
                subWait(500)
                boolCollisionDetected = False
                boolManualControl = False
                boolCtrlKey = False
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in Form_KeyUp " & ex.ToString)
        End Try
    End Sub








    '==================================== Tool Strip  =============================================

    Private Sub picBot_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles picBot.Click
        boolPlaceBot = Not boolPlaceBot
        If boolPlaceBot Then boolPlaceDestination = False
    End Sub

    Private Sub picDestination_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles picDestination.Click
        Try
            boolPlaceDestination = Not boolPlaceDestination
            If boolPlaceDestination Then boolPlaceBot = False
            If boolPlaceDestination Then
                boolStop = False
                Me.picStop.BorderStyle = FormBorderStyle.None
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in picDestination_Click " & ex.ToString)
        End Try
    End Sub


    Private Sub picStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles picStop.DoubleClick
        Try
            If (Me.picStop.BorderStyle = FormBorderStyle.None) Then
                Me.picStop.BorderStyle = FormBorderStyle.Fixed3D
            Else
                Me.picStop.BorderStyle = FormBorderStyle.None
            End If
            boolStop = (Me.picStop.BorderStyle = FormBorderStyle.Fixed3D)
            If boolStop Then
                tbpBotPose = ftnBotStop(tbpBotPose, tmiMoveInfo.tbpTargetPose)
                boolDock = False
                boolDrivingToDestination = False
                strStatusDriving = "STOP mode"
                frmDebug.subWriteLogs(Now() & "    >>>>  STOP button was pushed  >>> ")
                ftnSendCommand("play phrase 'By your command.'")
            Else
                strStatusDriving = ""
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in picStop_Click " & ex.ToString)
        End Try
    End Sub




    Private Sub StatusDriving_Click(sender As Object, e As EventArgs) Handles StatusDriving.Click
        Try
            ftnSendCommand("battery")
            Dim byteCollisionCode1 As Byte = Val(ftnSendCommand("bumper"))
            Select Case byteCollisionCode1
                Case 4
                    subDrawBumperSwitch(tbpBotPose, 0)
                Case 6
                    subDrawBumperSwitch(tbpBotPose, -45)
                Case 5
                    subDrawBumperSwitch(tbpBotPose, 45)
                Case 3
                    subDrawBumperSwitch(tbpBotPose, 180)
                Case Else
            End Select
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in StatusDriving_Click " & ex.ToString)
        End Try
    End Sub


    Private Sub mnuHelpContents_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuHelpContents.Click
        Process.Start("GotABot User Manual.pdf")
    End Sub

    Private Sub HelpToolStripButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles HelpToolStripButton.Click
        If NativeMethods.GetAsyncKeyState(Keys.RShiftKey) Then   ' Test Code
            Dim sngmax As Single = 0
            Dim sngmin As Single = 0
            tmiMoveInfo.timeMoveCommandSent = Now()
            For i = 1 To 1000000
                Dim sngResult As Single = ftnGenerateGaussian()
                If (sngResult > sngmax) Then sngmax = sngResult
                If (sngResult < sngmin) Then sngmin = sngResult
            Next
            frmDebug.subWriteLogs(" ftnGenerateGaussian Time = " & ftnElapsedTimeS() / 1000000)
            frmDebug.subWriteLogs(" ftnGenerateGaussian max = " & sngmax)
            frmDebug.subWriteLogs(" ftnGenerateGaussian min = " & sngmin)
        ElseIf NativeMethods.GetAsyncKeyState(Keys.LShiftKey) Then   ' Test Code
            MsgBox(SystemInformation.PowerStatus.BatteryChargeStatus.ToString)
            ftnGetScanVectors()
            Dim tbpTargetPose As typeBotPose = tbpBotPose
            tbpTargetPose.Location = ftnLocationFromEstimatedPose(tbpBotPose, 10, 66)
            frmDebug.subWritePose("       tbpTargetPose = ", tbpTargetPose)
            tmiMoveInfo.boolBotIsMoving = False
            Dim trvScnner As typeRangeVector = ftnScannerObstacleVector(tbpBotPose, tbpBotPose, tbpTargetPose, TypeOfMove.CURVE)
            MsgBox(" trvScnner = " & trvScnner.sngRange & " @ " & trvScnner.sngAngle & " degrees.")
            trvScnner = ftnObstacleVectorTop(tbpBotPose, TypeOfMove.CURVE, tbpBotPose, tbpTargetPose)
            MsgBox(" trvScnner2 = " & trvScnner.sngRange & " @ " & trvScnner.sngAngle & " degrees.")
        ElseIf NativeMethods.GetAsyncKeyState(Keys.RShiftKey) Then   ' Test Code
        Else
            Process.Start("GotABot User Manual.pdf")
        End If
    End Sub





    '==================================== WatchDog - Dock, API Disconnect  =============================================
    Dim boolHeroDisplay1 As Boolean = False
    Private Sub timerWatchDog_Tick(sender As System.Object, e As System.EventArgs) Handles timerWatchDog.Tick
        ' check if APIs are communicating
        ' check if compass attached
        ' check battery voltages and Dock if required
        Try
            If Not tmiMoveInfo.boolBotIsMoving And Not boolLocalizationInProgress And Not boolShutDown And Not boolDock Then
                timerWatchDog.Enabled = False
                subCheckForAPITimeout()
                If boolPhidgetsInstalled Then
                    If (frmSpatial.spatial IsNot Nothing) Then boolCompassAttached = ftnCompassAttached()
                End If
                ftnSendCommand("battery")  'Recheck
                If boolHeroSelected And boolHeroDisplay1 And Not tmiMoveInfo.boolBotIsMoving Then
                    ftnHero_Communicate("GD08374F051D88", ">", 1000) ' Write "-Hero-" to robot's display
                    boolHeroDisplay1 = False
                ElseIf boolHeroSelected And Not tmiMoveInfo.boolBotIsMoving Then
                    ftnHero_Communicate("GD085E1D707D88", ">", 1000) ' Write "-Gota-" to robot's display
                    boolHeroDisplay1 = True
                End If
                If (strStatusBotVoltage = "   ??   ") Or CBool(InStr(strStatusBotVoltage, "--")) Then sngBotBatteryVoltage = sngDockTriggerBot
                If boolDock And ((sngBotBatteryVoltage > sngDockTriggerBot * 1.05) And ((sngLaptopBatteryPercent > intDockTriggerPC * 1.1) Or (SystemInformation.PowerStatus.BatteryChargeStatus = BatteryChargeStatus.Charging))) Then
                    boolDock = False
                ElseIf Not boolDock And ((sngBotBatteryVoltage < sngDockTriggerBot) Or ((sngLaptopBatteryPercent < intDockTriggerPC) And Not (SystemInformation.PowerStatus.BatteryChargeStatus = BatteryChargeStatus.Charging))) Then
                    If Not tmiMoveInfo.boolBotIsMoving And ((sngBotBatteryVoltage < sngDockTriggerBot) Or
                           (sngLaptopBatteryPercent < intDockTriggerPC)) And Not (SystemInformation.PowerStatus.BatteryChargeStatus = BatteryChargeStatus.Charging) And Not boolSimulatedMovement Then
                        subWait(1000)
                        ftnSendCommand("battery")  'Recheck
                        If (strStatusBotVoltage = "   ??   ") Then sngBotBatteryVoltage = sngDockTriggerBot
                        If boolBotConnected And Not tmiMoveInfo.boolBotIsMoving And ((sngBotBatteryVoltage < sngDockTriggerBot) Or (sngLaptopBatteryPercent < intDockTriggerPC)) Then
                            subWait(1000)
                            ftnSendCommand("battery")  'Recheck
                            If (strStatusBotVoltage = "   ??   ") Then sngBotBatteryVoltage = sngDockTriggerBot
                            If Not boolDock And Not boolCollisionDetected And ((sngBotBatteryVoltage < sngDockTriggerBot) Or (sngLaptopBatteryPercent < intDockTriggerPC)) Then
                                mnuDock.Checked = True
                                boolStop = False
                                boolPause = False
                                Dim threadDock As New Thread(AddressOf frmDock.subDock)
                                threadDock.Start()
                            End If
                        End If
                    End If
                End If
                If mnuER1Direct.Checked And Not boolBotConnected Then ftnER1_SerialConfig()
                If boolURGConnected Then
                    If Not modIF_URG.boolUrgAccessed Then
                        subUrgLaserOff()
                        classScanner.subUpdateScannerStatusLabel("URG Connected, Laser OFF", Color.Black)
                    Else
                        classScanner.subUpdateScannerStatusLabel("URG Connected, Laser ON", Color.Black)
                    End If
                    Dim availableSerialPorts As System.Collections.ObjectModel.ReadOnlyCollection(Of String) = My.Computer.Ports.SerialPortNames
                    If Not availableSerialPorts.Contains(strURGComPort) Then boolURGConnected = False
                ElseIf boolKinectConnected Then
                    classScanner.subUpdateScannerStatusLabel("Kinect Connected", Color.Black)
                ElseIf boolHeroSelected Then
                    classScanner.subUpdateScannerStatusLabel("Hero Selected", Color.Black)
                Else
                    classScanner.subUpdateScannerStatusLabel("No Scanner", Color.Red)
                End If
                modIF_URG.boolUrgAccessed = False
                If Not boolShutDown And Not boolDrivingToDestination And Not boolLocalizationInProgress Then _
                    boolURGConnected = ftnURGInitializeTop()
                If Not boolShutDown And Not boolURGConnected And Not boolDrivingToDestination And Not boolLocalizationInProgress Then _
                        boolKinectConnected = ftnKinectInitializeTop()
                If Not boolDebugGuiUpdated Then frmDebug.subWriteLogs(" timerWatchDog_Tick:  ERROR ERROR ERROR GUI not updated:  timerGUI.Enabled = " & timerGUI.Enabled)
                boolDebugGuiUpdated = False
                timerWatchDog.Interval = 60000
                If Not boolLocalizationInProgress And Not boolDrivingToDestination And Not boolSlam Then GC.Collect()
                boolEnableCurveMotion = boolER1Selected And (boolKinectConnected Or boolURGConnected)
                boolEnableCourseCorrection = boolER1Selected And (boolKinectConnected Or boolURGConnected)
                boolEnableLocalizationWhileMoving = (boolKinectConnected Or boolURGConnected)
                timerWatchDog.Enabled = True
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in timerWatchDog_Tick: " & ex.ToString)
        End Try
    End Sub


    Function ftnCompassAttached() As Boolean
        Try
            ftnCompassAttached = False
            If (frmSpatial.spatial IsNot Nothing) Then ftnCompassAttached = (frmSpatial.spatial.compassAxes.Count > 0)
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in ftnCompassAttached " & ex.ToString)
        End Try
    End Function

 End Class
'End Module



Class NativeMethods
    Declare Function GetAsyncKeyState Lib "user32" (ByVal vKey As Integer) As Short

End Class



