﻿
Imports System.Globalization
Imports System.IO
Imports System.Math
Imports System.EventArgs
Imports System.Threading
Imports System.Net
Imports System.Drawing


Public Class classScanner

    Private Sub frmScannerConfigure_Load(sender As Object, e As EventArgs) Handles Me.Load
        On Error Resume Next
        Me.Visible = True
        updnOffsetX.Value = tmcScanVectorOffset.X
        updnOffsetY.Value = tmcScanVectorOffset.Y
        sliderScannerRangeCalibrate.Value = sngScannerCalibrate * 100
        sliderScannerDepthCurveAdjust.Value = (sngScannerCurveAdjust + 1) * 100
        updnScannerOffsetDegrees.Value = intScanOffsetDegrees
        chkContinuous.Checked = False
        ftnURGInitializeTop()
        updnScannerOffsetDegrees.Value = intScanOffsetDegrees
        If Not boolURGConnected Then ftnKinectInitializeTop()
    End Sub

    Private Sub updnOffsetX_ValueChanged(sender As Object, e As EventArgs) Handles updnOffsetX.ValueChanged
        On Error Resume Next
        If updnOffsetX.ContainsFocus Then
            tmcScanVectorOffset.X = updnOffsetX.Value
            boolSettingsChanged = True
        End If
    End Sub

    Private Sub updnOffsetY_ValueChanged(sender As Object, e As EventArgs) Handles updnOffsetY.ValueChanged
        On Error Resume Next
        If updnOffsetY.ContainsFocus Then
            tmcScanVectorOffset.Y = updnOffsetY.Value
            boolSettingsChanged = True
        End If
    End Sub

    Private Sub trbRangeCalibrate_Scroll(sender As Object, e As EventArgs) Handles sliderScannerRangeCalibrate.Scroll
        On Error Resume Next
        sngScannerCalibrate = sliderScannerRangeCalibrate.Value / 100
        boolSettingsChanged = True
        subCalculateScanCalCoefficients()
    End Sub


    Private Sub updnScannerOffsetDegrees_ValueChanged(sender As Object, e As EventArgs) Handles updnScannerOffsetDegrees.ValueChanged
        On Error Resume Next
        If updnScannerOffsetDegrees.ContainsFocus Then
            intScanOffsetDegrees = updnScannerOffsetDegrees.Value
            subCalculateScanBeamAngles()
            boolSettingsChanged = True
        End If
    End Sub


    Private Sub sliderScannerDepthCurveAdjust_Scroll(sender As Object, e As EventArgs) Handles sliderScannerDepthCurveAdjust.Scroll
        On Error Resume Next
        If sliderScannerDepthCurveAdjust.ContainsFocus Then
            sngScannerCurveAdjust = sliderScannerDepthCurveAdjust.Value / 100 - 1
            boolSettingsChanged = True
            subCalculateScanCalCoefficients()
        End If
    End Sub

    Private Sub Cancel_Button_Click(sender As Object, e As EventArgs) Handles Cancel_Button.Click
        On Error Resume Next
        Me.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Dim tbpTempPose As typeBotPose = tbpBotPose ' make sure we aren't throwing away important stuff!
        Dim tlmTempLandMarkArray(128) As typeLandMark
        tlmTempLandMarkArray = tlmLandMarkArray
        frmGotABotTop.mnuLoadSettings_Click(sender, e)
        tbpBotPose = tbpTempPose
        tlmLandMarkArray = tlmTempLandMarkArray
        strStatusDriving = ""
        Me.Close()
    End Sub

    Private Sub OK_Button_Click(sender As Object, e As EventArgs) Handles OK_Button.Click
        On Error Resume Next
        Me.Visible = False
        On Error Resume Next
        strStatusDriving = ""
        subCalculateScanBeamAngles()
        subCalculateScanCalCoefficients()
        Me.Close()
    End Sub

    Private Sub me_exit(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Me.FormClosed
        Me.Visible = False
    End Sub


    Delegate Sub DelegateUpdateLabel(ByVal strNewText As String, ByVal colText As Color)
    Public Sub subUpdateScannerStatusLabel(ByVal strNewText As String, ByVal colText As Color)
        Try
            If Me.Visible Then
                If InvokeRequired And Not boolShutDown Then
                    Dim newDelegate As New DelegateUpdateLabel(AddressOf subUpdateScannerStatusLabel)
                    Invoke(newDelegate, New Object() {strNewText, colText})
                ElseIf Not boolShutDown Then
                    tsslScannerStatus.ForeColor = colText
                    tsslScannerStatus.Text = strNewText
                End If '
            End If '
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in subUpdateScannerStatusLabel " & ex.ToString)
        End Try
    End Sub

    '--------------------------------------  MENU BAR   -----------------------------------------------------

    Private Sub mnuDefaultElevation_Click(sender As Object, e As EventArgs) Handles mnuDefaultElevation.Click
        On Error Resume Next
        Dim strDefaultElevation As String
        strDefaultElevation = InputBox("Enter Default Elevation Angle (-27 to 27 degrees) ", "Elevation Angle", Str(intDefaultElevation))
        If strDefaultElevation <> "" And IsNumeric(strDefaultElevation) Then
            intDefaultElevation = Convert.ToInt16(strDefaultElevation)
            If (intDefaultElevation < -27) Then intDefaultElevation = -27
            If (intDefaultElevation > 27) Then intDefaultElevation = 27
            K_Sensor.ElevationAngle() = intDefaultElevation
            boolSettingsChanged = True
        End If
        Me.Refresh()
    End Sub


    Private Sub mnuComboBoxBeams_Click(sender As Object, e As EventArgs) Handles mnuComboBoxBeams.TextChanged
        On Error Resume Next
        intNumberOfBeamsDefault = Val(Me.mnuComboBoxBeams.Text)
        boolSettingsChanged = True
        mnuBeams.Text = "Beams           (" & intNumberOfBeamsDefault & ")"
        If mnuComboBoxBeams.Visible Then
            SettingsToolStripMenuItem.HideDropDown()
        End If
        Me.Refresh()
    End Sub

    Private Sub SettingsToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles SettingsToolStripMenuItem.Click
        On Error Resume Next
        mnuBeams.Text = "Beams           (" & intNumberOfBeamsDefault & ")"
        mnuComboBoxBeams.Text = intNumberOfBeamsDefault
    End Sub


    Public Sub subReportScannerStatus()
        Try
            If boolURGConnected Then
                subUpdateScannerStatusLabel("URG Connected.  ", Color.Black)
                If boolDebugURG Then frmDebug.subWriteLogs(" URG Connected")
            ElseIf boolKinectConnected Then
                subUpdateScannerStatusLabel("Kinect Connected", Color.Black)
            ElseIf boolHeroSelected Then
                subUpdateScannerStatusLabel("Hero Selected", Color.Black)
                If boolDebugHero Then frmDebug.subWriteLogs("Hero Selected")
            Else
                subUpdateScannerStatusLabel("No Scanner", Color.Red)
                If boolDebugKinect And (K_Sensor IsNot Nothing) Then _
                    frmDebug.subWriteLogs(" Kinect Sensor status: " & K_Sensor.Status.ToString)
                If boolDebugKinect Or boolDebugURG Then frmDebug.subWriteLogs("subReportScanner Status:  No Scanner Connected!")
            End If
        Catch ex As Exception
            boolKinectDriversInstalled = False
            frmDebug.subWriteLogs(" EXCEPTION in subReportScannerStatus " & ex.ToString)
        End Try
    End Sub

  
 End Class