﻿Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Drawing
Imports System.Linq
Imports System.Text
Imports System.Windows.Forms
Imports System.Math

Imports Emgu.CV.UI
Imports Emgu.CV
Imports Emgu.CV.Structure
Imports Emgu.CV.CvEnum
'Imports cvextern

Imports DirectShowLib




Public Class frmVideo

    Dim boolTrained As Boolean = False
    Private Face As New HaarCascade("haarcascade_frontalface_alt2.xml")
    Private emcuFont As New Emgu.CV.Structure.MCvFont(CvEnum.FONT.CV_FONT_HERSHEY_COMPLEX, 0.5, 0.5)
    Dim tfrFacesRecognized(10) As typeFaceClassifier


    Public Sub subFaceRecognitionLoad(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Try
            Me.Visible = boolEnableFaceRecognition Or boolEnableVideo
            subPopulateCameraList()
            mnuVidSelectComboBox.Text = "Video Device : " & mnuVidSelectComboBox.Items.Item(intVideoSource).ToString
            ResolutionToolStripMenuItem.Text = "Resolution  " & Str(ticCameraResolution.X) & ", " & Str(ticCameraResolution.Y)
            FieldOfViewToolStripMenuItem.Text = "Field Of View   " & sngCameraFOV.ToString
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in subFaceRecognitionLoad " & ex.ToString)
        End Try
    End Sub

    Public Sub subVideoStart()
        Try
            Me.Visible = boolEnableFaceRecognition Or boolEnableVideo
            mnuVidSelectComboBox.SelectedIndex = intVideoSource
            mnuVidSelectComboBox.Text = "Video Device : " & mnuVidSelectComboBox.Items.Item(intVideoSource).ToString
            boolTrained = modFaceClassifier.ftnClassifierLoad()
            If boolTrained And boolEnableFaceRecognition Then
                message_bar1.Text = "Training Data loaded"
            ElseIf boolEnableFaceRecognition Then
                message_bar1.Text = "No training data found, please train program using Train menu option"
            End If
            If boolEnableFaceRecognition Or boolEnableVideo Then
                subInitializeCapture()
            Else
                subStopCapture()
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in subVideoStart " & ex.ToString)
        End Try
    End Sub

    Private Sub mnuVidSelectComboBox_Click(sender As Object, e As EventArgs) Handles mnuVidSelectComboBox.Click
        Try
            mnuVidSelectComboBox.Items.Clear()
            subPopulateCameraList()
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in mnuVidSelectComboBox_Click " & ex.ToString)
        End Try
    End Sub

    Private Sub VidSelectComboBox1_Change(sender As System.Object, e As System.EventArgs) Handles mnuVidSelectComboBox.TextChanged
        Try
            If mnuVidSelectComboBox.Focused And (boolEnableFaceRecognition Or boolEnableVideo) Then
                intVideoSource = Val(mnuVidSelectComboBox.SelectedIndex)
                mnuVidSelectComboBox.Text = "Video Device : " & mnuVidSelectComboBox.Items.Item(intVideoSource).ToString
                message_bar1.Text = "Video Device : " & mnuVidSelectComboBox.Items.Item(intVideoSource).ToString
                boolSettingsChanged = True
                subInitializeCapture()
                Me.mnuCamera.HideDropDown()
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in VidSelectComboBox1_Change " & ex.ToString)
        End Try
    End Sub


    Sub subPopulateCameraList()
        Try
            Dim ListCamerasData As New List(Of KeyValuePair(Of Integer, String))()    'Find systems cameras with DirectShow.Net dll 
            Dim _SystemCamereas As DsDevice() = DsDevice.GetDevicesOfCat(DirectShowLib.FilterCategory.VideoInputDevice)
            Dim _DeviceIndex As Integer = 0
            For Each _Camera As DirectShowLib.DsDevice In _SystemCamereas
                mnuVidSelectComboBox.Items.Add(New KeyValuePair(Of Integer, String)(_DeviceIndex, _Camera.Name))
                _DeviceIndex += 1
            Next
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in subPopulateCameraList " & ex.ToString)
        End Try
    End Sub

    Dim boolTraining As Boolean = False
    Private Sub trainToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles trainToolStripMenuItem2.Click
        boolEnableFaceRecognition = True
        boolTraining = True
        'subStopCapture()
        frmFaceTraining.subFacetrainLoad(sender, e)
        frmFaceTraining.subStartTraining_Form()
    End Sub


    Public Sub retrain()
        boolTrained = modFaceClassifier.ftnClassifierLoad()
        boolTraining = False
        If boolTrained Then
            message_bar1.Text = "Training Data loaded"
        Else
            message_bar1.Text = "No training data found, please train program using Train menu option"
        End If
    End Sub

    'Camera Start Stop
    Private Sub subInitializeCapture()
        Try
            subStopCapture()
            'If grabber IsNot Nothing Then grabber.Dispose()
            If boolEnableFaceRecognition Or boolEnableVideo Then
                grabber = New Capture(intVideoSource)
                grabber.SetCaptureProperty(Emgu.CV.CvEnum.CAP_PROP.CV_CAP_PROP_FRAME_HEIGHT, ticCameraResolution.Y) ' 
                grabber.SetCaptureProperty(Emgu.CV.CvEnum.CAP_PROP.CV_CAP_PROP_FRAME_WIDTH, ticCameraResolution.X) ' 
                grabber.QueryFrame()
                AddHandler Application.Idle, AddressOf FrameGrabber
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in subInitializeCapture " & ex.ToString)
        End Try
    End Sub

    Private Sub subStopCapture()
        RemoveHandler Application.Idle, AddressOf FrameGrabber
        If grabber IsNot Nothing Then grabber.Dispose()
    End Sub

    Private haar As HaarCascade
    Private imageResult As Image(Of Gray, Byte)
    Private grabber As Capture
    Dim currentFrame As Image(Of Bgr, [Byte])
    Sub FrameGrabber(sender As Object, e As EventArgs)
        Try
            If boolEnableVideo And Me.Visible Then
                RemoveHandler Application.Idle, AddressOf FrameGrabber
                currentFrame = grabber.QueryFrame()    'Get the current frame from capture device
                currentFrame = currentFrame.Resize(480 * currentFrame.Width / currentFrame.Height, 480, INTER.CV_INTER_NN)
                If boolEnableFaceRecognition And currentFrame IsNot Nothing Then subFaceRecognition()

                Me.picVideo.Image = currentFrame.ToBitmap()
                AddHandler Application.Idle, AddressOf FrameGrabber
                GC.Collect()
            End If
        Catch ex As Exception
            Me.picVideo.Image = currentFrame.ToBitmap()
            subStopCapture()
            subInitializeCapture()
            frmDebug.subWriteLogs(" EXCEPTION in FrameGrabber " & ex.ToString)
            GC.Collect()
        End Try
    End Sub

    Public Sub subFaceRecognition()
        Try
            If Me.Visible Then
                Dim grayframe As Image(Of Gray, [Byte]) = currentFrame.Convert(Of Gray, [Byte])()
                Dim faces As MCvAvgComp()() = grayframe.DetectHaarCascade(Face, 1.3, 4, Emgu.CV.CvEnum.HAAR_DETECTION_TYPE.DO_CANNY_PRUNING, New Size(20, 20))
                '  see http://fewtutorials.bravesites.com/entries/emgu-cv-c/level-3c---how-to-improve-face-detection'
                If faces IsNot Nothing Then
                    Dim intName As Short = 0
                    Dim tfrFacesRecognizedTemp(10) As typeFaceClassifier
                    For Each FaceDetected In faces(0) ' As MCvAvgComp
                        imageResult = currentFrame.Copy(FaceDetected.rect).Convert(Of Gray, Byte)().Resize(100, 100, Emgu.CV.CvEnum.INTER.CV_INTER_CUBIC)
                        imageResult._EqualizeHist()
                        currentFrame.Draw(FaceDetected.rect, New Bgr(Color.Red), 2)        'draw the face detected in the 0th (gray) channel
                        If boolTraining Or frmFaceTraining.boolRECORD Then
                            frmFaceTraining.picbxFaceTraining.Image = imageResult.ToBitmap()
                            If frmFaceTraining.boolRECORD AndAlso faces.Length > 0 AndAlso frmFaceTraining.resultImages.Count < frmFaceTraining.intNumFacesToAquire Then
                                frmFaceTraining.resultImages.Add(imageResult)
                                frmFaceTraining.lblCount.Text = "Count: " + frmFaceTraining.resultImages.Count.ToString()
                                Beep()
                                subWait(1000)
                                If frmFaceTraining.resultImages.Count = frmFaceTraining.intNumFacesToAquire Then
                                    For i As Integer = 0 To frmFaceTraining.resultImages.Count - 1
                                        frmFaceTraining.picbxFaceTraining.Image = frmFaceTraining.resultImages(i).ToBitmap()
                                        If Not frmFaceTraining.ftnSaveTrainingData(frmFaceTraining.picbxFaceTraining.Image) Then
                                            MessageBox.Show("Error", "Error in saving file info. Training data not saved", MessageBoxButtons.OK, MessageBoxIcon.[Error])
                                        End If
                                        subWait(100)
                                    Next
                                    boolEnableFaceRecognition = False
                                    frmFaceTraining.btnAddImage.Enabled = True
                                    frmFaceTraining.btnNextImage.Visible = True
                                    frmFaceTraining.btnPrevImage.Visible = True
                                    frmFaceTraining.lblCount.Visible = False
                                    frmFaceTraining.btnSingle.Visible = True
                                    frmFaceTraining.btnAddAll.Visible = True
                                    frmFaceTraining.boolRECORD = False
                                End If
                            End If
                        End If
                        tfrFacesRecognizedTemp(intName).X = (FaceDetected.rect.X + FaceDetected.rect.Width / 2)
                        tfrFacesRecognizedTemp(intName).Y = FaceDetected.rect.Y + FaceDetected.rect.Height / 2
                        tfrFacesRecognizedTemp(intName).intSize = FaceDetected.rect.Height + FaceDetected.rect.Width
                        If boolTrained Then         'draw the face detected and name
                            tfrFacesRecognizedTemp(intName).strFaceName = modFaceClassifier.ftnClassifierRecognize(imageResult)
                            currentFrame.Draw(tfrFacesRecognizedTemp(intName).strFaceName, emcuFont, New Point(FaceDetected.rect.X - 2, FaceDetected.rect.Y - 2), New Bgr(Color.LightGreen))
                        Else
                            tfrFacesRecognizedTemp(intName).strFaceName = "??"
                        End If
                        intName += 1
                        intName = Min(intName, 9)
                    Next FaceDetected
                    tfrFacesRecognized = tfrFacesRecognizedTemp
                Else
                    tfrFacesRecognized(0).strFaceName = ""
                End If
                grayframe.Dispose()
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in subFaceRecognition " & ex.ToString)
        End Try
    End Sub


    Private Sub exitToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles exitToolStripMenuItem4.Click
        subFaceExit(sender, e)
    End Sub


    Sub subFaceExit(sender As Object, e As EventArgs) Handles Me.FormClosing
        Try
            boolEnableFaceRecognition = False
            boolEnableVideo = False
            frmGotABotTop.mnuFaceRecognition.Checked = False
            frmGotABotTop.mnuVideo.Checked = False
            subStopCapture()
            RemoveHandler Application.Idle, AddressOf FrameGrabber
            Me.Dispose()
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in subFaceExit " & ex.ToString)
        End Try
    End Sub

    Private Sub subInitializeComponent()

    End Sub

    Public Function ftnGetFaceResults() As typeFaceClassifier()
        Try
            ftnGetFaceResults = tfrFacesRecognized
        Catch ex As Exception
            ftnGetFaceResults = tfrFacesRecognized
            frmDebug.subWriteLogs(" EXCEPTION in ftnGetFaceResults " & ex.ToString)
        End Try
    End Function


    Private Sub ResolutionToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles ResolutionToolStripMenuItem.Click
        Try
            Dim strCameraResolution As String
            strCameraResolution = InputBox("Enter Camera Resolution in the form 640, 480", "Camera Resolution", Str(ticCameraResolution.X) & ", " & Str(ticCameraResolution.Y))
            strCameraResolution &= " , 640, 480"
            Dim strParsedText As String() = strCameraResolution.Split(","c)
            ticCameraResolution.X = Convert.ToInt16(strParsedText(0))
            ticCameraResolution.Y = Convert.ToInt16(strParsedText(1))
            boolSettingsChanged = True
            ResolutionToolStripMenuItem.Text = "Resolution  " & Str(ticCameraResolution.X) & ", " & Str(ticCameraResolution.Y)
            mnuCamera.ShowDropDown()
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in ResolutionToolStripMenuItem_Click " & ex.ToString)
        End Try
    End Sub

    Private Sub FieldOfViewToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles FieldOfViewToolStripMenuItem.Click
        Try
            Dim strCameraFOV As String
            strCameraFOV = InputBox("Enter Camera Field Of View ", "Camera FOV", Str(sngCameraFOV))
            If strCameraFOV <> "" And IsNumeric(strCameraFOV) Then
                sngCameraFOV = Convert.ToSingle(strCameraFOV)
            End If
            boolSettingsChanged = True
            FieldOfViewToolStripMenuItem.Text = "Field Of View   " & sngCameraFOV.ToString
            mnuCamera.ShowDropDown()
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in FieldOfViewToolStripMenuItem_Click " & ex.ToString)
        End Try
    End Sub
End Class