﻿
Imports System.Drawing
Imports System.Math

Partial Public Class classArm
    'Module modArmDraw

    Public Sub subDrawArm()
        Try
            Const constWristToGripper = 108
            If Not InvokeRequired Then
                pbbArm.CreateGraphics.Clear(Color.LightGray)
                subDrawArmVector(tjcJointCoordinates.tpcShoulder, tjcJointCoordinates.tpcShoulder, constShoulderSegment, False)
                subDrawArmVector(tjcJointCoordinates.tpcShoulder, tjcJointCoordinates.tpcElbow, constShoulderSegment, False)
                subDrawArmVector(tjcJointCoordinates.tpcElbow, tjcJointCoordinates.tpcWristRotateB4Offset, constElbowSegment, False)
                subDrawArmVector(tjcJointCoordinates.tpcWristRotateB4Offset, tjcJointCoordinates.tpcWrist, constWristRSegment, False)
                Dim tpcGripperStart As typePointCoordinate = ftnPointFromPoint(tjcJointCoordinates.tpcWrist, taaArmAngles.sngGripperOpening / 2, taaArmAngles.sngWrist + 90)
                subDrawArmVector(tjcJointCoordinates.tpcWrist, tpcGripperStart, constGripperSegment, False)
                Dim tpcGripperTip As typePointCoordinate = ftnPointFromPoint(tpcGripperStart, constWristToGripper, taaArmAngles.sngWrist)
                subDrawArmVector(tpcGripperStart, tpcGripperTip, constGripperSegment, False)
                tpcGripperStart = ftnPointFromPoint(tjcJointCoordinates.tpcWrist, taaArmAngles.sngGripperOpening / 2, taaArmAngles.sngWrist - 90)
                subDrawArmVector(tjcJointCoordinates.tpcWrist, tpcGripperStart, constGripperSegment, False)
                tpcGripperTip = ftnPointFromPoint(tpcGripperStart, constWristToGripper, taaArmAngles.sngWrist)
                subDrawArmVector(tpcGripperStart, tpcGripperTip, constGripperSegment, False)
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in subDrawArm " & ex.ToString)
        End Try
    End Sub


    Public Sub subDrawArmVector(ByVal tpcStartCoordinate As typePointCoordinate, ByVal tpcEndCoordinate As typePointCoordinate, ByVal intArmSegment As Short, ByVal boolError As Boolean)    ' Draw a vector from point-point
        Try
            If Not InvokeRequired Then
                tpcStartCoordinate.X += pbbArm.Width * 0.25
                tpcStartCoordinate.Z += pbbArm.Height * 0.5
                tpcStartCoordinate.Z = pbbArm.Height - tpcStartCoordinate.Z
                tpcEndCoordinate.X += pbbArm.Width * 0.25
                tpcEndCoordinate.Z += pbbArm.Height * 0.5
                tpcEndCoordinate.Z = pbbArm.Height - tpcEndCoordinate.Z
                If boolError Then
                    Dim widePen As New Pen(Brushes.Crimson)
                    widePen.Width = 8.0F
                    pbbArm.CreateGraphics.DrawLine(widePen, tpcStartCoordinate.X, tpcStartCoordinate.Z, tpcEndCoordinate.X, tpcEndCoordinate.Z)
                ElseIf (intArmSegment = intArmSegmentSelect) Then
                    Dim widePen As New Pen(Brushes.Green)
                    widePen.Width = 8.0F
                    pbbArm.CreateGraphics.DrawLine(widePen, tpcStartCoordinate.X, tpcStartCoordinate.Z, tpcEndCoordinate.X, tpcEndCoordinate.Z)
                Else
                    Dim widePen As New Pen(Brushes.Black)
                    widePen.Width = 8.0F
                    pbbArm.CreateGraphics.DrawLine(widePen, tpcStartCoordinate.X, tpcStartCoordinate.Z, tpcEndCoordinate.X, tpcEndCoordinate.Z)
                End If
                subDrawSmallCircleArm(tpcEndCoordinate, True)
                pbbArm.CreateGraphics.Flush()
                pbbArm.CreateGraphics.Dispose()
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION In subDrawArmVector " & ex.ToString)
        End Try
    End Sub

    Sub subDrawSmallCircleArm(ByVal tpcCoordinate As typePointCoordinate, ByVal boolBlue As Boolean)    ' Draw a small circle 
        Try
            If Not InvokeRequired Then
                If Not (tpcCoordinate.X = 0 And tpcCoordinate.Z = 0) And boolBlue Then
                    pbbArm.CreateGraphics.DrawArc(Pens.Blue, tpcCoordinate.X - 12, tpcCoordinate.Z - 12, 24, 24, 0, 360)
                    pbbArm.CreateGraphics.FillEllipse(Brushes.Blue, tpcCoordinate.X - 12, tpcCoordinate.Z - 12, 24, 24)
                ElseIf Not (tpcCoordinate.X = 0 And tpcCoordinate.Z = 0) Then
                    pbbArm.CreateGraphics.DrawArc(Pens.Green, tpcCoordinate.X - 12, tpcCoordinate.Z - 12, 24, 24, 0, 360)
                    pbbArm.CreateGraphics.FillEllipse(Brushes.Green, tpcCoordinate.X - 12, tpcCoordinate.Z - 12, 24, 24)
                End If
                pbbArm.CreateGraphics.Flush()
                pbbArm.CreateGraphics.Dispose()
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION In subDrawSmallCircleArm " & ex.ToString)
        End Try
    End Sub




    'End Module
End Class