﻿

Imports System.Math
Imports System.Drawing


Partial Public Class classArm



    Public Sub subInitializeDynamixels()
        Try
            If (dxl_initialize(constDefaultPortNum, constDefaultBaudNum) = 0) Then
                tsslArmStatus.ForeColor = Color.Red
                tsslArmStatus.Text = "Simulated"
                If Not boolArmSimulationMode Then
                    taaArmAngles.sngShoulder = 100
                    taaArmAngles.sngElbow = 0
                    taaArmAngles.sngWrist = taaArmAngles.sngElbow   '
                    taaArmAngles.sngWristRotate = taaArmAngles.sngElbow
                End If
                boolArmSimulationMode = True
            Else
                boolArmSimulationMode = False
                tsslArmStatus.ForeColor = Color.Green
                tsslArmStatus.Text = "Operating"
                dxl_write_byte(5, constCWComplianceMargin, 4)  ' Dual Dynamixel Joint.  Dont fight other dynamixel
                dxl_write_byte(4, constCWComplianceMargin, 4)  ' Dual Dynamixel Joint.  Dont fight other dynamixel
                dxl_write_byte(2, constCWComplianceMargin, 4)  ' Dual Dynamixel Joint.  Dont fight other dynamixel
                dxl_write_byte(3, constCWComplianceMargin, 4)  ' Dual Dynamixel Joint.  Dont fight other dynamixel
                dxl_write_word(2, constMovingSpeed, 50)  ' Shoulder = Slow Moving Speed 
                dxl_write_word(3, constMovingSpeed, 50)  ' Shoulder = Slow Moving Speed 
                dxl_write_word(4, constMovingSpeed, 100)  ' Elbow = Slow Moving Speed 
                dxl_write_word(5, constMovingSpeed, 100)  ' Elbow = Slow Moving Speed 
            End If
            taaArmAngles = ftnForwardKinematicsAngles()
            tjcJointCoordinates = ftnForwardKinematicsCoordinates(taaArmAngles)
            subDrawArm()
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION In subInitializeDynamixels " & ex.ToString)
        End Try
    End Sub


    Public Function ftnSetShoulderPosition(ByVal intPosition As Short) As Boolean
        ftnSetShoulderPosition = ftnSetDynamixelPosition(2, 1024 - intPosition) And ftnSetDynamixelPosition(3, intPosition)
        taaArmAngles.sngShoulder = ftnPositionToDegree(intPosition)
        tjcJointCoordinates = ftnForwardKinematicsCoordinates(taaArmAngles)
        If booldebugArm Then frmDebug.subWriteLogs(" ftnSetShoulderPosition: taaArmAngles.sngShoulder = " & taaArmAngles.sngShoulder)
    End Function

    Public Function ftnSetElbowPosition(ByVal intPosition As Short) As Boolean
        On Error Resume Next
        ftnSetElbowPosition = ftnSetDynamixelPosition(4, intPosition) And ftnSetDynamixelPosition(5, 1024 - intPosition)
        taaArmAngles.sngElbow = ftnPositionToDegree(intPosition) + taaArmAngles.sngShoulder
        taaArmAngles.sngWristRotate = taaArmAngles.sngElbow
        taaArmAngles.sngWrist = taaArmAngles.sngElbow
        tjcJointCoordinates = ftnForwardKinematicsCoordinates(taaArmAngles)
        If booldebugArm Then frmDebug.subWriteLogs(" ftnSetElbowPosition: taaArmAngles.sngElbow = " & taaArmAngles.sngElbow)
    End Function


    Public Function ftnSetWristRotatePosition(ByVal intPosition As Short) As Boolean
        On Error Resume Next
        ftnSetWristRotatePosition = ftnSetDynamixelPosition(6, intPosition)
    End Function

    Public Function ftnSetGripperPosition(ByVal intPosition As Short) As Boolean
        On Error Resume Next
        ftnSetGripperPosition = ftnSetDynamixelPosition(7, intPosition)
     End Function

    Public Function ftnSetDynamixelPosition(ByVal intID As Short, ByVal intPosition As Short) As Boolean
        Try
            ftnSetDynamixelPosition = False
            If booldebugArm Then frmDebug.subWriteLogs(" ftnSetDynamixelPosition: intID = " & intID & ", intPosition = " & intPosition)
            If (intPosition > 1023) Then intPosition = 1023
            If (intPosition < 0) Then intPosition = 0
            If Not boolArmSimulationMode Then
                dxl_write_word(intID, constGoalPosition, intPosition)
                ftnSetDynamixelPosition = (dxl_get_result() = COMM_RXSUCCESS) And Not (dynamixel.dxl_get_rxpacket_error(dynamixel.ERRBIT_OVERLOAD) = 1) And Not (dynamixel.dxl_get_rxpacket_error(dynamixel.ERRBIT_OVERHEAT) = 1)
                timeJointMove(intID) = Now()
                If Not ftnSetDynamixelPosition Then
                    dxl_write_word(intID, constGoalPosition, dxl_read_word(intID, constPresentPosition))
                    dxl_write_word(intID, constTorqueLimit, dxl_read_word(intID, constTorqueMax))
                    subHighlightDynamixelError(intID)
                End If
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION In ftnSetDynamixelPosition " & ex.ToString)
        End Try
    End Function

    Sub subDisplayDynamixelValues(ByVal intID As Short)   'UNUSED
        Try
            MsgBox("ERROR:  " & vbCrLf & _
        "Goal (R) = " & dxl_read_word(intID, constGoalPosition) & vbCrLf & _
        "Present Position = " & dxl_read_word(intID, constPresentPosition) & vbCrLf & _
        "Speed = " & dxl_read_word(intID, 32) & vbCrLf & _
        "CW Angle Limit = " & dxl_read_word(intID, 6) & vbCrLf & _
        "CCW Angle Limit = " & dxl_read_word(intID, 8) & vbCrLf & _
        "CW Compliance = " & dxl_read_byte(intID, 26) & vbCrLf & _
        "CCW Compliance = " & dxl_read_byte(intID, 27) & vbCrLf & _
        "Torque Limit = " & dxl_read_word(intID, constTorqueLimit) & vbCrLf & _
        "Torque Enable = " & dxl_read_byte(intID, 24) & vbCrLf & _
        "Timeout = " & (dxl_get_result() = COMM_RXTIMEOUT) & vbCrLf & _
        "High limit T = " & dxl_read_byte(intID, 11) & vbCrLf & _
       "Temperature = " & dxl_read_byte(intID, 43) & vbCrLf & _
        "Low limit V = " & dxl_read_byte(intID, 12) & vbCrLf & _
        "High limit V = " & dxl_read_byte(intID, 13) & vbCrLf & _
        "Voltage = " & dxl_read_byte(intID, 42) & _
        "Alarm Shutdown = " & dxl_read_byte(intID, constAlarmShutDown))
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION In subDisplayDynamixelValues " & ex.ToString)
        End Try
    End Sub

    Public Sub subHighlightDynamixelError(ByVal intID As Short)
        Try
            timerUpdate.Enabled = False
            Select Case intID
                Case 2
                    subDrawArmVector(tjcJointCoordinates.tpcShoulder, tjcJointCoordinates.tpcElbow, constShoulderSegment, True)
                Case 3
                    subDrawArmVector(tjcJointCoordinates.tpcShoulder, tjcJointCoordinates.tpcElbow, constShoulderSegment, True)
                Case 4
                    subDrawArmVector(tjcJointCoordinates.tpcElbow, tjcJointCoordinates.tpcWristRotate, constElbowSegment, True)
                Case 5
                    subDrawArmVector(tjcJointCoordinates.tpcElbow, tjcJointCoordinates.tpcWristRotate, constElbowSegment, True)
                Case 6
                    subDrawArmVector(tjcJointCoordinates.tpcWristRotate, tjcJointCoordinates.tpcWrist, constWristRSegment, True)
                Case 7
                    subDrawArmVector(tjcJointCoordinates.tpcWrist, tjcJointCoordinates.tpcGripperEnd, constGripperSegment, True)
                Case 8
                    subDrawArmVector(tjcJointCoordinates.tpcShoulderBase, tjcJointCoordinates.tpcShoulder, constShoulderSegment, True)
                Case 9
                    subDrawArmVector(tjcJointCoordinates.tpcWrist, tjcJointCoordinates.tpcGripperEnd, constWristSegment, True)
                Case Else
            End Select
            frmDebug.subWriteLogs(" subHighlightDynamixelError:  intID =  " & intID)
            timerUpdate.Enabled = True
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION In subHighlightDynamixelError " & ex.ToString)
        End Try
    End Sub

    Public Function ftnGetJointAngle(ByVal intID As Short) As Single
        Try
            If Not boolArmSimulationMode Then
                ftnGetJointAngle = ftnPositionToDegree(dxl_read_word(intID, constPresentPosition))
                If (intID = 7) Then
                    If (ftnGetJointAngle < constGripperOpenPosition) Then ftnGetJointAngle = constGripperOpenPosition + (constGripperOpenPosition - ftnGetJointAngle)
                    ftnGetJointAngle = (constGripperClosedPosition - ftnGetJointAngle) * 55 / (constGripperClosedPosition - constGripperOpenPosition) ' note - opening is in mm, not radians
                End If
            Else
                Select Case intID
                    Case 2
                        ftnGetJointAngle = ftnConvertTo180(taaArmAngles.sngShoulder)
                    Case 3
                        ftnGetJointAngle = ftnConvertTo180(taaArmAngles.sngShoulder)
                    Case 4
                        ftnGetJointAngle = ftnConvertTo180(taaArmAngles.sngElbow - taaArmAngles.sngShoulder)
                    Case 5
                        ftnGetJointAngle = ftnConvertTo180(taaArmAngles.sngElbow - taaArmAngles.sngShoulder)
                    Case 6
                        ftnGetJointAngle = ftnConvertTo180(taaArmAngles.sngElbow - taaArmAngles.sngShoulder)
                    Case 7
                        ftnGetJointAngle = taaArmAngles.sngGripperOpening
                    Case 8
                    Case 9
                    Case Else
                End Select
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION In ftnGetJointAngle " & ex.ToString)
        End Try
    End Function

    Function ftnPositionToDegree(ByVal intPosition As Short) As Single
        On Error Resume Next
        ftnPositionToDegree = ftnConvertTo180(intPosition * 300 / 1024 - 150)  ' 
    End Function

    Function ftnDegreeToPosition(ByVal sngDegree As Single) As Short
        On Error Resume Next
        ftnDegreeToPosition = (ftnConvertTo180(sngDegree) + 150) / 300 * 1024   ' 
    End Function



End Class
