﻿
Imports System.Math
Imports System.Threading
Imports System.Drawing


Public Module modCourseCorrection


    Public Class classCourseCorrection

        Public Sub subCourseCorrection_Top()
            Try
                Dim boolValidLocation As Boolean
                Dim timeLocalizationStart As DateTime
                Dim intLocalizationsWhileMoving As Short = 0
                Dim tbpScanPose As typeBotPose
                Dim tmiMoveInfoLocal As typeMoveInfo
                Thread.CurrentThread.Name = "threadCourseCorrection"
                While Not boolShutDown
                    If Not boolSimulatedMovement And boolEnableCourseCorrection _
                        And Not boolStop And Not boolEnableRBPF And Not boolSlam And Not boolPause Then '
                        tmiMoveInfoLocal = ftnGetMoveInfo()
                        While tmiMoveInfoLocal.boolBotIsMoving
                            If (tmiMoveInfoLocal.tomTypeOfMove <> TypeOfMove.TURN) Then ' Localize While Moving
                                If (ftnDistanceBetweenLocations(tmiMoveInfoLocal.tbpStartingPose.Location, tbpBotPose.Location) > sngBotLinearAccelerationDistance) Then '  
                                    timeLocalizationStart = Now()
                                    intLocalizationsWhileMoving += 1
                                    tbpScanPose = ftnLocalizeFrom2DScan_Top(tbpBotPose, tbpBotPose, True, boolValidLocation, 0)
                                    If boolDebugCC Then frmDebug.subWriteLogs(ftnElapsedTimeS() & _
                                        "subCourseCorrection_Top:       tbpScanPose = " & tbpScanPose.Location.X & ", " & tbpScanPose.Location.Y & " at " & _
                                        tbpScanPose.Orientation & " degrees.  boolValidLocation = " & boolValidLocation)
                                    If boolValidLocation Then _
                                          subCourseCorrect(timeLocalizationStart, tbpScanPose)
                                End If
                            Else
                                subWait(50)
                            End If
                            tmiMoveInfoLocal = ftnGetMoveInfo()
                        End While  ' tmiMoveInfoLocal.boolBotIsMoving
                        If boolDebugCC Then
                            If boolEnableCourseCorrection And (intLocalizationsWhileMoving > 0) Then _
                                frmDebug.subWriteLogs(vbCrLf & ">>> 2D Localized While Moving " & intLocalizationsWhileMoving & " times.   ")
                        End If
                        intLocalizationsWhileMoving = 0
                        Thread.Sleep(200)
                    Else
                        Thread.Sleep(500)
                    End If
                End While  ' Not boolShutDown
            Catch ex As Exception
                frmDebug.subWriteLogs(" EXCEPTION in subCourseCorrection_Top " & ex.ToString)
            End Try
        End Sub

        Dim sngCcDelayS As Single = 0.4  ' Delay from Start of timeLocalizationStart to time of new move issued
        Sub subCourseCorrect(ByRef timeLocalizationStart As DateTime, ByRef tbpScanPose As typeBotPose)
            Try
                Thread.CurrentThread.Priority = ThreadPriority.Highest
                If boolEnableCourseCorrection And tmiMoveInfo.boolBotIsMoving And Not boolStop And Not boolShutDown And Not tmiMoveInfo.boolMoveCommandInProgress Then ' 
                    If (ftnDistanceBetweenLocations(tmiMoveInfo.tbpTargetPose.Location, tbpBotPose.Location) > (sngBotLinearAccelerationDistance + ftnCmToInches(sngBotLinearVelocity) * sngCcDelayS)) Then ' course correction is possible 
                        Dim tbpDR As typeBotPose = ftnLocalizeUsingDeadReckoning(tbpBotPose, 0, False)
                        Dim tbpStartingPoseDR As typeBotPose = ftnLocalizeUsingDeadReckoning(tbpBotPose, -sngCcDelayS, False) ' Predict where the Bot will be when the move correction is issued
                        Dim tbpStartingPosePlanned As typeBotPose = tbpScanPose
                        tbpStartingPosePlanned.Location.X += tbpStartingPoseDR.Location.X - tbpDR.Location.X
                        tbpStartingPosePlanned.Location.Y += tbpStartingPoseDR.Location.Y - tbpDR.Location.Y
                        tbpStartingPosePlanned.Orientation = ftnConvertTo360(tbpScanPose.Orientation + tbpStartingPoseDR.Orientation - tbpDR.Orientation)
                        Dim tbpNexttarget As typeBotPose = ftnFindTargetPose(tbpStartingPosePlanned, tmcDestination)
                        Dim tomTypeOfMoveCorrection As TypeOfMove = ftnTypeOfMove(tbpStartingPosePlanned, tbpNexttarget)
                        If (ftnDistanceBetweenLocations(tbpNexttarget.Location, tbpStartingPosePlanned.Location) > sngBotLinearAccelerationDistance) And _
                            (tomTypeOfMoveCorrection <> TypeOfMove.TURN) And Not tmiMoveInfo.boolMoveCommandInProgress And _
                            Not ftnLocationsEqual(tbpStartingPosePlanned.Location, tmiMoveInfo.tbpStartingPose.Location) Then ' perform course correction
                            If boolDebugCC Then
                                frmDebug.subWriteLogs(ftnElapsedTimeS() & " ##############  Course Correction:  ##############  ")
                                frmDebug.subWriteLogs("       tbpDR =                    " & tbpDR.Location.X & ", " & tbpDR.Location.Y & " at " & tbpDR.Orientation & " degrees.")
                                frmDebug.subWriteLogs("       tbpStartingPoseDR =  " & tbpStartingPoseDR.Location.X & ", " & tbpStartingPoseDR.Location.Y & " at " & tbpStartingPoseDR.Orientation & " degrees.")
                                frmDebug.subWriteLogs("       ScanPose =                 " & tbpScanPose.Location.X & ", " & tbpScanPose.Location.Y & " at " & tbpScanPose.Orientation & " degrees.")
                                frmDebug.subWriteLogs("       tbpStartingPosePlanned =   " & tbpStartingPosePlanned.Location.X & ", " & tbpStartingPosePlanned.Location.Y & " at " & tbpStartingPosePlanned.Orientation & " degrees.")
                                frmDebug.subWriteLogs("       tbpNexttarget =            " & tbpNexttarget.Location.X & ", " & tbpNexttarget.Location.Y & " at " & tbpNexttarget.Orientation & " degrees.")
                                frmDebug.subWriteLogs("       sngCcDelayS = " & sngCcDelayS)
                            End If
                            Select Case tomTypeOfMoveCorrection  ' start move correction
                                Case TypeOfMove.FWD
                                    ftnBotFwd(tbpStartingPosePlanned, tbpNexttarget)
                                    sngCcDelayS = (sngCcDelayS + Now().Subtract(timeLocalizationStart).TotalSeconds - Now().Subtract(tmiMoveInfo.timeMoveCommandSent).TotalSeconds) / 2
                                Case TypeOfMove.CURVE
                                    tbpNexttarget = ftnCurve_DR(tbpStartingPosePlanned, 99999, tbpNexttarget, False) ' Calculate the orientation
                                    ftnBotCurve(tbpStartingPosePlanned, tbpNexttarget)
                                    sngCcDelayS = (sngCcDelayS + Now().Subtract(timeLocalizationStart).TotalSeconds - Now().Subtract(tmiMoveInfo.timeMoveCommandSent).TotalSeconds) / 2
                                Case TypeOfMove.HALT
                                    ftnBotStop(tbpStartingPosePlanned, tbpNexttarget)
                            End Select
                        Else
                            If boolDebugCC Then
                                frmDebug.subWriteLogs(ftnElapsedTimeS() & " -------------  No Course Correction:  ")
                                frmDebug.subWriteLogs("       tbpBotPose =  " & tbpBotPose.Location.X & ", " & tbpBotPose.Location.Y & " at " & tbpBotPose.Orientation & " degrees.")
                                frmDebug.subWriteLogs("       tbpNexttarget =  " & tbpNexttarget.Location.X & ", " & tbpNexttarget.Location.Y & " at " & tbpNexttarget.Orientation & " degrees.")
                                frmDebug.subWriteLogs("       tomTypeOfMoveCorrection = " & tomTypeOfMoveCorrection.ToString)
                            End If
                        End If
                    End If
                End If
                Thread.CurrentThread.Priority = ThreadPriority.Normal
            Catch ex As Exception
                frmDebug.subWriteLogs(" EXCEPTION in subCourseCorrect " & ex.ToString)
            End Try
        End Sub


 


    End Class
End Module
