﻿
Imports System.Math
Imports System.Drawing
Imports System.Windows.Forms
Imports System.Threading


Module modDriveToDestination

    ' This module determines the driving commands required for the Bot
    ' to reach a specific destination

    ' Examples of  driving commands:
    '      move 27 inches
    '      move -12 cm
    '      move 27 degrees
    '      stop


    Public Sub subDriveToUserChosenDestination()
        Try
            Thread.CurrentThread.Name = "threadDrive"
            If ftnInWall(tmcDestination) And Not boolSlam Then
                strStatusDriving = "In Wall"
                ftnSendCommand("play phrase ' I'm sorry Dave. I'm afraid I can't do that '")
            Else
                boolStop = False
                boolDock = False
                frmDebug.subWriteLogs(" ")
                frmDebug.subWriteLogs(" ")
                frmDebug.subWriteLogs(" ")
                frmDebug.subWriteLogs(" ******************************************************************************************")
                frmDebug.subWriteLogs(" ")
                frmDebug.subWriteLogs(" GOTABOT       (Version " & My.Application.Info.Version.ToString(3) & ")")
                ftnSendCommand("play phraseA OK")
                ftnDriveToDestination_Top(tbpBotPose, tmcDestination) ' Drive to destination
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in subDriveToUserChosenDestination " & ex.ToString)
        End Try
    End Sub


    Public Function ftnDriveToDestination_Top(ByVal tbpEstimatedPose As typeBotPose, ByVal tmcDestination As typeMapCoordinate) As Boolean
        Try
            ftnDriveToDestination_Top = False
            If Not ftnCheckForStopMode() Then
                subCheckForPause()
                frmDebug.subWriteLogs(Now() & " Drive to new destination: " & tmcDestination.X & ", " & tmcDestination.Y)
                strStatusDriving = "Drive to " & tmcDestination.X & ", " & tmcDestination.Y
                tbpBotPose = tbpEstimatedPose
                If tmiMoveInfo.boolBotIsMoving Then
                    tbpBotPose = ftnLocalizeUsingDeadReckoning(tbpBotPose, 0, True)
                    If tmiMoveInfo.boolBotIsMoving Then tbpBotPose.OrientationUncertainty += 15
                    tbpBotPose = ftnBotStop(tbpBotPose, tmiMoveInfo.tbpTargetPose)
                End If
                subInitializeDrivingControl(tbpBotPose)  ' initialize
                intLastCollisionSequenceNumber = -6
                boolCollisionDetectionEnable = True
                timeDrivingStarted = Now()
                boolCollisionDetected = False
                boolCollisionPredicted = False
                ftnSendCommand("stop")
                intDrivingSequenceNumber = 0
                frmDock.subUnDock(tbpBotPose)
                If boolMapUpdatedWithObstacle Then
                    subConvertMapToArray()
                    boolMapUpdatedWithObstacle = False
                End If
                subGeneratePathArray()
                ftnFindPathToDestination(tmcDestination, tbpBotPose.Location)
                boolDrivingToDestination = True
                subDriveToDestinationLoop(tmcDestination)
                If Not boolDock Then
                    frmDebug.subWriteFinishedMessage()
                    strStatusDriving = intDrivingSequenceNumber & " : Finished Driving "
                    ftnDriveToDestination_Top = (ftnDistanceBetweenLocations(tbpBotPose.Location, tmcDestination) <= sngBotDiameter / 3)
                    If Not boolSlam And (ftnDistanceBetweenLocations(tbpBotPose.Location, tmcDestination) <= (sngBotDiameter / 6)) Then
                        ftnSendCommand("play phraseA 'nailed it.'")
                    ElseIf Not boolSlam And ftnDriveToDestination_Top Then
                        ftnSendCommand("play phraseA 'close enough'")
                    Else
                        ftnSendCommand("play phrase Beep")
                    End If
                    ftnBotStop(tbpBotPose, tbpBotPose)
                End If
            End If
            boolDrivingToDestination = False
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in ftnDriveToDestination_Top " & ex.ToString)
        End Try
    End Function

    Sub subDriveToDestinationLoop(ByVal tmcDestination As typeMapCoordinate)
        Try
            Dim boolGoodPath As Boolean = True
            Dim tbpTargetPose As typeBotPose
            Dim sngDestinationError As Single
            If boolSlam Then
                sngDestinationError = sngBotDiameter * 0.5
            Else
                sngDestinationError = sngBotDiameter * 0.33333
            End If
            Do While ((ftnDistanceBetweenLocations(tbpBotPose.Location, tmcDestination) > sngDestinationError) _
                             And Not boolStop And boolGoodPath And boolDrivingToDestination)
                If boolDebugDrive Then frmDebug.subWriteLogs(ftnElapsedTimeS() & "          <<<<<  subDriveToDestinationLoop  START      ")
                subCheckForPause()

                If boolDebugDrive Then frmDebug.subWritePose(ftnElapsedTimeS() & " subDriveToDestinationLoop: " & " tbpBotPose  ", tbpBotPose)
                tbpTargetPose = ftnFindTargetPose(tbpBotPose, tmcDestination) ' 
                If boolDebugDrive Or boolDebugPath Then frmDebug.subWritePose(ftnElapsedTimeS() & " subDriveToDestinationLoop: " & "  Target Pose  ", tbpTargetPose)
                If Not tmiMoveInfo.boolBotIsMoving Then tbpBotPose = ftnControlDriving(tbpBotPose, tbpTargetPose) '  
                If Not (boolSlam And Not boolDrivingToDestination) Then tbpBotPose = ftnPostMoveLocalizeAndPath(tbpBotPose, tmiMoveInfo.tomTypeOfMove, tmiMoveInfo.tbpTargetPose)
                If (ftnPoseUncertaintyFactor(tbpBotPose) < 288) Then boolPoseConfirmedAfterCollision = True '(288 = (12 inches + 12 inches) * 12 degrees) _
                tmiMoveInfo.tomTypeOfMove = TypeOfMove.NONE
            Loop  ' 
            If boolDebugDrive Then frmDebug.subWriteLogs(ftnElapsedTimeS() & "          <<<<<  subDriveToDestinationLoop  END     ")
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in subDriveToDestinationLoop " & ex.ToString)
        End Try
    End Sub


    Function ftnControlDriving(ByVal tbpEstimatedPose As typeBotPose, ByVal tbpTargetPose As typeBotPose) As typeBotPose
        Try
            ftnControlDriving = tbpEstimatedPose
            If boolDebugDrive And Not tmiMoveInfo.boolBotIsMoving Then frmDebug.subWriteLogs(ftnElapsedTimeS() & " ftnControlDriving  START  ")
            Dim intTurnAngle As Short = ftnTurnAngle(tbpEstimatedPose, tbpTargetPose)
            Dim tomTypeOfMove As TypeOfMove = ftnTypeOfMove(tbpEstimatedPose, tbpTargetPose)
            If boolDebugDrive Or boolDebugPath Then frmDebug.subWriteLogs(" ftnControlDriving: tomTypeOfMove = " & tomTypeOfMove.ToString)
            If boolStop Then
                ftnControlDriving = ftnLocalizeUsingDeadReckoning(tbpEstimatedPose, 0, True)
                If tmiMoveInfo.boolBotIsMoving Then ftnControlDriving.OrientationUncertainty += 15
                ftnControlDriving = ftnBotStop(ftnControlDriving, tbpTargetPose)
            ElseIf Not tmiMoveInfo.boolBotIsMoving And (tomTypeOfMove <> TypeOfMove.TURN) And ftnObstacleDetected(tbpEstimatedPose, tomTypeOfMove, tbpBotPose, tbpTargetPose) Then  ' 
                'If boolSlam Then
                '    ftnControlDriving = tbpEstimatedPose
                '    boolDrivingToDestination = False
                'Else
                ftnControlDriving = ftnObstacleAvoid(tbpEstimatedPose, tomTypeOfMove, tbpEstimatedPose, tbpTargetPose)
                ' End If
            ElseIf Not boolStop Then
                Select Case tomTypeOfMove
                    Case TypeOfMove.TURN
                        Dim sngDistanceToTarget As Single = ftnDistanceBetweenLocations(tbpEstimatedPose.Location, tbpTargetPose.Location)
                        If (Abs(intTurnAngle) < 135) Or (sngDistanceToTarget > 10) Or boolSlam Then
                            tbpTargetPose = tbpEstimatedPose
                            tbpTargetPose.Orientation = ftnConvertTo360(ftnControlDriving.Orientation + intTurnAngle)
                            ftnControlDriving = ftnBotTurn(ftnControlDriving, True, tbpTargetPose)
                        Else
                            frmDebug.subWriteLogs(ftnElapsedTimeS() & " ***** Turn and Backup: . ***************************")
                            tbpTargetPose.Orientation = ftnConvertTo360(ftnControlDriving.Orientation + intTurnAngle - 180)
                            ftnControlDriving = ftnBotTurn(ftnControlDriving, False, tbpTargetPose)  ' prepare to backup
                            boolPoseConfirmedAfterCollision = False  ' force localization
                            ftnControlDriving = ftnBotFwd(ftnControlDriving, tbpTargetPose) ' backup
                        End If
                    Case TypeOfMove.FWD
                        ftnControlDriving = ftnBotFwd(ftnControlDriving, tbpTargetPose)
                    Case TypeOfMove.CURVE
                        tbpTargetPose = ftnCurve_DR(tbpEstimatedPose, 99999, tbpTargetPose, False) ' Calculate the orientation
                        ftnControlDriving = ftnBotCurve(ftnControlDriving, tbpTargetPose)
                    Case TypeOfMove.HALT
                        ftnControlDriving = ftnLocalizeUsingDeadReckoning(ftnControlDriving, 0, True)
                        If tmiMoveInfo.boolBotIsMoving Then ftnControlDriving.OrientationUncertainty += 15
                        ftnControlDriving = ftnBotStop(ftnControlDriving, tbpTargetPose)
                    Case Else
                        frmDebug.subWriteLogs(" **********************  ftnControlDriving:  Unexpected TypeOfMove")
                        ftnControlDriving = ftnLocalizeUsingDeadReckoning(ftnControlDriving, 0, True)
                        If tmiMoveInfo.boolBotIsMoving Then ftnControlDriving.OrientationUncertainty += 15
                        ftnControlDriving = ftnBotStop(ftnControlDriving, tbpTargetPose)
                End Select
                If boolDebugCC Then frmDebug.subWriteLogs(ftnElapsedTimeS() & "  ftnControlDriving Post Move:  tbpBotPose : " & tbpBotPose.Location.X & ", " & tbpBotPose.Location.Y & " at " & tbpBotPose.Orientation & " degrees.")
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in ftnControlDriving " & ex.ToString)
        End Try
    End Function



End Module
