﻿Imports System

Imports Emgu.CV.UI
Imports Emgu.CV
Imports Emgu.CV.Structure
Imports Emgu.CV.CvEnum

Imports System.IO
Imports System.Xml
Imports System.Windows.Forms



Public Module modFaceClassifier

    Private termCrit As MCvTermCriteria
    Private eigenFaceRecognizer As EigenObjectRecognizer

    Private trainingImages As New List(Of Image(Of Gray, Byte))()
    Private Names_List As New List(Of String)()
    Private intContTrain As Integer, intNumLabels As Integer

    Private boolTrained As Boolean = False

    Public Function ftnClassifierLoad() As Boolean
        Try
            termCrit = New MCvTermCriteria(intContTrain, 0.001)
            boolTrained = ftnLoadTrainingData(Application.StartupPath + "\TrainedFaces")
            ftnClassifierLoad = boolTrained
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in ftnClassifierLoad " & ex.ToString)
        End Try
    End Function

    Public Function ftnClassifierRecognize(Input_image As Image(Of Gray, Byte)) As String
        Try
            If boolTrained Then
                ftnClassifierRecognize = eigenFaceRecognizer.Recognize(Input_image)
            Else
                ftnClassifierRecognize = ""
            End If
        Catch ex As Exception
            ftnClassifierRecognize = ""
            frmDebug.subWriteLogs(" EXCEPTION in ftnClassifierRecognize " & ex.ToString)
        End Try
    End Function



    Public Sub subFaceClassifierDispose()
        eigenFaceRecognizer = Nothing
        trainingImages = Nothing
        Names_List = Nothing
        GC.Collect()
    End Sub


    Private Function ftnLoadTrainingData(Folder_loacation As String) As Boolean
        If File.Exists(Folder_loacation & Convert.ToString("\TrainedLabels.xml")) Then
            Try
                Names_List.Clear()
                trainingImages.Clear()
                Dim filestream As FileStream = File.OpenRead(Folder_loacation & Convert.ToString("\TrainedLabels.xml"))
                Dim filelength As Long = filestream.Length
                Dim xmlBytes As Byte() = New Byte(filelength - 1) {}
                filestream.Read(xmlBytes, 0, CInt(filelength))
                filestream.Close()

                Dim xmlStream As New MemoryStream(xmlBytes)

                Using xmlreader As XmlReader = XmlTextReader.Create(xmlStream)
                    While xmlreader.Read()
                        If xmlreader.IsStartElement() Then
                            Select Case xmlreader.Name
                                Case "NAME"
                                    If xmlreader.Read() Then
                                        Names_List.Add(xmlreader.Value.Trim())
                                        intNumLabels += 1
                                    End If
                                    Exit Select
                                Case "FILE"
                                    If xmlreader.Read() Then
                                        'PROBLEM HERE IF TRAININGG MOVED
                                        trainingImages.Add(New Image(Of Gray, Byte)(Application.StartupPath + "\TrainedFaces\" + xmlreader.Value.Trim()))
                                    End If
                                    Exit Select
                            End Select
                        End If
                    End While
                End Using
                intContTrain = intNumLabels

                If trainingImages.ToArray().Length <> 0 Then
                    eigenFaceRecognizer = New EigenObjectRecognizer(trainingImages.ToArray(), Names_List.ToArray(), 5000, termCrit)      '5000 default
                    Return True
                Else
                    Return False
                End If
            Catch ex As Exception
                Return False
                frmDebug.subWriteLogs(" EXCEPTION in ftnLoadTrainingData " & ex.ToString)
            End Try
        Else
            Return False
        End If
    End Function
End Module

