﻿
'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'
'
'  Example taken from http://msdn.microsoft.com/en-us/library/6y0e13d3.aspx
'
'    Synchronous Server Socket Example

'  The following example program creates a server that receives connection requests from clients. The 
' server is built with a synchronous socket, so execution of the server application is suspended 
' while it waits for a connection from a client. 
'
'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

Imports System.Net
Imports System.Net.Sockets
Imports System.Text
Imports System.Threading
Imports System.Drawing



Module modIF_Api2_Server
    Dim strAPIMessage As String
    Dim evntSendComplete As New ManualResetEvent(False)
    Dim evntParseComplete As New ManualResetEvent(False)
    Dim boolLoggedIn As Boolean = False
    Dim booltimeOut As Boolean = False


    Sub subAPITimeout()
        booltimeOut = True
        boolLoggedIn = False
    End Sub


    Public Sub API2ParseAndRespond()
        '  Parse the received data and respond
        Try
            strAPIMessage = ftnAPICommands(strAPIMessage, boolLoggedIn)
            evntParseComplete.Set()
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in API2ParseAndRespond")
        End Try
    End Sub



#Region "API Server1"

    Public Class classAPI2Server
        ' This server waits for a connection and then uses  sychronous operations to
        ' accept the connection, get data from the connected client, 
        ' perform the API function.
        Public Shared Event evntAPICommandReceived(ByVal boolAPICommandReceived As Boolean)
        Public Shared Connected As Boolean = False
        Shared boolErrorDetected As Boolean = False
        Shared strMessageReceived As String = String.Empty
        Shared evntAllDone As New ManualResetEvent(False)


        Public Shared data As String = Nothing

        Public Shared Sub subMain()
            Try
                ' Data buffer for incoming data.
                Dim bytes() As Byte = New [Byte](1024) {}

                ' Establish the local endpoint for the socket.
                ' Dns.GetHostName returns the name of the 
                ' host running the application.
                Dim ipHostInfo As IPHostEntry = Dns.GetHostEntry(Dns.GetHostName())
                Dim ipAddress As IPAddress = IPAddress.Loopback    ' ipHostInfo.AddressList(UBound(ipHostInfo.AddressList))
                Dim handler As Socket
                While Not boolShutDown
                    Dim localEndPoint As New IPEndPoint(ipAddress, 9400) ' Create a TCP/IP socket.
                    Dim listener As New Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp)
                    booltimeOut = False
                    boolErrorDetected = False
                    boolLoggedIn = False
                    If (Socket.OSSupportsIPv6) Then   ' VISTA = 6.1, Win7 = 6.2
                        ipAddress = IPAddress.IPv6Loopback
                        localEndPoint = New IPEndPoint(ipAddress.IPv6Any, 9400) ' Create a TCP/IP socket.
                        listener = New Socket(AddressFamily.InterNetworkV6, SocketType.Stream, ProtocolType.Tcp)
                        listener.SetSocketOption(SocketOptionLevel.IPv6, SocketOptionName.IPv6Only, 0)
                        listener.SetSocketOption(SocketOptionLevel.Socket, SocketOptionName.DontLinger, True)
                    Else
                        ipAddress = IPAddress.Loopback    'ipHostInfo.AddressList(UBound(ipHostInfo.AddressList))
                        localEndPoint = New IPEndPoint(ipAddress.Any, 9400) ' Create a TCP/IP socket.
                        listener = New Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp)
                    End If

                    listener.Bind(localEndPoint)
                    listener.Listen(10)

                    ' Start listening for connections.
                    ' Program is suspended while waiting for an incoming connection.
                    handler = listener.Accept()
                    handler.SetSocketOption(SocketOptionLevel.Socket, SocketOptionName.ReuseAddress, 1)
                    handler.SetSocketOption(SocketOptionLevel.Socket, SocketOptionName.ReceiveTimeout, 1000)
                    data = Nothing
                    classAPI2Server.Connected = handler.Connected

                    ' An incoming connection needs to be processed.
                    While Not boolShutDown And Not booltimeOut And handler.Connected
                        Thread.Sleep(50)
                        bytes = New Byte(1024) {}
                        Dim bytesRec As Integer = 0 ' handler.Receive(bytes)
                        If (handler.Poll(100000, SelectMode.SelectRead)) Then _
                              bytesRec = handler.Receive(bytes, bytes.Length, 0) ' numbytes =count of bytes returned
                        If bytesRec > 0 Then data += Encoding.ASCII.GetString(bytes, 0, bytesRec)
                        If data.IndexOf(vbCrLf) > -1 Then
                            evntParseComplete.Reset()
                            subAPIToMainIF(data)  ' Process the command
                            evntParseComplete.WaitOne(1000)
                            Dim msg As Byte() = Encoding.ASCII.GetBytes(strAPIMessage)
                            data = ""
                            If handler.Connected Then handler.Send(msg)
                        End If
                    End While
                    handler.Disconnect(Not boolShutDown)
                    Thread.Sleep(500)
                    classAPI2Server.Connected = handler.Connected
                End While
            Catch ex As Exception
                frmDebug.subWriteLogs(" EXCEPTION in subMain")
            End Try
        End Sub


        Private Shared Sub subAPIToMainIF(ByVal strMessage As String)
            Try
                If booltimeOut Then
                    evntAllDone.Set() ' Signal the subMain thread to continue.
                    strAPIMessage = "API_Timeout" & vbCr
                    booltimeOut = False
                    boolErrorDetected = True
                ElseIf boolErrorDetected Then
                    evntAllDone.Set() ' Signal the subMain thread to continue.
                    strAPIMessage = "Error_Detected" & vbCr
                    booltimeOut = False
                    boolErrorDetected = True
                Else
                    strAPIMessage = strMessage
                End If
                RaiseEvent evntAPICommandReceived(True)
            Catch ex As Exception
                frmDebug.subWriteLogs(" EXCEPTION in subAPIToMainIF")
            End Try
        End Sub



    End Class 'classAPI2Server




#End Region



End Module
