﻿Imports System.Math
Imports System.Drawing
Imports System.Windows.Forms


Module modIF_RoboRealm_Top
    Public Function ftnRoboRealmCommand(ByRef strCommand As String) As String
        ftnRoboRealmCommand = ""
        Try
            Dim strParsedText As String() = strCommand.Split(" "c)
            If (Not boolSimulatedMovement) Or (strParsedText(0) = "play") Then ' 
                Select Case strParsedText(0)
                    Case "move" : If Not boolStop Then _
                            ftnRoboRealmCommand = ftnMoveCommand(strParsedText, strCommand)
                    Case "battery" : ftnRoboRealmCommand = ftnGetBattery(strParsedText, strCommand)
                    Case "input" : If (UBound(strParsedText) > 0) Then
                            If (strParsedText(1) = "analog") Then  ' get  voltage
                                ftnRoboRealmCommand = ftnGetAnalog(strParsedText, strCommand)
                            ElseIf (strParsedText(1) = "digital") Then
                                ftnRoboRealmCommand = ftnGetDigital()
                            End If
                        End If
                    Case "play" : ftnRoboRealmCommand = ftnSpeak(strCommand)
                    Case "pose" : ftnRoboRealmCommand = ftnGetPose(strParsedText) ' get odometry data
                    Case "moving" : ftnRoboRealmCommand = ftnMoving() ' get moving status
                    Case "bumper" : ftnRoboRealmCommand = ftnGetBumper(strParsedText, strCommand) ' get bumper switch status
                    Case "set" : ftnRoboRealmCommand = ftnSet(strParsedText, strCommand) ' Set bot parameter
                    Case "stop" : ftnRoboRealmCommand = ftnStop(strParsedText, strCommand) 'stop
                    Case Else : ftnRoboRealmCommand = ftnTransmitRR(strCommand, "", 0)
                End Select
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in ftnRoboRealmCommand " & ex.ToString)
        End Try
    End Function

    Function ftnMoving() As String
        Try
            If tmiMoveInfo.boolBotIsMoving Then
                ftnMoving = "True"
            Else
                ftnMoving = "False"
            End If
        Catch ex As Exception
            ftnMoving = "False"
            frmDebug.subWriteLogs(" EXCEPTION in ftnMoving " & ex.ToString)
        End Try
    End Function



    Private Function ftnMoveCommand(ByRef strParsedText As String(), ByVal strCommand As String) As String
        ftnMoveCommand = "OK"
        Try
            Dim boolMidCourseCorrectionCommand As Boolean = tmiMoveInfo.boolBotIsMoving
            Dim sngMoveDistanceOrAngle As Single
            If (tomTypeOfMovePlanned = TypeOfMove.CURVE) Then
                sngMoveDistanceOrAngle = Sqrt(Convert.ToSingle(Val(strParsedText(2))) ^ 2 + Convert.ToSingle(Val(strParsedText(4))) ^ 2) / Cos(Atan(Convert.ToSingle(Val(strParsedText(4))) / Convert.ToSingle(Val(strParsedText(2)))))
            Else
                sngMoveDistanceOrAngle = Convert.ToSingle(Val(strParsedText(1)))
            End If

            If boolEnableCourseCorrection Then subStartImageRecognition()
            ftnSetMoveInfo(tomTypeOfMovePlanned, tbpStartingPosePlanned, tbpTargetPosePlanned, True)
            ControlRRBot(sngMoveDistanceOrAngle, tmiMoveInfo.tomTypeOfMove)
            ftnSetMoveInfo(tmiMoveInfo.tomTypeOfMove, tmiMoveInfo.tbpStartingPose, tmiMoveInfo.tbpTargetPose, False)
            tmiMoveInfo.boolMoveCommandInProgress = False
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in ftnMoveCommand " & ex.ToString)
        End Try
    End Function





    Private Function ftnGetPose(ByVal strParsedText As String()) As String
        ftnGetPose = "ERROR :"
        Try
            Dim tbpRRPose As typeBotPose = ftnLocalizeUsingDeadReckoning(tbpBotPose, 0, True)
            ftnGetPose = "OK " & tbpRRPose.Location.X.ToString & " " & tbpRRPose.Location.Y.ToString & " " & tbpRRPose.Orientation
            'ftnSetMoveInfo(tmiMoveInfo.tomTypeOfMove, tmiMoveInfo.tbpStartingPose, tmiMoveInfo.tbpTargetPose, tmiMoveInfo.boolBotIsMoving, False, True)
            If boolDebugOdometry Then frmDebug.subWriteLogs("     ---------   ftnGetPose:  = " & ftnGetPose)
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in ftnGetPose " & ex.ToString)
        End Try
    End Function


    Private Function ftnGetBumper(ByRef strParsedText As String(), ByRef strCommand As String) As String
        ftnGetBumper = "7"
        Try
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in ftnGetBumper " & ex.ToString)
        End Try
    End Function



    Private Function ftnStop(ByVal strParsedText As String(), ByVal strCommand As String) As String
        Try
            ftnSetMoveInfo(TypeOfMove.HALT, tbpBotPose, tbpBotPose, True)
            ControlRRBot(0, TypeOfMove.FWD)
            ftnStop = ""
            ftnSetMoveInfo(TypeOfMove.HALT, tbpBotPose, tbpBotPose, False)
            tmiMoveInfo.boolMoveCommandInProgress = False
        Catch ex As Exception
            ftnStop = ""
            frmDebug.subWriteLogs(" EXCEPTION in ftnStop " & ex.ToString)
        End Try
    End Function


    Private Function ftnSet(ByRef strParsedText As String(), ByRef strCommand As String) As String
        Try
            ftnSet = ""
        Catch ex As Exception
            ftnSet = ""
            frmDebug.subWriteLogs(" EXCEPTION in ftnSet " & ex.ToString)
        End Try
    End Function


    Private Function ftnGetBattery(ByVal strParsedText As String(), ByRef strCommand As String) As String
        Try
            Dim intBatteryPercentage As Integer = 0
            sngBotBatteryVoltage = CSng(Val(ftnGetVariableFromRR("battery"))) / 127 * 12.5
            intBatteryPercentage = Int((100.0 * (sngBotBatteryVoltage - 11.35) / 0.75))
            If (intBatteryPercentage > 100) Then intBatteryPercentage = 100
            If (intBatteryPercentage < 0) Then intBatteryPercentage = 0
            intBatteryPercentage = (intBatteryPercentage \ 20) * 20
            strStatusBotVoltage = "Bot: " & intBatteryPercentage.ToString & "%"

            ftnGetBattery = strStatusBotVoltage
            If (ftnGetBattery = "   ??   ") And boolBotConnected Then ftnRoboRealmCommand("play phrase 'No power'")
            sngLaptopBatteryPercent = Int(SystemInformation.PowerStatus.BatteryLifePercent * 100)
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in ftnGetBattery " & ex.ToString)
            ftnGetBattery = ""
        End Try
    End Function


    Private Function ftnGetAnalog(ByVal strParsedText As String(), ByRef strCommand As String) As String
        ftnGetAnalog = ""
        Try
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in ftnGetAnalog " & ex.ToString)
        End Try
    End Function

    Private Function ftnGetDigital() As Byte
        Try
            ftnGetDigital = "&Hff"
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in ftnGetDigital " & ex.ToString)
        End Try
    End Function

    Private Function ftnSpeak(ByVal strCommand As String) As String
        Try
            ftnSpeak = "OK"
            Dim strParsedText As String() = strCommand.Split(" "c)
            If boolMute Then
                ftnSpeak = "OK"
            Else
                subSpeak(strCommand)
            End If
        Catch ex As Exception
            ftnSpeak = ""
            frmDebug.subWriteLogs(" EXCEPTION in ftnSpeak " & ex.ToString)
        End Try
    End Function

End Module
