﻿
Imports System.Threading
Imports System.Drawing


Module modImageRecognition
    Public RecognizedImagesQueue As New Queue(24)

    Public Sub subStartImageRecognition()
        Try
            If ftnVisualRecognizerEnabled() Then
                ftnSendToRecognizer("clear")
                RecognizedImagesQueue.Clear()
                If (RecognizedImagesQueue.Count <> 0) Then _
                    RecognizedImagesQueue.Dequeue()
                ftnSendToRecognizer("events")
                RecognizedImagesQueue.Enqueue("")     'kludge
                classAddImageToQueue.boolGetMoreRecognizedImages = True
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in subStartImageRecognition " & ex.ToString)
        End Try
    End Sub

    Public Sub subEndImageRecognition()
        Try
            If ftnVisualRecognizerEnabled() Then
                classAddImageToQueue.boolGetMoreRecognizedImages = False
                If boolEnableLocalRCC Then _
                  ftnLRCC_Communicate("clear", "OK", 1000)
                classAddImageToQueue.boolGetMoreRecognizedImages = False
                RecognizedImagesQueue.Clear()
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in subEndImageRecognition " & ex.ToString)
        End Try
    End Sub


    Public Function ftnGetNextObject() As String
        ftnGetNextObject = ""
        Try
            While (RecognizedImagesQueue.Count > 0) And (Not CBool(InStr(ftnGetNextObject, "object"))) _
                   And Not boolStop And Not boolShutDown
                ftnGetNextObject = Convert.ToString(RecognizedImagesQueue.Dequeue())
            End While
            If (Not CBool(InStr(ftnGetNextObject, "object"))) Then
                ftnGetNextObject = ""
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in ftnGetNextObject " & ex.ToString)
        End Try
    End Function


    Public Function ftnSendToRecognizer(ByRef strTextToSend As String) As String
        ftnSendToRecognizer = ""
        If boolEnableLocalRCC Then _
          ftnSendToRecognizer = ftnLRCC_Communicate(strTextToSend, "OK", 1000) ' subSend to the local RCC
    End Function





#Region "Image Queue"
    Public Class classAddImageToQueue
        Public Shared boolGetMoreRecognizedImages As Boolean = False
        Public Sub subGetMoreRecognizedImages()
            Try
                While Not boolShutDown
                    If boolGetMoreRecognizedImages Then
                        If boolEnableLocalRR Then subGetMoreFiducialRecognitions()
                        If ftnVisualRecognizerEnabled() Then subGetMoreRecognitions()
                    End If
                    Thread.Sleep(200)
                End While
            Catch ex As Exception
                frmDebug.subWriteLogs(" EXCEPTION in subGetMoreRecognizedImages " & ex.ToString)
            End Try
        End Sub


        Sub subGetMoreRecognitions()
            Try
                Dim intObjectCounter As Integer = 0
                Dim intQueueCounter As Integer = 0
                Dim strObjectRecognized As String = ""
                strObjectRecognized = ftnGetTextFromRecognizer() & " EndOfText" ' get the recognized landmarks 
                strObjectRecognized = strObjectRecognized.Replace(vbLf, "")
                Dim strRecognizedObjects As String() = strObjectRecognized.Split(vbCr)
                Dim strRecognizedObjectsSplit As String()
                While (intObjectCounter <= UBound(strRecognizedObjects)) And Not boolShutDown
                    If (CBool(InStr(strRecognizedObjects(intObjectCounter), "object"))) Then
                        Dim intSubStringStart As Integer = strRecognizedObjects(intObjectCounter).IndexOf("object")
                        strRecognizedObjects(intObjectCounter) = strRecognizedObjects(intObjectCounter).Substring(intSubStringStart, (strRecognizedObjects(intObjectCounter).Length - intSubStringStart))
                        strRecognizedObjectsSplit = strRecognizedObjects(intObjectCounter).Split(" ")
                        If (UBound(strRecognizedObjectsSplit) >= 6) Then
                            RecognizedImagesQueue.Enqueue(strRecognizedObjects(intQueueCounter))
                            intQueueCounter += 1
                        End If
                    End If
                    intObjectCounter += 1
                End While
            Catch ex As Exception
                frmDebug.subWriteLogs(" EXCEPTION in subGetMoreRecognitions " & ex.ToString)
            End Try
        End Sub

        Sub subGetMoreFiducialRecognitions()  ' called by subGetMoreRecognizedImages
            Try
                Dim tirFiducials(64) As typeImageRecognized
                Dim strObjectRecognized As String = ""
                Dim i As Integer = 0
                tirFiducials(0).Name = ""
                GetFiducials(tirFiducials)
                Do While ((tirFiducials(i).Name <> "") And (i < 64)) And Not boolShutDown
                    strObjectRecognized = "object " & """" & tirFiducials(i).Name & """" & " 70 100 " & tirFiducials(i).intPixelX & " 200 " &
                            tirFiducials(i).Range & " Rotation " & tirFiducials(i).sngYRotation & vbCrLf
                    RecognizedImagesQueue.Enqueue(strObjectRecognized)
                    i += 1
                Loop
            Catch ex As Exception
                frmDebug.subWriteLogs(" EXCEPTION in subGetMoreFiducialRecognitions " & ex.ToString)
            End Try
        End Sub

        Private Function ftnGetTextFromRecognizer() As String
            ftnGetTextFromRecognizer = ""
            If boolEnableGotAGlyph Then _
                ftnGetTextFromRecognizer = ftnGotAGlyph_Communicate("glyph", ">", 1000)
            If boolEnableLocalRCC Then _
                ftnGetTextFromRecognizer &= ftnGetTextLRCC(1000)
            If (boolEnableAVM) Then _
                ftnGetTextFromRecognizer &= ftnGetAVMResponse()
        End Function

    End Class
#End Region



End Module
