﻿Imports System.Drawing
Imports System.Math
Imports System.Windows.Forms


Public Module modLocalizeRBPF

    '  StochasticUniversalSampling() taken from http://mnemstudio.org/genetic-algorithms-simple-example-4.htm

    Dim sngParticleWeightNormalized(intNumberOfParticles) As Single
    Public sngRMS_Error(intNumberOfParticles) As Single
    Dim tbpParticleStartPose(intNumberOfParticles) As typeBotPose
    Dim tbpParticleProposalPose(intNumberOfParticles) As typeBotPose

    Public Sub subInitParticles(ByVal tbpEstimatedPose As typeBotPose, ByVal intNumberOfParticles As Short)
        Dim intParticleNumber As Short
        Try
            If boolEnableRBPF Or boolSlam Then
                If boolDebugRBPF Then frmDebug.subWriteLogs("//  subInitParticles  //")
                Dim colorMapPixel As Color
                ReDim byteParticleMapOdds(intNumberOfParticles, bmpMap.Width, bmpMap.Height)
                ReDim sngParticleWeightNormalized(intNumberOfParticles)
                ReDim sngRMS_Error(intNumberOfParticles)
                ReDim tbpParticleStartPose(intNumberOfParticles)
                ReDim tbpParticleProposalPose(intNumberOfParticles)
                ReDim tbpParticlePose(intNumberOfParticles)
                If boolSlam Then boolEnableRBPF = True
                boolEnableCourseCorrection = False
                For intX As Short = 0 To bmpMap.Width - 1   ' Convert bmpMap into intOccupiedOddsArray.   
                    For intY As Short = 0 To bmpMap.Height - 1
                        colorMapPixel = bmpMap.GetPixel(intX, intY)
                        If (colorMapPixel.G = 0) Then  ' occupied
                            byteParticleMapOdds(0, intX, intY) = 255  ' 
                        ElseIf (colorMapPixel.G = 255) Then ' empty
                            byteParticleMapOdds(0, intX, intY) = 0  ' 
                        Else
                            byteParticleMapOdds(0, intX, intY) = 16 ' 16 = 1:1 odds or 50% probability
                        End If
                    Next intY
                Next intX
                tbpParticlePose(0) = tbpEstimatedPose
                tbpParticlePose(0).LocationUncertainty.X = 10
                tbpParticlePose(0).LocationUncertainty.Y = 10
                tbpParticlePose(0).OrientationUncertainty = 10
                sngRMS_Error(0) = sngOneSigma
                tbpParticleStartPose(0) = tbpParticlePose(0)
                tbpParticleProposalPose(0) = tbpParticlePose(0)
                For intParticleNumber = 1 To intNumberOfParticles - 1
                    subCopyParticle(0, intParticleNumber)
                Next intParticleNumber
                subAddPropsalNoise()
                intBestParticle = 0
                subConvertParticleOddsToBMP(intBestParticle)
                subConvertMapToArray()
                subGeneratePathArray()
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in subInitParticles " & ex.ToString)
            frmDebug.subWriteLogs("     intParticleNumber = " & intParticleNumber)
            frmDebug.subWriteLogs("     tbpParticlePose(intParticleNumber).Location = " & tbpParticlePose(intParticleNumber).Location.X & ", " & tbpParticlePose(intParticleNumber).Location.Y)
        End Try
    End Sub

    Function ftnLocalizeRBPF_Top(ByVal tbpEstimatedPose As typeBotPose, ByRef boolGoodLocalization As Boolean) As typeBotPose
        Try
            ftnLocalizeRBPF_Top = tbpEstimatedPose
            boolGoodLocalization = False
            If ftnGetScanVectors() Then
                boolLocalizationInProgress = True
                boolShowVectors = True
                Dim boolBotIsMoving As Boolean = tmiMoveInfo.boolBotIsMoving
                If boolBotIsMoving Then
                    intNumberOfBeams = Max(16, intNumberOfBeamsDefault \ 2) ' reduce number of vectors while moving or lost for faster localization
                Else
                    intNumberOfBeams = Max(16, intNumberOfBeamsDefault)
                End If
                If boolDebugRBPF Then
                    frmDebug.subWriteLogs(ftnElapsedTimeS() & " intNumberOfBeams =  " & intNumberOfBeams)
                    frmDebug.subWriteLogs(" intNumberOfBeamsDefault =  " & intNumberOfBeamsDefault)
                    frmDebug.subWriteLogs(" intNumberOfParticles =  " & intNumberOfParticles)
                End If
                If boolBotIsMoving Or Not tmiMoveInfo.boolParticalStartPoseIsReset Then subGenerateProposalFromMotionModel() '
                subLocalizeParticles(intNumberOfParticles)  ' 
                If Not boolBotIsMoving Then intBestParticle = ftnBestParticle(intNumberOfParticles)
                ftnLocalizeRBPF_Top = tbpParticlePose(intBestParticle)
                boolGoodLocalization = (sngRMS_Error(intBestParticle) <= sngUnacceptableError)
                If boolGoodLocalization Then
                    If Not tmiMoveInfo.boolBotIsMoving Then boolShowGreenVectors = True
                    frmDebug.subWritePose(ftnElapsedTimeS() & "       Pose Derived From (2D) Particle Filter  ", ftnLocalizeRBPF_Top)
                    frmDebug.subWriteLogs("                         Scan Error = " & FormatNumber(sngRMS_Error(intBestParticle), 2) & "   (Particle (2D) localization success)")
                Else
                    frmDebug.subWritePose(ftnElapsedTimeS() & "       Pose Derived From (2D) Particle Filter  ", ftnLocalizeRBPF_Top)
                    frmDebug.subWriteLogs("                           Scan Error = " & FormatNumber(sngRMS_Error(intBestParticle), 2) & "   (Particle localization failed)")
                End If
                If Not boolBotIsMoving Then
                    If boolDebugRBPF Then
                        frmDebug.subWriteLogs("ftnLocalizeRBPF_Top:    intBestParticle = " & intBestParticle)
                        subDebugTmi()
                        frmDebug.subWriteLogs("ftnLocalizeRBPF_Top:    intBestParticle = " & intBestParticle)
                        For intParticleNumber = 0 To intNumberOfParticles - 1
                            frmDebug.subWriteShortPose("ftnLocalizeRBPF_Top: " & intParticleNumber & ": " & FormatNumber(sngRMS_Error(intParticleNumber), 2) & ":  tbpParticlePose ", tbpParticlePose(intParticleNumber))
                            frmDebug.subWriteShortPose("                   : " & intParticleNumber & ": " & FormatNumber(sngRMS_Error(intParticleNumber), 2) & ",  tbpParticleProposalPose ", tbpParticleProposalPose(intParticleNumber))
                        Next intParticleNumber
                    End If
                    subStochasticUniversalSampling(intNumberOfParticles)
                    If Not tmiMoveInfo.boolParticalStartPoseIsReset Then
                        For intParticleNumber = 0 To intNumberOfParticles - 1
                            tbpParticleStartPose(intParticleNumber) = tbpParticlePose(intParticleNumber)
                        Next intParticleNumber
                    End If
                    tmiMoveInfo.boolParticalStartPoseIsReset = True
                End If
                subUpdateSlamMaps(intNumberOfParticles, intBestParticle)
                frmSlam.updnMapSelect.Value = intBestParticle
                frmSlam.updnMapSelect.Refresh()
                boolLocalizationInProgress = False
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in ftnLocalizeRBPF_Top " & ex.ToString)
            boolLocalizationInProgress = False
        End Try
    End Function

    Sub subUpdateSlamMaps(ByRef intNumberOfParticles As Short, ByRef intBestParticle As Short)
        Try
            subConvertScanToOccupencyOdds(intNumberOfParticles)
            'subGenerateDistanceFromWallSquaredSegmentArray(intBestParticle)
            subConvertParticleOddsToBMP(intBestParticle)
            subConvertMapToArray()
            If boolDrivingToDestination Then subGeneratePathArray()
            ' Application.DoEvents()
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in subUpdateSlamMaps " & ex.ToString)
        End Try
    End Sub


    Sub subGenerateProposalFromMotionModel()
        Try
            Dim tmiMoveInfoLocal As typeMoveInfo = ftnGetMoveInfo()
            Dim sngElapsedTime As Single = ftnElapsedTimeS()   ' in Seconds
            If boolDebugRBPF Then frmDebug.subWriteLogs(" subGenerateProposalFromMotionModel:  sngElapsedTime = " & sngElapsedTime)
            Select Case tmiMoveInfoLocal.tomTypeOfMove
                Case TypeOfMove.TURN
                    Dim intTurnAngle As Short = ftnAngleTravelled(tmiMoveInfoLocal.tbpStartingPose, tmiMoveInfoLocal.tbpTargetPose, sngElapsedTime, tmiMoveInfoLocal.boolCourseCorrection)
                    If boolDebugRBPF Then frmDebug.subWriteLogs(" subGenerateProposalFromMotionModel:  intTurnAngle = " & intTurnAngle)
                    For intParticleNumber As Short = 0 To intNumberOfParticles - 1
                        tbpParticleProposalPose(intParticleNumber) = ftnTurnDR(tbpParticleStartPose(intParticleNumber), intTurnAngle, True)
                    Next intParticleNumber
                Case TypeOfMove.FWD
                    Dim sngDistance As Single = ftnDistanceTravelled(tmiMoveInfoLocal.tbpStartingPose, tmiMoveInfoLocal.tbpTargetPose, sngElapsedTime, tmiMoveInfoLocal.tomTypeOfMove, tmiMoveInfoLocal.boolCourseCorrection)
                    If boolDebugRBPF Then frmDebug.subWriteLogs(" subGenerateProposalFromMotionModel:  sngDistance = " & sngDistance)
                    For intParticleNumber As Short = 0 To intNumberOfParticles - 1
                        tbpParticleProposalPose(intParticleNumber) = ftnFwdDR(tbpParticleStartPose(intParticleNumber), sngDistance, True)
                    Next intParticleNumber
                Case TypeOfMove.CURVE
                    Dim sngTargetRange As Single = ftnDistanceBetweenLocations(tmiMoveInfoLocal.tbpStartingPose.Location, tmiMoveInfoLocal.tbpTargetPose.Location)
                    Dim sngTargetAngle As Single = ftnTurnAngle(tmiMoveInfoLocal.tbpStartingPose, tmiMoveInfoLocal.tbpTargetPose.Location)
                    Dim sngDistance As Single = ftnDistanceTravelled(tmiMoveInfoLocal.tbpStartingPose, tmiMoveInfoLocal.tbpTargetPose, sngElapsedTime, tmiMoveInfoLocal.tomTypeOfMove, tmiMoveInfoLocal.boolCourseCorrection)
                    Dim tbpParticleTargetPose As typeBotPose
                    For intParticleNumber As Short = 0 To intNumberOfParticles - 1
                        tbpParticleTargetPose = tbpParticleStartPose(intParticleNumber)
                        tbpParticleTargetPose.Location = ftnLocationFromEstimatedPose(tbpParticleStartPose(intParticleNumber), sngTargetAngle, sngTargetRange)
                        tbpParticleProposalPose(intParticleNumber) = ftnCurve_DR(tbpParticleStartPose(intParticleNumber), sngDistance, tbpParticleTargetPose, True)
                    Next intParticleNumber
                Case Else
                    If boolDebugRBPF Then frmDebug.subWriteLogs(ftnElapsedTimeS() & " subGenerateProposalFromMotionModel: ERROR - Undefined type of Move ")
                    For intParticleNumber As Short = 0 To intNumberOfParticles - 1
                        tbpParticleProposalPose(intParticleNumber) = tbpParticlePose(intParticleNumber)
                    Next intParticleNumber
            End Select
            subAddPropsalNoise() '  Add noise to each Particle's movement
            If boolDebugRBPF Then
                For intParticleNumber = 0 To intNumberOfParticles - 1
                    frmDebug.subWriteLogs(" subGenerateProposalFromMotionModel: " & intParticleNumber & ":  sngRMS_Error = " & FormatNumber(sngRMS_Error(intParticleNumber), 2))
                    frmDebug.subWritePose("subGenerateProposalFromMotionModel: tbpParticleStartPose ", tbpParticleStartPose(intParticleNumber))
                    frmDebug.subWritePose("subGenerateProposalFromMotionModel: tbpParticleProposalPose ", tbpParticleProposalPose(intParticleNumber))
                Next intParticleNumber
            End If
            For intParticleNumber = 0 To intNumberOfParticles - 1
                tbpParticlePose(intParticleNumber) = tbpParticleProposalPose(intParticleNumber)
            Next intParticleNumber
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in subGenerateProposalFromMotionModel " & ex.ToString)
        End Try
    End Sub

    Sub subAddPropsalNoise()
        Try
            If Not tmiMoveInfo.boolBotIsMoving Then
                Randomize()
                For intParticleNumber As Short = 0 To intNumberOfParticles - 1
                    tbpParticleProposalPose(intParticleNumber).Location.X += ftnGenerateGaussian() '
                    tbpParticleProposalPose(intParticleNumber).Location.Y += ftnGenerateGaussian()
                    tbpParticleProposalPose(intParticleNumber).Location = ftnCheckMapArrayLimits(tbpParticleProposalPose(intParticleNumber).Location)
                    tbpParticleProposalPose(intParticleNumber).Orientation = ftnConvertTo360(tbpParticleProposalPose(intParticleNumber).Orientation + ftnGenerateGaussian())
                Next intParticleNumber
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in subAddPropsalNoise " & ex.ToString)
        End Try
    End Sub




    Sub subLocalizeParticles(ByRef intNumberOfParticles As Short)
        Try
            If ftnNonFlatWall() Then
                For intParticleNumber As Short = 0 To intNumberOfParticles - 1
                    If boolDebugRBPF Then frmDebug.subWriteLogs(" subLocalizeParticles: " & intParticleNumber & "====================================================")
                    subGenerateDistanceFromWallSquaredSegmentArray(intParticleNumber)
                    tbpParticlePose(intParticleNumber) = ftnPoseFrom2DScan(tbpParticleProposalPose(intParticleNumber), sngRMS_Error(intParticleNumber))
                    If boolDebugRBPF Then
                        frmDebug.subWritePose("subLocalizeParticles: tbpParticleProposalPose ", tbpParticleProposalPose(intParticleNumber))
                        frmDebug.subWriteShortPose("subLocalizeParticles: tbpParticlePose ", tbpParticlePose(intParticleNumber))
                        Dim intDistanceFromWallErrorSquared As Short
                        Dim intValidBeamCounter As Short = 0
                        Dim intDistanceFromWallErrorSquaredSum As Short = 0
                        Dim boolEndPointInGreySpace As Boolean = False
                        Dim trvVector As typeRangeVector
                        Dim tmcVectorOrigin As typeMapCoordinate = ftnLocationFromEstimatedPose(tbpParticlePose(intParticleNumber), tmcScanVectorOffset)
                        For intBeamNumber As Short = 0 To constMaxScannerBeams - 1 Step constMaxScannerBeams \ intNumberOfBeams
                            trvVector.sngRange = trvScanVectors(intBeamNumber).sngRange
                            If (trvVector.sngRange > 0) And (trvVector.sngRange < intScanVectorsMaxRangeInches) Then  ' 
                                trvVector.sngAngle = ftnConvertTo360(trvScanVectors(intBeamNumber).sngAngle + tbpParticlePose(intParticleNumber).Orientation)
                                intDistanceFromWallErrorSquared = ftnDistanceFromWallErrorSquared(tmcVectorOrigin, trvVector, True, boolEndPointInGreySpace)
                                'frmDebug.subWriteLogs("  subLocalizeParticles: Beam " & intBeamNumber & ":  Range = " & trvVector.sngRange & ":  Error = " & intDistanceFromWallErrorSquared)
                                If (intDistanceFromWallErrorSquared < sngOneSigmaSquared) Then
                                    intValidBeamCounter += 3
                                ElseIf (intDistanceFromWallErrorSquared < intOneDotFiveSigmaSquared) Then
                                    intValidBeamCounter += 1
                                End If
                                intDistanceFromWallErrorSquaredSum += intDistanceFromWallErrorSquared
                            End If
                        Next intBeamNumber
                        intValidBeamCounter = intValidBeamCounter \ 3
                        frmDebug.subWriteLogs(" subLocalizeParticles:  intNumberOfBeams = " & intNumberOfBeams)
                        frmDebug.subWriteLogs(" subLocalizeParticles:  intValidBeamCounter = " & intValidBeamCounter)
                        frmDebug.subWriteLogs(" subLocalizeParticles:  intDistanceFromWallErrorSquaredSum = " & intDistanceFromWallErrorSquaredSum)
                        frmDebug.subWriteLogs(" subLocalizeParticles:  Error = " & Sqrt(intDistanceFromWallErrorSquaredSum / intValidBeamCounter) * 0.7 * 0.5)
                    End If
                    If Not tmiMoveInfo.boolBotIsMoving Then
                        If ftnInWall(tbpParticlePose(intParticleNumber).Location) Or ftnLocationOnMapEdge(tbpParticlePose(intParticleNumber).Location) Then
                            subCopyParticle(ftnBestParticle(intNumberOfParticles), intParticleNumber)
                            tbpParticlePose(intParticleNumber) = ftnPoseFrom2DScan(tbpParticleProposalPose(intParticleNumber), sngRMS_Error(intParticleNumber))
                            If ftnInWall(tbpParticlePose(intParticleNumber).Location) Then sngRMS_Error(intParticleNumber) = sngOneDotFiveSigma
                        End If
                    End If
                Next intParticleNumber
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in subLocalizeParticles " & ex.ToString)
        End Try
    End Sub

 
    Sub subConvertParticleOddsToBMP(ByRef intParticleNumber As Short)
        Try
            If boolDebugRBPF Then frmDebug.subWriteShortPose(ftnElapsedTimeS() & "subConvertParticleOddsToBMP: intParticleNumber = " & intParticleNumber & " tbpParticlePose ", tbpParticlePose(intParticleNumber))
            Dim bytePixelOdds As Byte
            For intX As Short = 0 To bmpMap.Width - 1   ' Convert byteParticleMapOdds into bmpMap.   white = free,  black = occupied
                For intY As Short = 0 To bmpMap.Height - 1
                    bytePixelOdds = byteParticleMapOdds(intParticleNumber, intX, intY)
                    If (bytePixelOdds = 16) Then
                        bmpMap.SetPixel(intX, intY, ColorTranslator.FromOle(RGB(223, 223, 223)))
                    ElseIf (bytePixelOdds < 16) Then
                        bmpMap.SetPixel(intX, intY, Color.White)
                    Else
                        bmpMap.SetPixel(intX, intY, Color.Black)
                    End If
                Next intY
            Next intX
            imgMap = bmpMap
            frmGotABotTop.myMap.Image = bmpMap
            frmGotABotTop.myMap.Refresh()
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in subConvertParticleOddsToBMP " & ex.ToString)
        End Try
    End Sub


    Sub subConvertScanToOccupencyOdds(ByRef intNumberOfParticles As Short)
        Try
            If Not boolCollisionDetected Then
                If boolDebugRBPF Then frmDebug.subWriteLogs(ftnElapsedTimeS() & " subConvertScanToOccupencyOdds Start  ")
                Dim tbpThisParticlesPose As typeBotPose
                Dim trvVector As typeRangeVector
                Dim tmcEndPoint, tmcCheckPoint As typeMapCoordinate
                Dim boolRangeExceedsMapLimits As Boolean = False
                Dim tmcVectorOrigin As typeMapCoordinate
                For intParticleNumber As Short = 0 To intNumberOfParticles - 1
                    If Not (tmiMoveInfo.boolBotIsMoving And (sngRMS_Error(intParticleNumber) > sngOkError)) Then
                        If boolDebugRBPF Then frmDebug.subWriteShortPose(ftnElapsedTimeS() & "subConvertScanToOccupencyOdds: intParticleNumber = " & intParticleNumber & ":  sngRMS_Error = " & FormatNumber(sngRMS_Error(intParticleNumber), 2) & " tbpParticlePose ", tbpParticlePose(intParticleNumber))
                        tbpThisParticlesPose = tbpParticlePose(intParticleNumber)
                        tmcVectorOrigin = ftnLocationFromEstimatedPose(tbpThisParticlesPose, tmcScanVectorOffset)
                        For intBeamNumber As Short = 0 To constMaxScannerBeams - 1 '
                            boolRangeExceedsMapLimits = False
                            If (trvScanVectors(intBeamNumber).sngRange > sngBotRadius) Then
                                trvVector.sngRange = trvScanVectors(intBeamNumber).sngRange
                                trvVector.sngAngle = ftnConvertTo360(Convert.ToInt16(trvScanVectors(intBeamNumber).sngAngle) + tbpThisParticlesPose.Orientation)
                                tmcEndPoint = ftnLocationFromLocation(tmcVectorOrigin, trvVector.sngAngle, trvVector.sngRange)
                                While ftnLocationOnMapEdge(tmcEndPoint) And (trvVector.sngRange > sngBotRadius) ' Vector extends beyond map limits,  reduce it
                                    boolRangeExceedsMapLimits = True
                                    trvVector.sngRange -= 1
                                    tmcEndPoint = ftnLocationFromLocation(tmcVectorOrigin, trvVector.sngAngle, trvVector.sngRange) ' 
                                End While
                                tmcCheckPoint = ftnFirstPointOnLine(tmcVectorOrigin, tmcEndPoint)
                                While Not ftnLocationsEqual(tmcCheckPoint, tmcEndPoint)
                                    subUpdateCellOccupencyEmpty(tmcCheckPoint, intParticleNumber)  ' empty space
                                    tmcCheckPoint = ftnNextPointOnLine(tmcCheckPoint)
                                End While
                                If (trvVector.sngRange < intScanVectorsMaxRangeInches) And Not boolRangeExceedsMapLimits Then _
                                  subUpdateCellOccupencyFull(tmcEndPoint, intParticleNumber) ' wall
                            End If
                        Next intBeamNumber
                    End If
                Next intParticleNumber
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in subConvertScanToOccupencyOdds " & ex.ToString)
        End Try
    End Sub


    Sub subUpdateCellOccupencyEmpty(ByRef tmcLocation As typeMapCoordinate, ByRef intParticleNumber As Short)  ' 
        Try ' byteParticleMapOdds :  0 = Empty,  16 = 50% Odds of Empty or Occupied,  255 = Occupied
            Dim intLocationOdds As Byte = byteParticleMapOdds(intParticleNumber, tmcLocation.X, tmcLocation.Y)
            If (intLocationOdds <> 255) Then _
              byteParticleMapOdds(intParticleNumber, tmcLocation.X, tmcLocation.Y) = intLocationOdds \ 3
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in subUpdateCellOccupencyEmpty " & ex.ToString)
        End Try
    End Sub

    Sub subUpdateCellOccupencyFull(ByRef tmcLocation As typeMapCoordinate, ByRef intParticleNumber As Short)  ' 
        Try ' byteParticleMapOdds :  0 = Empty,  16 = 50% Odds of Empty or Occupied,  255 = Occupied
            Dim intLocationOdds As Short = byteParticleMapOdds(intParticleNumber, tmcLocation.X, tmcLocation.Y)
            byteParticleMapOdds(intParticleNumber, tmcLocation.X, tmcLocation.Y) = Min(intLocationOdds * 3, 255)
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in subUpdateCellOccupencyFull " & ex.ToString)
        End Try
    End Sub


    Public Function ftnGenerateGaussian() As Single
        Try ' Generate gaussian number with sigma = 0.5.  Range = +/- 3
            ftnGenerateGaussian = 0
            For i As Short = 1 To 12   ' 
                ftnGenerateGaussian += Rnd()
            Next i
            ftnGenerateGaussian -= 6
            If ftnGenerateGaussian > 3 Then ftnGenerateGaussian = 3
            If ftnGenerateGaussian < -3 Then ftnGenerateGaussian = -3
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in ftnGenerateGaussian " & ex.ToString)
        End Try
    End Function

    Function ftnResampleRequired(ByRef intNumberOfParticles As Short) As Boolean
        ' Normalize the weight array then calculate the Resample Factor
        Try
            subNormalizeWeights(intNumberOfParticles)
            Dim sngResampleFactor As Single = 0
            For intParticleNumber As Short = 0 To intNumberOfParticles - 1
                sngResampleFactor += sngParticleWeightNormalized(intParticleNumber) * sngParticleWeightNormalized(intParticleNumber)
            Next intParticleNumber
            sngResampleFactor = 1 / sngResampleFactor
            ftnResampleRequired = (sngResampleFactor < (intNumberOfParticles * 0.85))
            If boolDebugRBPF Then _
                frmDebug.subWriteLogs("ftnResampleRequired:    sngResampleFactor = " & sngResampleFactor)
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in ftnResampleRequired " & ex.ToString)
        End Try
    End Function

    Sub subNormalizeWeights(ByRef intNumberOfParticles As Short)
        Try
            Dim sngParticleWeight(intNumberOfParticles) As Single
            For intParticleNumber As Short = 0 To intNumberOfParticles - 1
                sngParticleWeight(intParticleNumber) = 1 / sngRMS_Error(intParticleNumber)
            Next intParticleNumber
            Dim sngWeightTotal As Single = sngParticleWeight.Sum
            For intParticleNumber As Short = 0 To intNumberOfParticles - 1
                sngParticleWeightNormalized(intParticleNumber) = sngParticleWeight(intParticleNumber) / sngWeightTotal
            Next intParticleNumber
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in subNormalizeWeights " & ex.ToString)
        End Try
    End Sub

    Public Sub subStochasticUniversalSampling(ByVal intNumberOfParticles As Short)
        ' sample tpParticles using Stochastic Universal Sampling
        ' complexity of O(N)
        ' Stochastic Universal Sampling is an elaborately-named variation of roulette wheel selection. 
        ' Stochastic Universal Sampling ensures that the observed selection frequencies of each individual are in line 
        ' with the expected frequencies. So if we have an individual that occupies 4.5% of the wheel and we select 100 
        ' individuals, we would expect on average for that individual to be selected between four and five times.
        Try
            If ftnResampleRequired(intNumberOfParticles) Then
                'If boolDebugRBPF Then 
                frmDebug.subWriteLogs(ftnElapsedTimeS() & "========================  subStochasticUniversalSampling  ==========================================  ")
                'If boolDebugRBPF Then frmDebug.subWriteLogs( "Resample: Original intBestParticle = " & intBestParticle )
                Dim intOrignalParticle As Short = 0
                Dim dblCumulativeSum As Double = sngParticleWeightNormalized(0)
                Dim dblSelectionSum As Double = 0
                ' Dim sngNewRMS_Error(intNumberOfParticles) As Single
                Dim tbpNewParticlePoses(intNumberOfParticles) As typeBotPose
                Dim tbpNewParticleStartPose(intNumberOfParticles) As typeBotPose
                Dim tbpNewParticleProposalPose(intNumberOfParticles) As typeBotPose
                Dim byteNewParticleOdds(intNumberOfParticles, bmpMap.Width, bmpMap.Height) As Byte
                subReplaceWorstParticle(intNumberOfParticles)
                For intNewSample As Short = 0 To intNumberOfParticles - 1
                    dblSelectionSum = intNewSample / intNumberOfParticles
                    While (dblSelectionSum > dblCumulativeSum)
                        intOrignalParticle += 1
                        If (intOrignalParticle = intNumberOfParticles) Then intOrignalParticle = 0
                        dblCumulativeSum += sngParticleWeightNormalized(intOrignalParticle)
                    End While
                    Dim intOddsLength As Integer = byteParticleMapOdds.GetLength(1) * byteParticleMapOdds.GetLength(2)
                    Array.Copy(byteParticleMapOdds, intOrignalParticle * intOddsLength, byteNewParticleOdds, intNewSample * intOddsLength, intOddsLength)
                    tbpNewParticlePoses(intNewSample) = tbpParticlePose(intOrignalParticle)
                    tbpNewParticleStartPose(intNewSample) = tbpParticleStartPose(intOrignalParticle)
                    tbpNewParticleProposalPose(intNewSample) = tbpParticleProposalPose(intOrignalParticle)
                Next intNewSample
                byteParticleMapOdds = byteNewParticleOdds
                For intParticleNumber = 0 To intNumberOfParticles - 1
                    tbpParticlePose(intParticleNumber) = tbpNewParticlePoses(intParticleNumber)
                    tbpParticleProposalPose(intParticleNumber) = tbpNewParticleProposalPose(intParticleNumber)
                    tbpParticleStartPose(intParticleNumber) = tbpNewParticleStartPose(intParticleNumber)
                Next intParticleNumber
                intBestParticle = ftnBestParticle(intNumberOfParticles)
                If boolDebugRBPF Then frmDebug.subWriteLogs("subStochasticUniversalSampling:    intBestParticle after sampling = " & intBestParticle)
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in subStochasticUniversalSampling " & ex.ToString)
        End Try
    End Sub

    Sub subReplaceWorstParticle(ByVal intNumberOfParticles As Short)
        Try
            If boolDebugRBPF Then frmDebug.subWriteLogs(" =====================================  subReplaceWorstParticle: ====================")
            Dim intWorstParticle As Short = ftnWorstParticle(intNumberOfParticles)
            subCopyParticle(ftnBestParticle(intNumberOfParticles), intWorstParticle)
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in subReplaceWorstParticle " & ex.ToString)
        End Try
    End Sub


    Public Sub subCopyParticle(ByVal intSourceParticle As Short, ByVal intDestinationParticle As Short)
        Try
            If boolDebugRBPF Then frmDebug.subWriteLogs(" =====================================  subCopyParticle: ====================" & intSourceParticle & " to " & intDestinationParticle)
            Dim intOddsLength As Integer = byteParticleMapOdds.GetLength(1) * byteParticleMapOdds.GetLength(2)
            Array.Copy(byteParticleMapOdds, intSourceParticle * intOddsLength, byteParticleMapOdds, intDestinationParticle * intOddsLength, intOddsLength)
            sngRMS_Error(intDestinationParticle) = sngRMS_Error(intSourceParticle)
            tbpParticlePose(intDestinationParticle) = tbpParticlePose(intSourceParticle)
            tbpParticleStartPose(intDestinationParticle) = tbpParticleStartPose(intSourceParticle)
            tbpParticleProposalPose(intDestinationParticle) = tbpParticleProposalPose(intSourceParticle)
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in subCopyParticle " & ex.ToString)
        End Try
    End Sub



    Function ftnBestParticle(ByVal intNumberOfParticles As Short) As Short
        Try
            ftnBestParticle = 0
            For i As Short = 1 To intNumberOfParticles - 1
                If (sngRMS_Error(i) < sngRMS_Error(ftnBestParticle)) Then _
                    ftnBestParticle = i
            Next i
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in ftnBestParticle " & ex.ToString)
        End Try
    End Function

    Function ftnWorstParticle(ByVal intNumberOfParticles As Short) As Short
        Try
            ftnWorstParticle = 0
            For i As Short = 1 To intNumberOfParticles - 1
                If (sngRMS_Error(i) > sngRMS_Error(ftnWorstParticle)) Then
                    ftnWorstParticle = i
                End If
            Next
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in ftnWorstParticle " & ex.ToString)
        End Try
    End Function




    Public Sub subGenerateDistanceFromWallSquaredSegmentArray(ByVal intParticleNumber As Short) ' 
        ' Precalculate  intDistanceFromWallSquaredArray() for a segment of a particle's map which encompasses the sensor's FOV
        ReDim boolOccupiedCell(imgMap.Width, imgMap.Height)
        ReDim intDistanceFromWallSquaredArray(imgMap.Width, imgMap.Height)
        Dim tmcMaxScanLeft, tmcMaxScanRight, tmcMaxScanForward, tmcMaxScanBack As typeMapCoordinate
        Dim tmcSegmentStart, tmcSegmentEnd As typeMapCoordinate
        Dim intX_Min, intX_Max, intY_Min, intY_Max As Short
        Dim tmcLocation1, tmcLocation2 As typeMapCoordinate
        Try
            Dim intMinSafeDistanceFromWall As Short = Max(Round(sngBotRadius + 1), sngOneDotFiveSigma) ' > used to compute ftnInWall and localization
            Dim intMinSafeDistanceFromWallSquared As Short = intMinSafeDistanceFromWall * intMinSafeDistanceFromWall

            Dim tbpPose As typeBotPose = tbpParticleProposalPose(intParticleNumber)
            Dim sngHalfScanFOV As Single = sngScanFOV / 2
            Dim sngLongestScanBeam As Single = ftnLongestBeamDistance()
            tmcMaxScanLeft = ftnLocationFromEstimatedPose(tbpPose, Min(sngHalfScanFOV, 90), sngLongestScanBeam)
            tmcMaxScanRight = ftnLocationFromEstimatedPose(tbpPose, Max(-sngHalfScanFOV, -90), sngLongestScanBeam)
            tmcMaxScanForward = ftnLocationFromEstimatedPose(tbpPose, 0, sngLongestScanBeam)
            tmcSegmentStart = ftnLocationFromEstimatedPose(tbpPose, tmcScanVectorOffset)
            tmcSegmentEnd = tmcSegmentStart

            tmcSegmentStart.X = Min(tmcSegmentStart.X, tmcMaxScanLeft.X)
            tmcSegmentStart.X = Min(tmcSegmentStart.X, tmcMaxScanRight.X)
            tmcSegmentStart.X = Min(tmcSegmentStart.X, tmcMaxScanForward.X)
            tmcSegmentStart.X -= (intMinSafeDistanceFromWall + tbpParticlePose(intParticleNumber).LocationUncertainty.X)
            tmcSegmentStart.Y = Min(tmcSegmentStart.Y, tmcMaxScanLeft.Y)
            tmcSegmentStart.Y = Min(tmcSegmentStart.Y, tmcMaxScanRight.Y)
            If sngScanFOV > 180 Then
                tmcMaxScanBack = ftnLocationFromEstimatedPose(tbpPose, sngHalfScanFOV, sngLongestScanBeam)
                tmcSegmentStart.Y = Min(tmcSegmentStart.Y, tmcMaxScanBack.Y)
                tmcMaxScanBack = ftnLocationFromEstimatedPose(tbpPose, -sngHalfScanFOV, sngLongestScanBeam)
                tmcSegmentStart.Y = Min(tmcSegmentStart.Y, tmcMaxScanBack.Y)
            End If
            tmcSegmentStart.Y = Min(tmcSegmentStart.Y, tmcMaxScanForward.Y)
            tmcSegmentStart.Y -= (intMinSafeDistanceFromWall + tbpParticlePose(intParticleNumber).LocationUncertainty.Y)
            tmcSegmentStart = ftnCheckMapArrayLimits(tmcSegmentStart)

            tmcSegmentEnd.X = Max(tmcSegmentEnd.X, tmcMaxScanLeft.X)
            tmcSegmentEnd.X = Max(tmcSegmentEnd.X, tmcMaxScanRight.X)
            tmcSegmentEnd.X = Max(tmcSegmentEnd.X, tmcMaxScanForward.X)
            tmcSegmentEnd.X += (intMinSafeDistanceFromWall + tbpParticlePose(intParticleNumber).LocationUncertainty.X)
            tmcSegmentEnd.Y = Max(tmcSegmentEnd.Y, tmcMaxScanLeft.Y)
            tmcSegmentEnd.Y = Max(tmcSegmentEnd.Y, tmcMaxScanRight.Y)
            If sngScanFOV > 180 Then
                tmcMaxScanBack = ftnLocationFromEstimatedPose(tbpPose, sngHalfScanFOV, sngLongestScanBeam)
                tmcSegmentEnd.Y = Max(tmcSegmentEnd.Y, tmcMaxScanBack.Y)
                tmcMaxScanBack = ftnLocationFromEstimatedPose(tbpPose, -sngHalfScanFOV, sngLongestScanBeam)
                tmcSegmentEnd.Y = Max(tmcSegmentEnd.Y, tmcMaxScanBack.Y)
            End If
            tmcSegmentEnd.Y = Max(tmcSegmentEnd.Y, tmcMaxScanForward.Y)
            tmcSegmentEnd.Y += (intMinSafeDistanceFromWall + tbpParticlePose(intParticleNumber).LocationUncertainty.Y)
            tmcSegmentEnd = ftnCheckMapArrayLimits(tmcSegmentEnd)

            If boolDebugRBPF Then
                frmDebug.subWriteLogs(" EsubGenerateDistanceFromWallSquaredSegmentArray: intMinSafeDistanceFromWall " & intMinSafeDistanceFromWall)
                frmDebug.subWriteCoordinate(" subGenerateDistanceFromWallSquaredSegmentArray:  tmcSegmentStart ", tmcSegmentStart)
                frmDebug.subWriteCoordinate(" subGenerateDistanceFromWallSquaredSegmentArray:  tmcSegmentEnd ", tmcSegmentEnd)
            End If
            For intX As Short = tmcSegmentStart.X + 1 To tmcSegmentEnd.X - 1   ' Convert the Particle's Odds Array into occupied / free cells for area which encompasses the sensor's FOV
                For intY As Short = tmcSegmentStart.Y + 1 To tmcSegmentEnd.Y - 1
                    boolOccupiedCell(intX, intY) = (byteParticleMapOdds(intParticleNumber, intX, intY) > 16)
                Next intY
            Next intX
            For tmcLocation1.Y = tmcSegmentStart.Y + 1 To tmcSegmentEnd.Y - 1
                For tmcLocation1.X = tmcSegmentStart.X + 1 To tmcSegmentEnd.X - 1 ' Mark wall edges as Distance = 0, otherwise = intMinSafeDistanceFromWallSquared
                    If boolOccupiedCell(tmcLocation1.X, tmcLocation1.Y) Then
                        If (Not boolOccupiedCell(tmcLocation1.X, tmcLocation1.Y + 1)) Then
                            intDistanceFromWallSquaredArray(tmcLocation1.X, tmcLocation1.Y) = 0
                        ElseIf (Not boolOccupiedCell(tmcLocation1.X, tmcLocation1.Y - 1)) Then
                            intDistanceFromWallSquaredArray(tmcLocation1.X, tmcLocation1.Y) = 0
                        ElseIf (Not boolOccupiedCell(tmcLocation1.X + 1, tmcLocation1.Y)) Then
                            intDistanceFromWallSquaredArray(tmcLocation1.X, tmcLocation1.Y) = 0
                        ElseIf (Not boolOccupiedCell(tmcLocation1.X - 1, tmcLocation1.Y)) Then
                            intDistanceFromWallSquaredArray(tmcLocation1.X, tmcLocation1.Y) = 0
                        Else
                            intDistanceFromWallSquaredArray(tmcLocation1.X, tmcLocation1.Y) = intMinSafeDistanceFromWallSquared
                        End If
                    Else
                        intDistanceFromWallSquaredArray(tmcLocation1.X, tmcLocation1.Y) = intMinSafeDistanceFromWallSquared
                    End If
                Next tmcLocation1.X
            Next tmcLocation1.Y

            Dim intX_Diff, intY_Diff, intDistanceFromWallSquared As Short
            For intX As Short = tmcSegmentStart.X To tmcSegmentEnd.X
                For intY As Short = tmcSegmentStart.Y To tmcSegmentEnd.Y
                    If (intDistanceFromWallSquaredArray(intX, intY) = 0) Then  ' location is a wall edge.  Populate nearby cells with distance from this location.
                        intX_Min = (intX - intMinSafeDistanceFromWall)
                        intX_Max = (intX + intMinSafeDistanceFromWall)
                        intY_Min = (intY - intMinSafeDistanceFromWall)
                        intY_Max = (intY + intMinSafeDistanceFromWall)
                        subCheckMapArrayLimits(intX_Min, intX_Max, intY_Min, intY_Max)
                        For tmcLocation2.X = intX_Min To intX_Max ' left and right neighbors
                            intX_Diff = Abs(tmcLocation2.X - intX)
                            For tmcLocation2.Y = intY_Min To intY_Max ' up and down neighbors
                                intY_Diff = Abs(tmcLocation2.Y - intY)
                                intDistanceFromWallSquared = intSquareDistanceArray(intX_Diff, intY_Diff)
                                intDistanceFromWallSquaredArray(tmcLocation2.X, tmcLocation2.Y) = Min(intDistanceFromWallSquaredArray(tmcLocation2.X, tmcLocation2.Y), intDistanceFromWallSquared)
                            Next tmcLocation2.Y
                        Next tmcLocation2.X
                    End If
                Next intY
            Next intX
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in subGenerateDistanceFromWallSquaredSegmentArray " & ex.ToString)
        End Try
    End Sub


    Function ftnLongestBeamDistance() As Single
        Try
            ftnLongestBeamDistance = 0
            For intBeamNumber As Short = 0 To constMaxScannerBeams - 1 Step constMaxScannerBeams \ intNumberOfBeams ' 
                If (trvScanVectors(intBeamNumber).sngRange > ftnLongestBeamDistance) Then ftnLongestBeamDistance = trvScanVectors(intBeamNumber).sngRange
            Next intBeamNumber
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in ftnLongestBeamDistance " & ex.ToString)
        End Try
    End Function

End Module

