﻿Imports System.Drawing
Imports System.Windows.Forms


Module modLocalizeTop

    Public Sub subLocalizeTop()
        Try
            tbpBotPose = ftnLocalize_Top(tbpBotPose, True)
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in subLocalizeTop " & ex.ToString)
        End Try
    End Sub

    Public Function ftnLocalize_Top(ByVal tbpEstimatedPose As typeBotPose, ByRef boolGoodLocalization As Boolean) As typeBotPose
        Try
            ftnLocalize_Top = tbpEstimatedPose
            boolGoodLocalization = False
            Dim timeOut As DateTime = Now().AddMilliseconds(3000)
            While boolLocalizationInProgress And (Now() < timeOut)  ' wait for move to complete
                subWait(25)
            End While
            If Not boolSimulatedMovement And Not boolShutDown And Not boolLocalizationInProgress Then
                boolLocalizationInProgress = True
                Dim boolSettingsChangedOld As Boolean = boolSettingsChanged
                tbpEstimatedPose.Orientation = ftnConvertTo360(tbpEstimatedPose.Orientation)
                Dim tbp2DPose, tbpVisualPose As typeBotPose
                Dim boolGood2DLocalization As Boolean = False
                Dim boolGoodVisualLocalization As Boolean = False
                Dim boolStoppedB4Start As Boolean = (frmGotABotTop.picStop.BorderStyle = FormBorderStyle.Fixed3D)
                Dim sngRMSError As Single = 0
                strStatusDriving = intDrivingSequenceNumber & ":  Localize = "

                If ftnScannerEnabled() Or boolRangersAreEnabled Then
                    If boolEnableRBPF Then
                        tbp2DPose = ftnLocalizeRBPF_Top(tbpEstimatedPose, boolGood2DLocalization)
                    Else
                        tbp2DPose = ftnLocalizeFrom2DScan_Top(ftnLocalize_Top, tbpEstimatedPose, tmiMoveInfo.boolBotIsMoving, boolGood2DLocalization, sngRMSError)
                    End If
                End If

                If ftnVisualRecognizerEnabled() And Not (boolSlam And tmiMoveInfo.boolBotIsMoving) Then
                    If (Not boolGood2DLocalization Or (ftnPoseUncertaintyFactor(tbp2DPose) > 442)) Then  '(442 = (13 inches + 13 inches) * 17 degrees)
                        subStartImageRecognition()
                        tbpVisualPose = ftnLocalizeUsingVisualLMsTop(ftnLocalize_Top, tbpEstimatedPose, boolGoodVisualLocalization)
                    End If
                End If

                If boolGood2DLocalization And boolGoodVisualLocalization Then
                    ftnLocalize_Top = ftnFindAvgPose(tbp2DPose, tbpVisualPose, 0)
                ElseIf boolGood2DLocalization Then
                    ftnLocalize_Top = tbp2DPose
                ElseIf boolGoodVisualLocalization Then
                    ftnLocalize_Top = tbpVisualPose
                End If
                boolGoodLocalization = boolGood2DLocalization Or boolGoodVisualLocalization

                frmDebug.subWritePose(ftnElapsedTimeS() & "       Pose Derived From All Data      ", ftnLocalize_Top)
                boolSettingsChanged = boolSettingsChangedOld
                If ((frmGotABotTop.picStop.BorderStyle = FormBorderStyle.Fixed3D) And Not boolStoppedB4Start) Then
                    ftnLocalize_Top = tbpEstimatedPose
                End If
                If Not tmiMoveInfo.boolBotIsMoving Then tbpBotPose = ftnLocalize_Top
            End If
            boolLocalizationInProgress = False
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in ftnLocalize_Top " & ex.ToString)
            ftnLocalize_Top = tbpEstimatedPose
            boolLocalizationInProgress = False
        End Try
    End Function






    Public Function ftnAccelerometerCheck(ByVal tbpReferencePose As typeBotPose) As typeBotPose ' check for collision using Kinect Accelerometer 
        ftnAccelerometerCheck = tbpReferencePose
#If constCompile2dAccelerometer Then
        If (tmiMoveInfo.tomTypeOfMove = TypeOfMove.FWD) Then
            ftnTransmitGotAKinect("get accelerometer distance ", "OK", 500)
            frmDebug.subWriteLogs( "Kinect Accelerometer Distances: " & tmcAccelerometerDistance.X & ", " & tmcAccelerometerDistance.Y)
            Dim tmcAccelerometer As typeMapCoordinate = ftnLocationFromLocation(tmiMoveInfo.tbpStartingPose.Location, tmiMoveInfo.tbpStartingPose.Orientation, tmcAccelerometerDistance.X)
            frmDebug.subWriteLogs( "Kinect Accelerometer Pose: " & tmcAccelerometer.X & ", " & tmcAccelerometer.Y)
            If (ftnDistanceBetweenLocations(tbpReferencePose.Location, tmcAccelerometer) > 12) Then
                'tbpReferencePose.Location = tmiMoveInfo.tbpStartingPose.Location
                'ftnAccelerometerCheck.Location = ftnBotOffsetLocation(tmcAccelerometerDistance)
                'ftnAccelerometerCheck.LocationUncertainty.X += ftnInchesToMapUnits(9)
                'ftnAccelerometerCheck.LocationUncertainty.X += ftnInchesToMapUnits(9)
                'ftnAccelerometerCheck.OrientationUncertainty += 15
                frmDebug.subWritePose(" Pose after Collision Detected by Kinect sensor", ftnAccelerometerCheck)
            End If
        End If
#End If
    End Function




    Function ftnFindPoseOverlap(ByVal tbpNewPoseReading As typeBotPose, ByVal tbpReferencePose As typeBotPose) As typeBotPose
        Try
            ' Use the existing pose to reduce the uncertainties of a new pose reading
            Dim intMaxX, intMaxY, intMinX, intMinY As Short
            ftnFindPoseOverlap = tbpNewPoseReading
            If (tbpNewPoseReading.Location.X + tbpNewPoseReading.LocationUncertainty.X) > (tbpReferencePose.Location.X + tbpReferencePose.LocationUncertainty.X) Then
                intMaxX = (tbpReferencePose.Location.X + tbpReferencePose.LocationUncertainty.X)
            Else
                intMaxX = (tbpNewPoseReading.Location.X + tbpNewPoseReading.LocationUncertainty.X)
            End If
            If (tbpNewPoseReading.Location.Y + tbpNewPoseReading.LocationUncertainty.Y) > (tbpReferencePose.Location.Y + tbpReferencePose.LocationUncertainty.Y) Then
                intMaxY = (tbpReferencePose.Location.Y + tbpReferencePose.LocationUncertainty.Y)
            Else
                intMaxY = (tbpNewPoseReading.Location.Y + tbpNewPoseReading.LocationUncertainty.Y)
            End If
            If (tbpNewPoseReading.Location.X - tbpNewPoseReading.LocationUncertainty.X) < (tbpReferencePose.Location.X - tbpReferencePose.LocationUncertainty.X) Then
                intMinX = (tbpReferencePose.Location.X - tbpReferencePose.LocationUncertainty.X)
            Else
                intMinX = (tbpNewPoseReading.Location.X - tbpNewPoseReading.LocationUncertainty.X)
            End If
            If (tbpNewPoseReading.Location.Y - tbpNewPoseReading.LocationUncertainty.Y) < (tbpReferencePose.Location.Y - tbpReferencePose.LocationUncertainty.Y) Then
                intMinY = (tbpReferencePose.Location.Y - tbpReferencePose.LocationUncertainty.Y)
            Else
                intMinY = (tbpNewPoseReading.Location.Y - tbpNewPoseReading.LocationUncertainty.Y)
            End If
            ftnFindPoseOverlap.LocationUncertainty.X = (intMaxX - intMinX) \ 2
            ftnFindPoseOverlap.Location.X = intMaxX - ftnFindPoseOverlap.LocationUncertainty.X
            ftnFindPoseOverlap.LocationUncertainty.Y = (intMaxY - intMinY) \ 2
            ftnFindPoseOverlap.Location.Y = intMaxY - ftnFindPoseOverlap.LocationUncertainty.Y
            ftnFindPoseOverlap = ftnMinPoseUncertainty(ftnFindPoseOverlap)
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in ftnFindPoseOverlap " & ex.ToString)
        End Try
    End Function


End Module
