﻿Imports System.Net
Imports System.Net.Sockets
Imports System.Text
Imports Microsoft.Kinect
Imports System.Drawing

Imports Emgu.CV.UI
Imports Emgu.CV
Imports Emgu.CV.Structure
Imports Emgu.CV.CvEnum



'  TODO Get rid of:
'     imgMap.Width,Y


Public Module modPublicDeclarations


    Public Structure typeImageCoordinate
        Dim X As Short
        Dim Y As Short
    End Structure


    Public Structure typeMapCoordinate
        Dim X As Short
        Dim Y As Short
    End Structure

    Public Structure typeMapOffset
        Dim X As Single
        Dim Y As Single
    End Structure



    '==============  Map  ==================
    Public imgMap As Image = System.Drawing.Image.FromFile("GotABot_Map.bmp")
    Public bmpMap As Bitmap = New Bitmap(1024, 1024)
    Public byteNavigationArray(400, 300) As Byte
    Public intDistanceFromWallSquaredArray(400, 300) As Short '  used by modLocalize2DScan
    Public intSquareDistanceArray(14, 14) As Short
    Public boolOccupiedCell(400, 300) As Boolean
    Public boolGreySpace(400, 300) As Boolean
    Public boolNoGo(400, 300) As Boolean
    Public boolCompassIsSuspect(400, 300) As Boolean
    Public sngZoom As Single = 1

    '==============  Map Path   ==================
    Public intPathArray(imgMap.Width, imgMap.Height) As UShort  'Long
    Public tmcDestination As typeMapCoordinate
    Public Const constDestinationCost As UShort = 4096
    Public Const constMaxPathCost As UShort = 65535


    '==============  Bot   ==================
    Public boolER1Selected As Boolean = True
    Public boolRoboRealmBotSelected As Boolean = False
    Public boolHeroSelected As Boolean = True
    Public sngBotDiameter As Single = 17
    Public sngBotRadius As Single = sngBotDiameter / 2
    Public sngBotRadiusSquared As Single = sngBotRadius * sngBotRadius
    Public intBotRadiusZoom As Integer = (sngBotDiameter * sngZoom) \ 2
    Public intBotDiameterZoom As Integer = sngBotDiameter * sngZoom
    Public sngCameraOffset As Single = -2
    Public ticCameraResolution As typeImageCoordinate
    Public sngCameraFOV As Single = 42.0
    Public boolEnableBumperSwitches_ER1 As Boolean = True
    Public strBotComPort As String = "com999"
    Public intHeadAngle As Short = 0
    Public intPowerMoving As Short = 60
    Public intPowerStopped As Short = 60
    Public strGetDigital As String = ""
    Public sngBotWheelSeparation As Single = 38

    '==============  Bot Corrections  ==================
    Public sngSteeringBiasOffsetCorrection As Short = 0
    Public sngDistanceCorrectionCoeff_x2 As Single = -0.0059
    Public sngDistanceCorrectionCoeff_x1 As Single = 0.8986
    Public sngDistanceCorrectionCoeff_x0 As Single = 0.0924
    Public intScanOffsetDegrees As Short = 0  ' Compensates for when Scanner is not pointed directly ahead


    '==============  Bot IP Address  ==================
    Public intLocalRccPort As Integer = 9200
    Public strPassword As String = "Password"


    '==============  Bot Dead Reckoning  ==================
    Public sngBotLinearVelocity As Single = 20    'cm /second
    Public sngBotLinearAcceleration As Single = 70  'cm /second /second 
    Public sngBotLinearAccelerationTime As Single = sngBotLinearVelocity / sngBotLinearAcceleration
    Public sngBotLinearAccelerationDistance As Single = ftnCmToInches(sngBotLinearAcceleration * sngBotLinearAccelerationTime * sngBotLinearAccelerationTime / 2)
 
    Public sngBotAngularVelocity As Single = 30 'degrees /second
    Public sngBotAngularAcceleration As Single = 40  'cm /second /second 
    Public sngBotAngularAccelerationTime As Single = sngBotAngularVelocity / sngBotAngularAcceleration
    Public sngBotAngularAccelerationDistance As Single = (sngBotAngularAcceleration * sngBotAngularAccelerationTime * sngBotAngularAccelerationTime / 2)

    Public sngBotMovementAccuracy As Single = 0.65

    '==============  Move Info  ==================
    Public tbpTargetPosePlanned As typeBotPose
    Public tomTypeOfMovePlanned As TypeOfMove
    Public tbpStartingPosePlanned As typeBotPose
    Public Enum TypeOfMove
        HALT = 0
        FWD = 1
        TURN = 2
        CURVE = 3
        NONE = 4
    End Enum
    Public Structure typeMoveInfo
        Dim tomTypeOfMove As TypeOfMove
        Dim boolBotIsMoving As Boolean
        Dim timeMoveCommandSent As DateTime
        Dim tbpStartingPose As typeBotPose ' 
        Dim tbpTargetPose As typeBotPose ' 
        Dim boolCourseCorrection As Boolean
        Dim boolMoveCommandInProgress As Boolean
        Dim boolParticalStartPoseIsReset As Boolean
    End Structure
    Public tmiMoveInfo As typeMoveInfo
    Public boolSetMoveInfoBusy As Boolean = False
    Public boolGetMoveInfoBusy As Boolean = False


    '==============  Bot Pose  ==================
    Public Structure typeBotPose
        Dim Location As typeMapCoordinate
        Dim LocationUncertainty As typeMapCoordinate
        Dim Orientation As Short
        Dim OrientationUncertainty As Short
    End Structure
    Public tbpBotPose As typeBotPose



    '==============  Driving Control  ==================
    Public boolStop As Boolean = False
    Public boolPause As Boolean = False
    Public boolSimulatedMovement As Boolean = False
    Public boolDrivingToDestination As Boolean = False
    Public sngMaxTurn As Single = 360
    Public intDrivingSequenceNumber As Short
    Public boolCollisionDetected As Boolean = False
    Public boolPoseConfirmedAfterCollision As Boolean = True '
    Public boolCollisionDetectionEnable As Boolean = True
    Public byteCollisionCode As Byte = 7
    Public byteCollisionCode_API As Byte = 7
    Public intLastCollisionSequenceNumber As Short = 0
    Public boolCollisionPredicted As Boolean = False
    Public boolEnableCourseCorrection As Boolean = True
    Public boolEnableCurveMotion As Boolean = False
    Public sngMaxTravel As Single = 111

    '==============  Visual LandMarks  ==================
    Public Structure typeLandMark
        Dim LandMarkName As String
        Dim LandMarkLocation As typeMapCoordinate
        Dim intLandMarkHeight As Short
        Dim LandMarkValidRegion As Rectangle
        Dim LandMarkRecognized As Integer
        Dim LandMarkValid As Integer
    End Structure
    Public tlmLandMarkArray(128) As typeLandMark
    Public tlm2DScanLandMarkArray(128) As typeLandMark

    Public Structure typeImageRecognized
        Dim Name As String
        Dim intNumber As Short  ' Short
        Dim intPixelX As Short
        Dim Range As Single
        Dim sngYRotation As Single
    End Structure

    '==============  SOCKETS  ==================

    Public Class typeSocketClass
        Public workSocket As Socket = Nothing ' Client  socket.
        Public Const BufferSize As Integer = 4096 ' Size of subReceive byteReceiveBuffer.
        Public byteReceiveBuffer(BufferSize) As Byte ' subReceive byteReceiveBuffer
        Public sbReceivedData As New StringBuilder ' Received data string.
    End Class '

    Public Class typeSocketClass_SmallBuffer
        Public workSocket As Socket = Nothing ' Client  socket.
        Public Const BufferSize As Integer = 64 ' Size of subReceive byteReceiveBuffer.
        Public byteReceiveBuffer(BufferSize) As Byte ' subReceive byteReceiveBuffer
        Public sbReceivedData As New StringBuilder ' Received data string.
    End Class '



    '==============  Thread Communications  ==================
    Public strAPIPasswordReceived As String = ""


    '==============  Movement and Localization Control  ==================
    Public boolLocalizationInProgress As Boolean = False
    Public boolEnableLocalizationWhileMoving As Boolean = True
    Public timeDrivingStarted As DateTime
    Public intCollisions As Short = 0

    Public Const constMaxTurnsWithLocalization As Short = 2  '  prevents Bot from turning back and forth repeatedly
    Public intMovementsSinceLocalization As Short = 0   ' used to force localization at least once every x moves


    '==============  API Variables  ==================
    Public sngLaptopBatteryPercent As Single = 999
    Public intApiUncertainty As Short = 9999
    Public intApiOrientation As Short = 0

    '==============   Recognizer Variables  ==================
    Public Const constVisualProcessingDelay = 0.9
    Public sngLocalizationTime As Single = 10
    Public boolEnableLocalRCC As Boolean = False
    Public boolEnableLocalRR As Boolean = False
    Public boolEnableGotAGlyph As Boolean = False
    Public boolEnableFaceRecognition As Boolean = True
    Public boolEnableAVM As Boolean = False



    '==============   RBPF Variables  ==================
    Public intNumberOfParticles As Short = 32
    Public tbpParticlePose(intNumberOfParticles) As typeBotPose
    Public byteParticleMapOdds(intNumberOfParticles, imgMap.Width, imgMap.Height) As Byte  ' 16 = 1:1 odds
    Public boolEnableRBPF As Boolean = True
    Public intBestParticle As Short = 0



    '==============  SLAM Variables  ==================
    Public boolSlam As Boolean = False



    '==============  Misc Variables  ==================
    Public boolAllowRoboRealmToControlBot As Boolean = False
    Public boolAllowRRToControlBotIsActive As Boolean = False
    Public boolViewLM As Boolean = True
    Public boolViewDebug As Boolean = True
    Public boolSettingsChanged As Boolean = False
    Public boolMute As Boolean = False
    Public boolShutDown As Boolean = False
    Public boolMapUpdatedWithObstacle As Boolean = False

    '==============  Communication Status  ==================
    Public boolBotConnected As Boolean = False
    Public boolLocalRCCConnected As Boolean = False
    Public boolRRConnected As Boolean = False


    '==============   Status Line  ==================
    Public strStatusDriving As String = String.Format("{0, -35}", "Waiting for command:     ")
    Public strStatusCommunications As String = String.Format("{0, -35}", "Coms:     ")
    Public strStatusBotVoltage As String = String.Format("{0, -15}", "   --   ")
    Public strStatusLaptopVoltage As String = String.Format("{0, -20}", "   --   ")
    Public strStatusMouseCoordinates As String = String.Format("{0, -15}", "    x,y    ")
    Public strStatusAPIMessage As String = String.Format("{0, -45}", "API: Not connected          ")
    Public strStatusMapContents As String = String.Format("{0, -15}", "   --   ")


    '==============  Docking  ==================
    Public boolDock As Boolean = False
    Public boolDocked As Boolean = False
    Public tmcDock As typeMapCoordinate
    Public intDockOrientation As Short = 0  '  Orientation of Bot when docked
    Public boolDockBackIn As Boolean = False
    Public intDockTriggerPC As Short = 30
    Public sngDockTriggerBot As Single = 11
    Public sngBotBatteryVoltage As Single = 2000


    '==============   Range Finder Variables  ==================
    Public intHighestEnabledRangerNumber As Short = 14
    Public boolRangersAreEnabled As Boolean = False
    Public Structure typeRangeFinder
        Dim boolEnable As Boolean
        Dim intOffset As typeMapCoordinate
        Dim intOrientation As Short
        Dim intType As Short
        Dim sngRange As Single
        Dim sngMaxRange As Single
        Dim intCalibrate As Short
    End Structure
    Public trfRangeFinders(intHighestEnabledRangerNumber) As typeRangeFinder
    Public intAnalogReading As Integer = 0
    Public Structure typeRangeVector
        Dim sngAngle As Single
        Dim sngRange As Single
    End Structure
    Public Const constIR_MaxRange = 80  'cm
    Public intNumberOfEnabledRangers As Short = 4
    Public intRangeCorrectionFactor(intHighestEnabledRangerNumber) As Integer

    '================== Kinect   ========================
    Public K_Sensor As KinectSensor = Nothing
    Public boolKinectConnected As Boolean = False
    Public intDefaultElevation As Short = 10

    '================== URG04   ========================
    Public strURGComPort As String = "COM3"
    Public boolURGConnected As Boolean = False

    '================== Scan Vectors (from Kinect, URG, API or whatever)   ========================
    Public Const constMaxScannerBeams As Short = 640
    Public intNumberOfBeamsDefault As Short = 32
    Public intNumberOfBeams As Short = 32
    Public sngScannerCalCoefficients(constMaxScannerBeams) As Single
    Public sngScannerCalibrate As Single = 1
    Public sngScannerCurveAdjust As Single = 0
    Public tmcScanVectorOffset As typeMapCoordinate
    Public trvScanVectors(constMaxScannerBeams) As typeRangeVector

    Public intScannerDelay As Short = 0.3
    Public sngScanFOV As Single = 58.5
    Public intScanVectorsMaxRangeInches As Short = 177
    Public intScanVectorsMinRangeInches As Short = 20
    Public boolShowVectors As Boolean
    Public boolShowGreenVectors As Boolean = False



    '================== Precalculated Distances  ========================
    Public sngOneSigma As Single = 5
    Public sngOneSigmaSquared As Single = sngOneSigma * sngOneSigma
    Public sngOneDotFiveSigma As Single = 1.5 * sngOneSigma
    Public sngRecipOneDotFiveSigma As Single = 1 / sngOneDotFiveSigma
    Public intOneDotFiveSigmaSquared As Short = sngOneDotFiveSigma * sngOneDotFiveSigma
    Public sngTwoSigma As Single = 2 * sngOneSigma
    Public intMaxPathDistanceFromWallSquared As Short = (sngBotRadius + 0.5 + 8) ^ 2
    Public intSafeDistanceFromWallSquared As Short = (sngBotRadius + 0.5 + 3) ^ 2
    Public intSaferDistanceFromWallSquared As Short = (sngBotRadius + 0.5 + 2) ^ 2
    Public sngUnacceptableError As Single = 4
    Public sngOkError As Single = 3
    Public sngLowError As Single = 2


    '================== Voice   ========================
    Public strNewsURL As String = "http://www.npr.org/player/v2/mediaPlayer.html?action=1&t=4&islist=false"
    Public strWeatherURL As String = "http://weather.yahooapis.com/forecastrss?w=743&u=c"
    Public boolVoiceCommandEnable As Boolean = True
    Public tmcDestinationAlpha As typeMapCoordinate
    Public tmcDestinationBravo As typeMapCoordinate
    Public tmcDestinationCharlie As typeMapCoordinate
    Public tmcDestinationDelta As typeMapCoordinate
    Public tmcDestinationEcho As typeMapCoordinate


    '================== Debug Log File  ========================
    Public boolDebugDrive As Boolean = False   ' 
    Public boolDebugCC As Boolean = False   '
    Public boolDebugObstacle As Boolean = False ' 
    Public boolDebugER1IF As Boolean = False   ' 
    Public boolDebugHero As Boolean = False   ' 
    Public boolDebugAPI_IF As Boolean = False   ' 
    Public boolDebugOdometry As Boolean = False   ' 
    Public boolDebugLocalize2D As Boolean = False   ' 
    Public boolDebugKinect As Boolean = False   ' 
    Public boolDebugDock As Boolean = False    ' 
    Public boolDebugCompass As Boolean = False
    Public boolDebugPath As Boolean = False
    Public boolDebugCollision As Boolean = False
    Public boolDebugSpeech As Boolean = False
    Public boolDebugSlam As Boolean = False
    Public boolDebugRBPF As Boolean = False
    Public boolDebugURG As Boolean = False
    Public boolDebugDR As Boolean = False   ' 
    Public booldebugArm As Boolean = False

    Public boolLogFileEnable As Boolean = True


    '================== Compass   ========================
    Public intCompassOrientation As Short = 0
    Public intCompassOrientationUncertainty As Integer = 16
    Public intCompassOrientationOffset As Integer = 0
    Public boolCompassAttached As Boolean = False
    Public gravity As Double() = {0, 0, 0}
    Public boolPhidgetsInstalled As Boolean = False




    '================== Arm   ========================
    '==============   Arm Variables  ==================
    Public boolEnableArm As Boolean = True


    Public Structure typePointCoordinate 'Coordinates in mm
        Dim X As Short
        Dim Y As Short
        Dim Z As Short
    End Structure

    Public timeJointMove(9) As DateTime

    '================== Videon   ========================
    Public boolEnableVideo As Boolean = False
    Public intVideoSource As Integer = 1

    '================== Facial Recognition   ========================
  

    Public Structure typeFaceClassifier
        Dim strFaceName As String
        Dim X As Short
        Dim Y As Short
        Dim intSize As Short
    End Structure


    '================== Debug Log File   ========================
    'Public boolQueueBusy As Boolean = False
    Public queueLogEntries As New Queue(150)


End Module
