﻿

Imports System.Speech
Imports System.Speech.Recognition
Imports System.Drawing
Imports System.Windows.Forms
Imports System.Threading
Imports System.Math


Module modSpeechRecognition


    '================== Speech Recognition   ========================
    Dim boolIgnoreSpeech As Boolean = False



    Public WithEvents reco As New SpeechRecognitionEngine

    Public Sub subStartSpeechRecognition()
        Try
            boolIgnoreSpeech = False
            If (Dir("C:\Windows\Speech\Common\sapisvr.exe") <> "") Then
                If (Process.GetProcessesByName("sapisvr").Count = 0) Then _
                    Process.Start("C:\Windows\Speech\Common\sapisvr.exe")
            End If
            If reco IsNot Nothing Then
                reco.RecognizeAsyncStop()
                reco.BabbleTimeout = TimeSpan.FromSeconds(1.0)
                reco.InitialSilenceTimeout = TimeSpan.FromSeconds(1.0)
                reco.EndSilenceTimeout = TimeSpan.FromSeconds(0.5)
                Dim gram As New Recognition.SrgsGrammar.SrgsDocument
                Dim GotAVoiceRule As New Recognition.SrgsGrammar.SrgsRule("GotAVoice")
                Dim GotAVoiceList As New Recognition.SrgsGrammar.SrgsOneOf("GotABot go to destination alpha", "GotABot go to destination bravo", _
                                                                           "GotABot go to destination charlie", "GotABot go to destination delta", "GotABot go to destination echo", _
                                                                           "GotABot stop movement", "GotABot pause mode", _
                                                                           "GotABot move forwards", "GotABot move backwards", _
                                                                           "GotABot turn right", "GotABot turn left", _
                                                                           "GotABot return to dock", "GotABot turnaround", _
                                                                           "GotABot what is your status", _
                                                                           "GotABot localize", "GotABot tell me the time", _
                                                                           "GotABot what is the weather", _
                                                                           "GotABot play newscast", _
                                                                           "GotABot execute batch file alpha", "GotABot execute batch file bravo", _
                                                                           "GotABot execute batch file charlie", "GotABot execute batch file delta", "GotABot execute batch file echo", _
                                                                           "GotABot tell me a joke", _
                                                                           "GotABot start listening", "GotABot dont listen", _
                                                                           "GotABot look up", "GotABot look down", _
                                                                           "GotABot look at me", "GotABot who am i", "GotABot remember my face", _
                                                                           "GotABot thankyou", "GotABot goodbye", "GotABot hello")
                GotAVoiceRule.Add(GotAVoiceList)
                gram.Rules.Add(GotAVoiceRule)
                gram.Root = GotAVoiceRule
                reco.LoadGrammar(New Recognition.Grammar(gram))
                reco.SetInputToDefaultAudioDevice()
                reco.RecognizeAsync(RecognizeMode.Multiple)
                timeLockout = Now()
            End If
        Catch ex As Exception
            boolIgnoreSpeech = False
            frmDebug.subWriteLogs(" EXCEPTION in subStartSpeechRecognition " & ex.ToString)
        End Try
    End Sub

    Public Sub subDisableSpeechRecognition()
        Try
            boolIgnoreSpeech = True
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in subDisableSpeechRecognition " & ex.ToString)
        End Try
    End Sub

    Dim timeLockout As DateTime
    Public Sub subEnableSpeechRecognition()
        Try
            boolIgnoreSpeech = False
            timeLockout = Now().AddMilliseconds(750)
            'reco.RecognizeAsync(RecognizeMode.Multiple)
            'reco.SetInputToDefaultAudioDevice()
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in subEnableSpeechRecognition " & ex.ToString)
        End Try
    End Sub


    Public Sub subSpeechEnableChange()
        Try
            If boolVoiceCommandEnable Then
                subStartSpeechRecognition()
            Else
                subDisableSpeechRecognition()
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in subSpeechEnableChange " & ex.ToString)
        End Try
    End Sub

    Private Sub reco_SpeechRecognized(ByVal sender As Object, ByVal e As System.Speech.Recognition.RecognitionEventArgs) Handles reco.SpeechRecognized
        Try
            If boolVoiceCommandEnable Then
                strStatusDriving = e.Result.Text
                If boolDebugSpeech Then _
                  frmDebug.subWriteLogs(Now() & " new speech = " & e.Result.Text)
                If (e.Result.Text = "GotABot stop movement") Then
                    If tmiMoveInfo.boolBotIsMoving Then tbpBotPose.OrientationUncertainty += 15
                    tbpBotPose = modBotMovementControl.ftnBotStop(tbpBotPose, tmiMoveInfo.tbpTargetPose)
                    ftnSendCommand("play phrase 'I am stopped'")
                    tbpBotPose = ftnLocalize_Top(tbpBotPose, True)
                ElseIf (e.Result.Text = "GotABot start listening") Then
                    boolIgnoreSpeech = False
                    subSpeak(" play phraseA 'OK'")
                ElseIf Not tmiMoveInfo.boolBotIsMoving And (Now() > timeLockout) And Not boolIgnoreSpeech Then
                    Select Case e.Result.Text
                        Case "GotABot dont listen"
                            subSpeak(" play phraseA 'OK'")
                            boolIgnoreSpeech = True
                        Case "GotABot pause mode"
                            boolPause = Not boolPause
                            If boolPause Then ftnSendCommand("play phrase 'I am in pause mode.'")
                            If boolPause Then frmDebug.subWriteLogs(Now() & "    >>>>  PAUSE voice command received  >>> ")
                        Case "GotABot what is your status"
                            subStaus()
                        Case "GotABot thankyou"
                            subThanks()
                        Case "GotABot goodbye"
                            subGoodBye()
                        Case "GotABot hello"
                            subHi()
                        Case "GotABot localize"
                            tbpBotPose = ftnLocalize_Top(tbpBotPose, True)
                            ftnSendCommand("play phraseA localizing")
                        Case "GotABot what is the weather"
                            Dim strWeather As String = ftnGetWeatherRSS("https://query.yahooapis.com/v1/public/yql?q=select%20*%20from%20weather.forecast%20where%20woeid%20in%20(select%20woeid%20from%20geo.places(1)%20where%20text%3D%22" & strWeatherURL & "%2C%20ak%22)&format=xml&env=store%3A%2F%2Fdatatables.org%2Falltableswithkeys")
                            ftnSendCommand("play phrase '" & strWeather & "'")
                        Case "GotABot tell me the time"
                            Dim strTime As String = DateTime.Now().ToShortTimeString()
                            ftnSendCommand("play phrase '" & strTime & "'")
                        Case "GotABot return to dock"
                            Dim threadDock As New Thread(AddressOf frmDock.subDock)
                            threadDock.Start()
                        Case "GotABot tell me a joke"
                            subJoke()
                        Case "GotABot play newscast"
                            ftnSendCommand("play phraseA 'Starting news.'")
                            Process.Start(strNewsURL)
                        Case "GotABot move forwards"
                            ftnSendCommand("play phraseA 'Moving forward.'")
                            boolStop = False
                            Dim tbpTargetPose As typeBotPose = tbpBotPose
                            tbpTargetPose.Location = ftnLocationFromEstimatedPose(tbpBotPose, 0, 12)
                            tbpBotPose = ftnBotFwd(tbpBotPose, tbpTargetPose)
                        Case "GotABot move backwards"
                            ftnSendCommand("play phraseA 'Moving back.'")
                            boolStop = False
                            Dim tbpTargetPose As typeBotPose = tbpBotPose
                            tbpTargetPose.Location = ftnLocationFromEstimatedPose(tbpBotPose, 0, -6)
                            tbpBotPose = ftnBotFwd(tbpBotPose, tbpTargetPose)
                        Case "GotABot turn right"
                            ftnSendCommand("play phraseA 'Turning Right.'")
                            boolStop = False
                            Dim tbpTargetPose As typeBotPose = tbpBotPose
                            tbpTargetPose.Orientation = ftnConvertTo360(tbpTargetPose.Orientation - 45)
                            tbpBotPose = ftnBotTurn(tbpBotPose, False, tbpTargetPose)
                        Case "GotABot turn left"
                            ftnSendCommand("play phraseA 'Turning Left.'")
                            boolStop = False
                            Dim tbpTargetPose As typeBotPose = tbpBotPose
                            tbpTargetPose.Orientation = ftnConvertTo360(tbpTargetPose.Orientation + 45)
                            tbpBotPose = ftnBotTurn(tbpBotPose, False, tbpTargetPose)
                        Case "GotABot turnaround"
                            ftnSendCommand("play phraseA 'Turning around.'")
                            boolStop = False
                            Dim tbpTargetPose As typeBotPose = tbpBotPose
                            tbpTargetPose.Orientation = ftnConvertTo360(tbpTargetPose.Orientation + 180)
                            tbpBotPose = ftnBotTurn(tbpBotPose, False, tbpTargetPose)
                        Case "GotABot look up"
                            If boolEnableArm Then
                                Dim sngGripperOrientation As Single = classArm.ftnGetCameraPose().Orientation + 15
                                classArm.ftnSetGripperOrientation(sngGripperOrientation, False, False, False)
                            ElseIf boolKinectDriversInstalled Then  ' KLUDGE
                                If K_Sensor IsNot Nothing Then _
                                   K_Sensor.ElevationAngle() = K_Sensor.ElevationAngle() + 15
                            End If
                        Case "GotABot look down"
                            If boolEnableArm Then
                                Dim sngGripperOrientation As Single = classArm.ftnGetCameraPose().Orientation - 15
                                classArm.ftnSetGripperOrientation(sngGripperOrientation, False, False, False)
                            ElseIf boolKinectDriversInstalled Then  ' KLUDGE
                                If K_Sensor IsNot Nothing Then _
                                    K_Sensor.ElevationAngle() = K_Sensor.ElevationAngle() - 15
                            End If
                        Case "GotABot remember my face"
                            boolEnableFaceRecognition = True
                            subSpeak(" play phraseA 'OK'")
                            frmFaceTraining.resultImages.Clear()
                            frmFaceTraining.intNumFacesToAquire = 10
                            frmFaceTraining.boolRECORD = True
                        Case "GotABot who am i"
                            Dim boolEnableFaceRecognitionTemp As Boolean = boolEnableFaceRecognition
                            boolEnableFaceRecognition = True
                            frmVideo.subFaceRecognition()
                            subWhoAmI()
                            boolEnableFaceRecognition = boolEnableFaceRecognitionTemp
                        Case "GotABot look at me"
                            Dim boolEnableFaceRecognitionTemp As Boolean = boolEnableFaceRecognition
                            boolEnableFaceRecognition = True
                            frmVideo.subFaceRecognition()
                            Dim tfcFaces() As typeFaceClassifier = frmVideo.ftnGetFaceResults()
                            tfcFaces = frmVideo.ftnGetFaceResults
                            Dim intHeight As Integer = 480
                            Dim intWidth As Integer = intHeight * ticCameraResolution.X / ticCameraResolution.Y
                            boolStop = False
                            If tfcFaces(0).strFaceName <> "" Then
                                ftnSendCommand("play phrase 'OK")
                                If boolEnableArm And (Abs(tfcFaces(0).Y - intHeight / 2) > 10) Then '
                                    Dim sngCameraOrientation As Single = classArm.ftnGetCameraPose().Orientation
                                    Dim sngDegreesToCenterY As Single = -(tfcFaces(0).Y - intHeight / 2) * sngCameraFOV / intWidth
                                    classArm.ftnSetGripperOrientation(sngCameraOrientation + sngDegreesToCenterY, False, False, False)
                                End If
                                If (Abs(tfcFaces(0).X - intWidth / 2) > 10) Then ' 
                                    Dim sngDegreesToCenterX As Single = (intWidth / 2 - tfcFaces(0).X) * sngCameraFOV / intWidth
                                    Dim tbpTargetPose As typeBotPose = tbpBotPose
                                    tbpTargetPose.Orientation = ftnConvertTo360(tbpTargetPose.Orientation + sngDegreesToCenterX)
                                    tbpBotPose = ftnBotTurn(tbpBotPose, False, tbpTargetPose)
                                End If
                            Else
                                subSpeak("play phraseA  'I dont see anyone'")
                            End If
                            boolEnableFaceRecognition = boolEnableFaceRecognitionTemp
                        Case "GotABot execute batch file alpha"
                            If (Dir("kbatch_alpha.bat") <> "") Then
                                ftnSendCommand("play phrase 'starting batch file alpha")
                                Process.Start("kbatch_alpha.bat")
                            Else
                                ftnSendCommand("play phrase 'Batch file not found")
                            End If
                        Case "GotABot execute batch file bravo"
                            If (Dir("kbatch_bravo.bat") <> "") Then
                                ftnSendCommand("play phrase 'starting batch file bravo")
                                Process.Start("kbatch_bravo.bat")
                            Else
                                ftnSendCommand("play phrase 'Batch file not found")
                            End If
                        Case "GotABot execute batch file charlie"
                            If (Dir("kbatch_charlie.bat") <> "") Then
                                ftnSendCommand("play phrase 'starting batch file charlie")
                                Process.Start("kbatch_charlie.bat")
                            Else
                                ftnSendCommand("play phrase 'Batch file not found")
                            End If
                        Case "GotABot execute batch file delta"
                            If (Dir("kbatch_delta.bat") <> "") Then
                                ftnSendCommand("play phrase 'starting batch file delta")
                                Process.Start("kbatch_delta.bat")
                            Else
                                ftnSendCommand("play phrase 'Batch file not found")
                            End If
                        Case "GotABot execute batch file echo"
                            If (Dir("kbatch_echo.bat") <> "") Then
                                ftnSendCommand("play phrase 'starting batch file echo")
                                Process.Start("kbatch_echo.bat")
                            Else
                                ftnSendCommand("play phrase 'Batch file not found")
                            End If
                        Case "GotABot go to destination alpha"
                            ftnSendCommand("play phrase 'Destination alpha selected")
                            tmcDestination = tmcDestinationAlpha
                            Dim threadDriveToDestination As New Thread(AddressOf subDriveToUserChosenDestination)
                            threadDriveToDestination.Start()
                        Case "GotABot go to destination bravo"
                            ftnSendCommand("play phrase 'Destination bravo selected")
                            tmcDestination = tmcDestinationBravo
                            Dim threadDriveToDestination As New Thread(AddressOf subDriveToUserChosenDestination)
                            threadDriveToDestination.Start()
                        Case "GotABot go to destination charlie"
                            ftnSendCommand("play phrase 'Destination charlie selected")
                            tmcDestination = tmcDestinationCharlie
                            Dim threadDriveToDestination As New Thread(AddressOf subDriveToUserChosenDestination)
                            threadDriveToDestination.Start()
                        Case "GotABot go to destination delta"
                            ftnSendCommand("play phrase 'Destination delta selected")
                            tmcDestination = tmcDestinationDelta
                            Dim threadDriveToDestination As New Thread(AddressOf subDriveToUserChosenDestination)
                            threadDriveToDestination.Start()
                        Case "GotABot go to destination echo"
                            ftnSendCommand("play phrase 'Destination echo selected")
                            tmcDestination = tmcDestinationEcho
                            Dim threadDriveToDestination As New Thread(AddressOf subDriveToUserChosenDestination)
                            threadDriveToDestination.Start()
                    End Select
                End If
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in reco_SpeechRecognized " & ex.ToString)
        End Try
    End Sub


    Sub subStaus()
        Try
            ftnSendCommand("battery") ' 
            If boolBotConnected Then
                If (sngBotBatteryVoltage < 11.4) Or (sngLaptopBatteryPercent < 40) Then
                    ftnSendCommand("play phrase 'Battery level is low'")
                ElseIf (sngBotBatteryVoltage < 11.6) Or (sngLaptopBatteryPercent < 75) Then
                    ftnSendCommand("play phrase 'Battery level is OK'")
                ElseIf (sngBotBatteryVoltage < 11.9) Or (sngLaptopBatteryPercent < 90) Then
                    ftnSendCommand("play phrase 'Battery level is good'")
                Else
                    ftnSendCommand("play phrase 'Battery is full'")
                End If
                subWait(300)
                If ftnLocationsEqual(tbpBotPose.Location, tmcDock) Or boolDocked Then
                    ftnSendCommand("play phrase 'I am at my docking station'")
                ElseIf boolDock Then
                    ftnSendCommand("play phrase 'I am docking'")
                ElseIf boolDrivingToDestination Then
                    ftnSendCommand("play phrase 'I am driving to destination'")
                End If
                If ftnIAmLost(tbpBotPose) Then _
                    ftnSendCommand("play phrase 'I am lost'")
            Else
                ftnSendCommand("play phrase 'I am not connected to my hardware'")
            End If
            If boolPause Then ftnSendCommand("play phrase 'I am in pause mode'")

        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in subStaus " & ex.ToString)
        End Try
    End Sub

    Sub subWhoAmI()
        Try
            If boolEnableFaceRecognition Then
                Dim tfcFaces() As typeFaceClassifier = frmVideo.ftnGetFaceResults()
                Dim intFace As Short = 0
                While (tfcFaces(intFace).strFaceName <> "")
                    subSpeak(" I see " & tfcFaces(intFace).strFaceName)
                    intFace += 1
                End While
            End If

        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in subWhoAmI " & ex.ToString)
        End Try
    End Sub

   


End Module

