﻿
Imports System.Threading
Imports System.Drawing

Public Module modThreadControl



    '==================================== THREADS   =============================================

    Public Sub subStartThreads()
        Try
            'classNewGotAnArm = New frmGotAnArm()
            'Dim threadGotAnArm As New Thread(AddressOf classNewGotAnArm.subBackgroundMonitor)
            'threadGotAnArm.IsBackground = True
            'threadGotAnArm.Start()

            classNewBackground = New classBackground()
            Dim threadBackground As New Thread(AddressOf classNewBackground.subBackgroundMonitor)
            threadBackground.IsBackground = True
            threadBackground.Start()

            classNewAPI1Server = New classAPI1Server()
            Dim API1MainThread As New Thread(AddressOf classAPI1Server.subMain)
            API1MainThread.IsBackground = True
            API1MainThread.Start()

            classNewAPI2Server = New classAPI2Server()
            Dim API2MainThread As New Thread(AddressOf classAPI2Server.subMain)
            API2MainThread.IsBackground = True
            API2MainThread.Start()


            classNewLocalRccClient = New classLRCCClient()
            Dim LocalRccClientMainThread As New Thread(AddressOf classNewLocalRccClient.subMain)
            LocalRccClientMainThread.IsBackground = True
            LocalRccClientMainThread.Start()

            classNewGotAGlyphClient = New classGotAGlyphClient()
            Dim GotAGlyphClientMainThread As New Thread(AddressOf classNewGotAGlyphClient.subMain)
            GotAGlyphClientMainThread.IsBackground = True
            GotAGlyphClientMainThread.Start()

            classNewRoboRealmClient = New classRoboRealmClient()
            Dim RoboRealmClientMainThread As New Thread(AddressOf classNewRoboRealmClient.MainRoboRealm)
            RoboRealmClientMainThread.IsBackground = True
            RoboRealmClientMainThread.Start()

            evntCourseCorrection = New classCourseCorrection()
            Dim CourseCorrectionThreadObject As New classCourseCorrection()
            Dim CourseCorrectionMainThread As New Thread(AddressOf evntCourseCorrection.subCourseCorrection_Top)
            CourseCorrectionMainThread.IsBackground = True
            CourseCorrectionMainThread.Start()

            classNewObstacleMoving = New classObstacleMoving()
            Dim ObstacleMoving2DscanMainThread As New Thread(AddressOf classNewObstacleMoving.subPreventCollisions)
            ObstacleMoving2DscanMainThread.IsBackground = True
            ObstacleMoving2DscanMainThread.Start()


            classNewAddImageToQueue = New classAddImageToQueue()
            Dim AddImageToQueueMainThread As New Thread(AddressOf classNewAddImageToQueue.subGetMoreRecognizedImages)
            AddImageToQueueMainThread.IsBackground = True
            AddImageToQueueMainThread.Start()

        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in subStartThreads " & ex.ToString)
        End Try
    End Sub



    '==================================== GotAnArm  Thread  =============================================
    Dim WithEvents classNewGotAnArm As classArm

    '==================================== Background  Thread  =============================================
    Dim WithEvents classNewBackground As classBackground

    '==================================== API  Thread  =============================================
    Delegate Sub DelegateevntAPI()
    Dim WithEvents classNewAPI1Server As classAPI1Server

    Sub evntAPI_evntAPICommandReceived(ByVal boolAPICommandReceived As Boolean) Handles classNewAPI1Server.evntAPICommandReceived
        If boolAPICommandReceived Then APICommandReceived()
    End Sub


    Sub APICommandReceived()
        ' If InvokeRequired is true then the call is being made on a thread other
        ' than the UI thread.
        Try
            If frmGotABotTop.myMap.InvokeRequired And Not boolShutDown Then
                Dim newDelegate As New DelegateevntAPI(AddressOf APICommandReceived)
                frmGotABotTop.Invoke(newDelegate)
            ElseIf Not boolShutDown Then
                boolAPIActivity1 = True
                API1ParseAndRespond()
            End If ' GotABotClass.InvokeRequired
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in APICommandReceived " & ex.ToString)
        End Try
    End Sub


    '==================================== API2  Thread  =============================================
    Delegate Sub DelegateevntAPI2()
    Dim WithEvents classNewAPI2Server As classAPI2Server

    Sub evntAPI_evntAPI2CommandReceived(ByVal boolAPICommandReceived As Boolean) Handles classNewAPI2Server.evntAPICommandReceived
        If boolAPICommandReceived Then API2CommandReceived()
    End Sub


    Sub API2CommandReceived()
        ' If InvokeRequired is true then the call is being made on a thread other
        ' than the UI thread.
        Try
            If frmGotABotTop.InvokeRequired And Not boolShutDown Then
                Dim newDelegate As New DelegateevntAPI2(AddressOf API2CommandReceived)
                frmGotABotTop.Invoke(newDelegate)
            ElseIf Not boolShutDown Then
                boolAPIActivity2 = True
                API2ParseAndRespond()
            End If ' GotABotClass.InvokeRequired
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in API2CommandReceived " & ex.ToString)
        End Try
    End Sub


    '==================================== Local RCC Client Thread  =============================================
    Dim WithEvents classNewLocalRccClient As classLRCCClient

    '==================================== GotAGlyph Client Thread  =============================================
    Dim WithEvents classNewGotAGlyphClient As classGotAGlyphClient

    '==================================== RoboRealm Client Thread  =============================================
    Dim WithEvents classNewRoboRealmClient As classRoboRealmClient



    '==================================== Course Correction Thread  =============================================
    Dim CourseCorrectionThread As Thread   '?? 
    Delegate Sub DelegateevntCourseCorrection()
    Dim WithEvents evntCourseCorrection As classCourseCorrection



    '====================================  Obstacle Moving Thread  =============================================
    Delegate Sub DelegateevntCollisionPredicted()
    Dim WithEvents classNewObstacleMoving As classObstacleMoving

    Sub subCollisionPredictedTop() Handles classNewObstacleMoving.evntCollisionPredicted
        subCollisionPredicted()
    End Sub

    Sub subCollisionPredicted()
        Try
            If frmGotABotTop.InvokeRequired Then
                Dim newDelegate As New DelegateevntCollisionPredicted(AddressOf subCollisionPredicted)
                frmGotABotTop.Invoke(newDelegate)
            Else
                If tmiMoveInfo.boolBotIsMoving Then
                    boolCollisionPredicted = True
                    tbpBotPose = ftnLocalizeUsingDeadReckoning(tbpBotPose, -0.2, True)
                    If tmiMoveInfo.boolBotIsMoving Then tbpBotPose.OrientationUncertainty += 15
                    ftnBotStop(tbpBotPose, tbpBotPose)
                End If
            End If ' GotABotClass.InvokeRequired
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in subCollisionPredicted " & ex.ToString)
        End Try
    End Sub


    '==================================== Add Image to Queue  =============================================
    Dim WithEvents classNewAddImageToQueue As classAddImageToQueue


    '==================================== API Timeout  =============================================

    Dim boolAPIActivity1 As Boolean = True
    Dim boolAPIActivity2 As Boolean = True

    Public Sub subCheckForAPITimeout()
        Try
            If classAPI1Server.Connected And Not boolAPIActivity1 Then
                intApiUncertainty = 9999
                modIF_Api1_Server.subAPITimeout()
                frmDebug.subWriteLogs(" $$$$$$$$######################################## API 1 TIMEOUT = ")
            End If
            If classAPI2Server.Connected And Not boolAPIActivity2 Then
                intApiUncertainty = 9999
                modIF_Api2_Server.subAPITimeout()
                frmDebug.subWriteLogs(" $$$$$$$$######################################## API 2 TIMEOUT = ")
            End If
            boolAPIActivity1 = False
            boolAPIActivity2 = False
        Catch ex As Exception
            frmDebug.subWriteLogs(" EXCEPTION in subCheckForAPITimeout " & ex.ToString)
        End Try
    End Sub



End Module
